#include <iostream>
#include <fstream>
#include <sstream>
#include <FileIO/FISpirit.h>
using namespace std;
using namespace boost::spirit;
using namespace Spr;

static ofstream descImp, stubIf, stubImp;

//	ȉCC++̃NX`p[XCTypeDesc镔
//	p[Tboost::spirit𗘗p
#ifdef DEBUG
#define PDEBUG_EVAL(x)	x
#else
#define PDEBUG_EVAL(x)
#endif

static std::string type;
static std::string typeBase;
static std::string prefix;
static std::string varType;
static std::string varId;
static std::string suffix;
static std::vector<std::string> bases;
static std::vector<std::pair<std::string,std::string> > enums;
enum StructType{
	ST_UNKNOWN,
	ST_IF,
	ST_STATE,
	ST_DESC
};
static StructType structType=ST_UNKNOWN;
static bool skipFlag = false;

static void StartStatic(const char* b, const char* e){
	skipFlag = true;
}
static void StructTypeSet(const char* b, const char* e){
	structType = ST_UNKNOWN;
	skipFlag = false;

	type = UTString(b,e);
	if (type.length()>=2 && type.substr(type.length()-2).compare("If")==0){
		typeBase = type.substr(0, type.length()-2);
		structType = ST_IF;
		skipFlag = true;
	}else if (type.length()>=5 && type.substr(type.length()-5).compare("State")==0){
		typeBase = type.substr(0, type.length()-5);
		structType = ST_STATE;
	}else if(type.length()>=4 && type.substr(type.length()-4).compare("Desc")==0){
		typeBase = type.substr(0, type.length()-4);
		structType = ST_DESC;
	}
	bases.clear();

	PDEBUG_EVAL(DSTR << "struct '" << type << "' start." << std::endl);
}
static bool IsIntf(UTString& str){
	if (str.length() >= 2 && str.substr(str.length()-2) == "If") return true;
	return false;
}
static void StructStart(const char c){
	if (structType == ST_IF){
		if (bases.size()){
			stubImp << "IF_IMP(" << type.substr(0, type.length()-2) << ", " 
				<< bases.front().substr(0, bases.front().length()-2) << ");" << std::endl;
		}else{
			stubImp << "IF_IMP_BASE(" << type.substr(0, type.length()-2) << ");" << std::endl;
		}

		//	IfStub
		bool hasBase = bases.size() && IsIntf(bases.front());

		stubIf << std::endl;
		if (hasBase){
			stubIf << "template <class IF, class MIF, class OBJ> struct ";
			stubIf << bases.front() << "StubTemplate;" << std::endl;
		}
		stubIf << "template <class IF, class MIF, class OBJ>" << std::endl;
		stubIf << "struct " << type << "StubTemplate: public ";
		if (hasBase) stubIf << bases.front() << "StubTemplate<IF, MIF, OBJ> ";
		else stubIf << "IF ";
		stubIf << "{" << std::endl;
/*		stubIf << "	virtual Object* GetObject(const UTTypeInfo* info) const{" << std::endl;
		stubIf << "		if (this) {" << std::endl;
		stubIf << "			OBJ* obj = (OBJ*)(MIF*)this" << std::endl;
		stubIf << "			if (obj->GetTypeInfo()->Inherit(info)) return obj;" << std::endl;
		stubIf << "		}" << std::endl;
		stubIf << "		return NULL;" << std::endl;
		stubIf << "	}" << std::endl;
*/		return;
	}
	descImp << "\t" << std::endl;
	descImp << "\t" << type << "* p" << type << " = NULL;" << std::endl;
	bool isDesc = false;
	descImp << "\tdesc = DBG_NEW UTTypeDesc(\"" << type << "\");" << std::endl;
	descImp << "\tdesc->size = sizeof(" << type << ");" << std::endl;
	//	IfInfo̐ݒ
	if (structType == ST_DESC){
		//	Ώۂ̍\̂IfDescȂ̂ŁCIfInfoǉ
		std::string ifType = type.substr(0, type.length()-4) + "If";
		descImp << "\tdesc->ifInfo = " << ifType << "::GetIfInfoStatic();" << std::endl;
		descImp << "\t((IfInfo*)" << ifType << "::GetIfInfoStatic())->desc = desc;" << std::endl;
	}
	//	IuWFNgփANZX邽߂̃NX
	descImp << "\tdesc->access = DBG_NEW UTAccess<" << type << ">;" << std::endl;

	//	{NXoƂĒǉD
	for(size_t i=0; i<bases.size(); ++i){
		descImp << "\tfield = desc->AddBase(\"" << bases[i] << "\");" << std::endl;
		descImp << "\tfield->offset = int((char*)("<< bases[i]<< "*)p"<< type 
			<<	" - (char*)p" << type << ");" << std::endl;
	}
}

static void StructEnd(const char c){
	if (structType == ST_IF){
		stubIf << "};" << std::endl;
		stubIf << "struct " << type << ";\tclass " << typeBase << ";" << std::endl;
		stubIf << "typedef " << type << "StubTemplate<";
		stubIf << type << ", ObjectIfBuf, " << typeBase << ">\t" << type << "Stub;" << std::endl;

		stubIf << "typedef IfInitTemplate<" 
			<< type << "Stub, " << typeBase << ">\t" << type << "Init;" << std::endl;
	}
	if (skipFlag) return;
	descImp << "\t" << "db->RegisterDesc(desc);" << std::endl;
}
static void VarTypeSet(const char* s, const char* e){
	if (skipFlag) return;
	varType = std::string(s,e);

	PDEBUG_EVAL( DSTR << " t:" << varType; )
};
static void VarId(const char* s, const char* e){
	if (skipFlag) return;
	varId = std::string(s,e);
}
static void VarEnd(char ch){
	if (skipFlag){
		if (structType != ST_IF) skipFlag = false;
		return;
	}
	descImp << "\tfield = desc->AddField(\"" 
		<< prefix << "\", \"" 
		<< varType << "\", \"" 
		<< varId << "\", \"" 
		<< suffix << "\");" << std::endl;
	descImp << "\tfield->offset = int((char*)&(p" << type << "->" << varId 
		<< ") - (char*)p" << type << ");" << std::endl;
	if (ch == ';') varType=varId=prefix=suffix="";
};
static void VectorSet(const char*, const char*){
	if (skipFlag) return;
	prefix = "vector";
	PDEBUG_EVAL( DSTR << " v"; )
};
static void UTRefSet(const char*, const char*){
	if (skipFlag) return;
	prefix = "UTRef";
	PDEBUG_EVAL( DSTR << " r"; )
};
static void SuffixSet(int l){
	if (skipFlag) return;
	std::ostringstream os;
	os << l;
	suffix = os.str();
	PDEBUG_EVAL( DSTR << " [" << l << "]"; )
};
static void VSuffixSet(const char* s, const char* e){
	if (skipFlag) return;
	suffix.assign(s,e);
	PDEBUG_EVAL( DSTR << " [" << suffix << "]"; )
};

static void AddBaseId(const char* b, const char* e){
	bases.push_back(std::string(b,e));
}
static void EnumType(const char* b, const char* e){
	if (skipFlag) return;
	varType.assign(b,e);
}
static void EnumAddConst(const char* b, const char* e){
	if (skipFlag) return;
	enums.push_back(make_pair(std::string(b,e),""));
}
static void EnumAddValue(const char* b, const char* e){
	if (skipFlag) return;
	enums.back().second.assign(b,e);
}
static void EnumId(const char* b, const char* e){
	if (skipFlag) return;
	varId.assign(b,e);
	descImp << "\tfield = desc->AddField(\"" << varType << "\", \"enum\", \""
		<< varId << "\",  \"\");" << std::endl;
	for(size_t i=0; i<enums.size(); ++i){
		descImp << "\tfield->AddEnumConst(\"" << 	enums[i].first << "\"";
		if (enums[i].second.length()) descImp << ", " << enums[i].second;
		descImp << ");" << std::endl;
	}
	descImp << "\tfield->offset = int((char*)(&p" << type << "->" << varId 
		<< ") - (char*)p" << type << ");" << std::endl;

	enums.clear();
}
static void PointerSet(const char c){
	if (skipFlag) return;
	prefix = "pointer";
}
static void test(const char* b, const char* e){
	DSTR << "test:";
	DSTR.write(b, (int)(e-b));
	DSTR << std::endl;
}


struct TFuncArg{
	std::vector<UTString> types;	//	^ or id
	UTString defaultValue;	//	ftHgl(int a =10 Ȃ)
};
static struct TFuncInfo{
	std::vector<TFuncArg> args;
	bool isConst;
	bool isPure;
	TFuncInfo():isConst(false), isPure(false){
		args.push_back(TFuncArg());
	}
	void Clear(){
		*this = TFuncInfo();
	}
}funcInfo;

static void FuncType(const char* b, const char* e){
	PDEBUG_EVAL(DSTR << "FuncType:");
	PDEBUG_EVAL(DSTR.write(b, (int)(e-b)));
	PDEBUG_EVAL(DSTR << std::endl);

	UTString str(b, e);
	funcInfo.args.back().types.push_back(str);
}
static void FuncConst(const char* b, const char* e){
	funcInfo.isConst = true;
}
static void FuncPure(const char* b, const char* e){
	funcInfo.isPure = true;
}
static void FuncExp(const char* b, const char* e){
	UTString str(b, e);
	funcInfo.args.back().defaultValue = str;
}
static void NewArg(const char c){
	funcInfo.args.push_back(TFuncArg());
}
static void FuncDef(const char* b, const char* e){
	/*
	DSTR << "FuncDef:";
	for(unsigned i=0; i<funcInfo.args.size(); ++i){
		for(unsigned j=0; j<funcInfo.args[i].types.size(); ++j){
			DSTR << funcInfo.args[i].types[j] << " ";
		}
		if (funcInfo.args[i].defaultValue.length()) 
			DSTR << "= "<< funcInfo.args[i].defaultValue;
		DSTR << std::endl;
	}
	*/
	if (structType != ST_IF) return;
	if (funcInfo.args[0].types[0]!="virtual") return;
	if (funcInfo.args[0].types.size()>1 && funcInfo.args[0].types[1]=="~") return;
	//	֐
	stubIf << "\t";
	unsigned i = 0;
	for(unsigned j=0; j<funcInfo.args[i].types.size(); ++j){
		stubIf << (j?" ":"") << funcInfo.args[i].types[j];
	}
	//	
	stubIf << "(";
	for(i=1; i<funcInfo.args.size(); ++i){
		for(unsigned j=0; j<funcInfo.args[i].types.size(); ++j){
			stubIf << (j?" ":"") << funcInfo.args[i].types[j];
		}
		if (funcInfo.args[i].defaultValue.length()){
			stubIf << " = "<< funcInfo.args[i].defaultValue;
		}
		if (i<funcInfo.args.size()-1){
			stubIf << ", ";
		}
	}
	stubIf << ")";
	if (funcInfo.isConst) stubIf << " const ";
	stubIf << "{" << std::endl;
//	stubIf << "\t\treturn ((OBJ*)(MIF*)this)->OBJ::" << funcInfo.args[0].types.back() << "(";
//	OBJ::ƁCpure virtualNG[ɂȂDȂƁC炭virtualQƂxD
	stubIf << "\t\treturn ((OBJ*)(MIF*)this)->" << funcInfo.args[0].types.back() << "(";

	for(i=1; i<funcInfo.args.size(); ++i){
		if (funcInfo.args[i].types.size())
			stubIf << funcInfo.args[i].types.back();
		if (i<funcInfo.args.size()-1){
			stubIf << ", ";
		}
	}
	stubIf << ");" << std::endl;
	stubIf << "\t}" << std::endl;
}

static void FieldEnd(const char* b, const char* e){
	funcInfo.Clear();
}


int _cdecl main(int argc, const char* argv[]){
	if (argc < 2) return -1;
	ifstream file(argv[1]);
	if(argc>2) descImp.open(argv[2], std::ios::app|std::ios::out);
	if(argc>3) stubIf.open(argv[3], std::ios::app|std::ios::out);
	if(argc>4) stubImp.open(argv[4], std::ios::app|std::ios::out);
	
	ostringstream os;
	while(file.good() && !file.eof()){
		char ch = file.get();
		os.put(ch);
	}

	//	p[T̒`
	//	{pp[T
	FIPhraseParser src, stId, stBlk, accessDef, enumDef, funcDef, varDef, structDef,
		funcType, funcArgs, funcArg, tmplArg, arg, block, baseIni, enumF, field, 
		ctype, type, typePf, id, suffix, exp;
	src		=	*((stId >> stBlk) | anychar_p);
	stId	=	str_p("struct") >> id[&StructTypeSet];
	stBlk	=	ch_p(';') | (
				!( ch_p(':') >> !(str_p("public")|"private") >> id[&AddBaseId] >>
				* (ch_p(',') >> !(str_p("public")|"private") >> id[&AddBaseId]) ) >>
				ch_p('{')[&StructStart] >> *(field) >> ch_p('}')[&StructEnd] );
	field	=	(accessDef | enumDef | structDef | funcDef[&FuncDef] | varDef)[&FieldEnd] | ';';

	accessDef =	(str_p("public")|"protected"|"private")  >> ch_p(':');
	enumDef	=	str_p("enum") >> !id[&EnumType] >> 
				'{' >> *(enumF>>',')>>!enumF >> '}' >> !id[&EnumId] >> ';';
	enumF	=	id [&EnumAddConst] >> !(ch_p('=') >> (*(~ch_p(',')-'}'))[&EnumAddValue]);

	funcDef	=	+ funcType[&FuncType] >> funcArgs >> !str_p("const")[&FuncConst] >> !chseq_p("=0")[&FuncPure]
				>> ( ch_p(';') | (!baseIni>>block) );
	funcType =	ch_p('*') | '&' | '~' | (id >> *(str_p("::")>>id)) | tmplArg;
	tmplArg	=	ch_p('<') >> *(tmplArg | ~ch_p('>') ) >> '>';
	funcArgs =	ch_p('(')[&NewArg] >> !(funcArg >> *(ch_p(',')[&NewArg] >> funcArg)) >> ch_p(')');
	funcArg	=	+ funcType[&FuncType] >> !(ch_p('=') >> exp[&FuncExp]);

	structDef =	str_p("struct") >> id >> block >> str_p(";");
	baseIni	=	ch_p(':') >> +(id >> arg >> !ch_p(','));
	arg		=	ch_p('(') >> *(arg		| ~ch_p(')') ) >> ')';
	block	=	ch_p('{') >> *(block	| ~ch_p('}') ) >> '}';

	varDef	=	ctype >> id[&VarId] >> !suffix >> 
				*(ch_p(',')[&VarEnd] >> id[&VarId] >> !suffix) >> ch_p(';')[&VarEnd];

	ctype	=	(  (+( str_p("static") | str_p("const") ))[&StartStatic] | eps_p  ) >>
				( !str_p("std::") >> str_p("vector")[&VectorSet] >> '<' >> type >> '>' | type );
	type	=	(str_p("UTRef")[&UTRefSet] >> '<' >> typePf >> '>' )
				| (typePf >> !ch_p('*')[&PointerSet]);
	typePf	=	(str_p("std::") >> id[&VarTypeSet]) 
				| str_p("unsigned") >> str_p("char")[&VarTypeSet] 
				| str_p("unsigned") >> str_p("short")[&VarTypeSet] 
				| str_p("unsigned") >> str_p("int")[&VarTypeSet] 
				| str_p("unsigned") >> str_p("long")[&VarTypeSet] 
				| id[&VarTypeSet];
	id		=	lexeme_d[(alpha_p | '_') >> *(alnum_p|'_')];
	suffix	=	'[' >> !int_p[&SuffixSet] >> ']' | str_p("VSIZE") >> '(' >> id[&VSuffixSet] >> ')';
	exp		=	+(ch_p('(') >> *(exp | ~ch_p(')') ) >> ')'  |  (anychar_p-')'-','));
	//	XLbvp[T(Xy[XƃRgǂݏop[T)̒`
	FISkipParser cmt;
	cmt		=	space_p
				|	"/*" >> *(~ch_p('*') | '*'>>~ch_p('/')) >> !ch_p('*') >> '/'
				|	"//" >> *~ch_p('\n') >> '\n';

	//	p[X
	parse_info<> info = parse(os.str().c_str(), src, cmt);
	return 0;
}
