/*
 *  Copyright (c) 2003-2006, Shoichi Hasegawa and Springhead development team 
 *  All rights reserved.
 *  This software is free software. You can freely use, distribute and modify this 
 *  software. Please deal with this software under one of the following licenses: 
 *  This license itself, Boost Software License, The MIT License, The BSD License.   
 */
#ifndef SPR_CDSHAPEIF_H
#define SPR_CDSHAPEIF_H
#include <Foundation/SprObject.h>

namespace Spr{;

/**	\defgroup	gpShape	`EڐGNX	*/	
//@{
/**	@file SprCDShape.h
	̂̌`
 */	

/*	memo
	shapeɊKw\邩ǂD
	Novodex ODEƂ Kw\͎ĂȂD
	Kw𓮂Ƃɂ́CdS [gȂ΂ȂȂ̂ŁC
	ȂɎgȂƂfƎvD
	ȂƂCV~[VɊKwœ͍̂ƎvD

	Ȃ̂ŁCKw͎ȂƂjōD

	Solid ͕ Shape ƂłD
	Shape ͊Kw\͎ȂD

	Kw\͕CuƂ͕ʂɁCV[OtCu
*/

///	`̊{NX
struct CDShapeIf : public NamedObjectIf{
	IF_DEF(CDShape);
};

///	ʌ`̊{NX
struct CDConvexIf : public CDShapeIf{
	IF_DEF(CDConvex);
};

/**		*/
struct CDFaceIf{
	virtual int NIndex()=0;
	virtual int* GetIndices()=0;
protected:
	virtual ~CDFaceIf() {};
};


///	V~[VɊ֌Wގ
struct PHMaterial{
	PHMaterial(){
		mu = mu0 = e = 0.2f;
	}
	float mu;				///< CCW
	float mu0;				///< Î~CW
	float e;				///< ˕ԂW
};

///	`̃fBXNv^({NX)
struct CDShapeDesc{
	PHMaterial material;	///<	ގ
};


/**	ʌ`̃bV*/
struct CDConvexMeshIf: public CDConvexIf{
	IF_DEF(CDConvexMesh);
	virtual CDFaceIf* GetFace(size_t i)=0;
	virtual size_t NFace()=0;
	virtual Vec3f* GetVertices()=0;
	virtual size_t NVertex()=0;
};
/**	ʌ`̃bṼfBXNv^	*/	
struct CDConvexMeshDesc: public CDShapeDesc{
	DESC_DEF_FOR_OBJECT(CDConvexMesh);
	CDConvexMeshDesc():CDShapeDesc(){}
	std::vector<Vec3f> vertices;	///<	_̍W
};
	
/** ́@*/
struct CDSphereIf: public CDConvexIf{
	IF_DEF(CDSphere);
	virtual float GetRadius()=0;
};	
/** ̂̃fBXNv^@*/
struct CDSphereDesc: public CDShapeDesc{
	DESC_DEF_FOR_OBJECT(CDSphere);
	CDSphereDesc():CDShapeDesc(){
		radius = 1.0f;
	}
	float radius;					// ̂̔a
};	

/** JvZ@*/
struct CDCapsuleIf: public CDConvexIf{
	IF_DEF(CDCapsule);
	virtual float GetRadius()=0;
	virtual float GetLength()=0;
};	
/** JvZ̃fBXNv^@*/
struct CDCapsuleDesc: public CDShapeDesc{
	DESC_DEF_FOR_OBJECT(CDCapsule);
	CDCapsuleDesc():CDShapeDesc(){
		radius = 1.0f;
		length = 1.0f;
	}
	float radius;					///< JvZ̋̔a
	float length;					///< JvZ̒ Z
};	

	
/**  */
struct CDBoxIf: public CDConvexIf{
	IF_DEF(CDBox);
	virtual Vec3f GetBoxSize()=0;
	virtual Vec3f* GetVertices()=0;
	virtual CDFaceIf* GetFace(size_t i)=0;
};
/** ̂̃fBXNv^ */
struct CDBoxDesc: public CDShapeDesc{
	DESC_DEF_FOR_OBJECT(CDBox);
	CDBoxDesc():CDShapeDesc(){
		boxsize = Vec3f(1.0f, 1.0f, 1.0f);
	}
	Vec3f boxsize;					// ̂̃TCYieӂ̒j
};	


//@}

}

#endif
