/*
 *  Copyright (c) 2003-2006, Shoichi Hasegawa and Springhead development team 
 *  All rights reserved.
 *  This software is free software. You can freely use, distribute and modify this 
 *  software. Please deal with this software under one of the following licenses: 
 *  This license itself, Boost Software License, The MIT License, The BSD License.   
 */
/**
 *	@file SprGRFrame.h
 *	@brief V[Ot̃m[h
*/

/**	\addtogroup	gpGraphics	*/
//@{

#ifndef SPR_GRFrame_H
#define SPR_GRFrame_H
#include <SprFoundation.h>

namespace Spr{;

struct GRRenderIf;

/** @brief rWÃfBXNv^ */
struct GRVisualDesc{
	enum VisualType{
		FRAME,
		MESH,
		MATERIAL,
		CAMERA,
		LIGHT
	} type;
};

/**	@brief	OtBbNXŕ\ɉe^	*/
struct GRVisualIf: public NamedObjectIf{
	IF_DEF(GRVisual);
	///	_ODqm[hCm[h̃_OOɌĂ΂D
	virtual void Render(GRRenderIf* r)=0;
	///	_OIDqm[hCm[h̃_OIĂĂ΂D
	virtual void Rendered(GRRenderIf* r)=0;
};
		
///	DirectX  Frame ̕ϊ\ FrameTransformMatrix m[hǂނ߂Desc
struct GRFrameTransformMatrix{
	Affinef transform;
};

///	@brief GRFrame DescDWnw肷
struct GRFrameDesc : GRVisualDesc{
	Affinef transform;
	GRFrameDesc(){ type = FRAME; }
};
	
/**	@brief	OtBbNXV[Ot̃c[̃m[hDWnD*/
struct GRFrameIf: public GRVisualIf{
	IF_DEF(GRFrame);

	/** @brief et[擾 */
	virtual GRFrameIf* GetParent()=0;

	/** @brief et[ݒ肷 */
	virtual void SetParent(GRFrameIf* fr)=0;

	/** @brief qm[h̐擾 */
	virtual int NChildren() = 0;

	/** @brief qm[h̔z擾 */
	virtual GRVisualIf** GetChildren() = 0;

	/** @brief em[hƂ̑Εϊ擾 */
	virtual Affinef GetTransform()=0;

	/** @brief [ht[Ƃ̑Εϊ擾 */
	virtual Affinef GetWorldTransform()=0;

	/** @brief em[hƂ̑Εϊݒ */
	virtual void SetTransform(const Affinef& af)=0;

	virtual void Print(std::ostream& os) const =0;
};

//@}
}
#endif
