/*
 *  Copyright (c) 2003-2006, Shoichi Hasegawa and Springhead development team 
 *  All rights reserved.
 *  This software is free software. You can freely use, distribute and modify this 
 *  software. Please deal with this software under one of the following licenses: 
 *  This license itself, Boost Software License, The MIT License, The BSD License.   
 */
/**
 *	@file SprGRMesh.h
 *	@brief bV
*/

/**	\addtogroup	gpGraphics	*/
//@{

#ifndef SPR_GRMesh_H
#define SPR_GRMesh_H

#include <Graphics/SprGRFrame.h>

namespace Spr{;

///	@brief \pMesh(GRMesh)̃fXNv^D
struct GRMeshDesc : GRVisualDesc{
	std::vector<Vec3f> positions;				///< _̍W
	std::vector<Vec3f> normals;					///< _̖@
	std::vector<Vec4f> colors;					///< _̐F
	std::vector<Vec2f> texCoords;				///< eNX`UV
	std::vector<size_t> faces;					///< ʂ\钸_CfbNXilp`͎Op`ɕj
	GRMeshDesc(){ type = MESH; }
};


/**	@brief	OtBbNXŎg\pMesh */
struct GRMeshIf: public GRVisualIf{
	IF_DEF(GRMesh);
};


//@}
}
#endif
