/*
 *  Copyright (c) 2003-2006, Shoichi Hasegawa and Springhead development team 
 *  All rights reserved.
 *  This software is free software. You can freely use, distribute and modify this 
 *  software. Please deal with this software under one of the following licenses: 
 *  This license itself, Boost Software License, The MIT License, The BSD License.   
 */
/**
 *	@file SprGRScene.h
 *	@brief V[Ot
*/

/**	\addtogroup	gpGraphics	*/
//@{

#ifndef SPR_GRScene_H
#define SPR_GRScene_H

#include <Graphics/SprGRFrame.h>
#include <Graphics/SprGRRender.h>

namespace Spr{;

///	@brief GRScene DescDgD
struct GRSceneDesc{
};

struct GRSdkIf;
/**	@brief	OtBbNXV[Ot */
struct GRSceneIf: public SceneIf{
	IF_DEF(GRScene);

	///	V[̃_O
	virtual void Render(GRRenderIf* r)=0;

	///	[ht[̎擾
	virtual GRFrameIf* GetWorld()=0;

	///	J̎擾
	virtual GRCameraIf* GetCamera()=0;

	/// J̍쐬Eݒ
	virtual void SetCamera(const GRCameraDesc& desc)=0;

	/** @brief rWA̍쐬
		@param desc rWÃfXNv^
		@param parent et[
		t[AbVA}eAA邢̓Cg쐬Đet[parent̉ɒǉB
		parentNULL̏ꍇ̓[ht[eƂȂB
	 */
	virtual GRVisualIf*  CreateVisual(const GRVisualDesc& desc, GRFrameIf* parent = NULL)=0;

	/** @brief SceneSDKԂ
		@return SDK̃C^tF[X
	*/	
	virtual GRSdkIf* GetSdk()=0;
};


//@}
}
#endif
