/*
 *  Copyright (c) 2003-2006, Shoichi Hasegawa and Springhead development team 
 *  All rights reserved.
 *  This software is free software. You can freely use, distribute and modify this 
 *  software. Please deal with this software under one of the following licenses: 
 *  This license itself, Boost Software License, The MIT License, The BSD License.   
 */

/**
 *	@file SprGRSdk.h
 *	@brief OtBbNXSDK̊{NX
 */
#ifndef SPR_GRSDK_H
#define SPR_GRSDK_H

namespace Spr{;

/**	\defgroup gpGraphics	OtBbNXSDK	*/
//@{
struct GRDeviceGLIf;
struct GRDebugRenderIf;
struct GRSceneIf;
struct GRSceneDesc;

///	@brief GRSdkDesc GRSDK̐ݒDDirectXgOpenGLg̑IȂǂɓ\D
struct GRSdkDesc{
};

/**	@brief	OtBbNXSDK̊{NX@ */
struct GRSdkIf: public SdkIf{
	IF_DEF(GRSdk);
	virtual GRDebugRenderIf* CreateDebugRender()=0;
	virtual GRDeviceGLIf* CreateDeviceGL()=0;
	virtual GRSceneIf* CreateScene(const GRSceneDesc& desc)=0;
	virtual GRSceneIf* GetScene(size_t i)=0;
	virtual size_t NScene()=0;
	virtual void MergeScene(GRSceneIf* scene0, GRSceneIf* scene1)=0;
	static GRSdkIf* SPR_CDECL CreateSdk();
	static void SPR_CDECL RegisterSdk();
};
//@}
}
#endif
