/*
 *  Copyright (c) 2003-2006, Shoichi Hasegawa and Springhead development team 
 *  All rights reserved.
 *  This software is free software. You can freely use, distribute and modify this 
 *  software. Please deal with this software under one of the following licenses: 
 *  This license itself, Boost Software License, The MIT License, The BSD License.   
 */
/**
 *	@file SprHIBase.h
 *	@brief q[}C^tF[X̊{NX
*/


#ifndef SPR_HIBase_H
#define SPR_HIBase_H
#include <HumanInterface/SprHIDevice.h>

namespace Spr{;

/**	\addtogroup	gpHumanInterface	*/
//@{

struct DRRealDeviceIf;

/**	@brief	q[}C^tF[X̊{NX	*/
struct HIBaseIf: public NamedObjectIf{
	IF_DEF(HIBase);
	///	Lu[V̑Oɍs
	virtual bool BeforeCalibration()=0;
	///	Lu[V
	virtual bool Calibration()=0;
	///	Lu[V̂Ƃɍs
	virtual bool AfterCalibration()=0;
	///	q[}C^tF[Ẍˑ֌Wǉ
	virtual void AddDeviceDependency(HIRealDeviceIf* rd)=0;
	///	q[}C^tF[Ẍˑ֌WNA
	virtual void ClearDeviceDependency()=0;
	///	q[}C^tF[X̏ԂXVD
	virtual void Update(float dt)=0;
	///	q[}C^tF[Xgp\Ȃ trueD
	virtual bool IsGood()=0;
	/**	q[}C^tF[X̏D
		KvȃfoCXsdk؂ĂāCq[}C^tF[X\	*/
	virtual bool Init(HISdkIf* sdk, const void* desc)=0;
};

/**	@brief	ʒu̓C^tF[X	*/
struct HIPositionIf: public HIBaseIf{
	IF_DEF(HIPosition);
	virtual Vec3f GetPosition()=0;
};

/**	@brief	px̓C^tF[X	*/
struct HIOrientationIf: public HIBaseIf{
	IF_DEF(HIOrientation);
	virtual Quaternionf GetOrientation()=0;
};

/**	@brief	p(=ʒu{px)̓C^tF[X	*/
struct HIPoseIf: public HIPositionIf{
	IF_DEF(HIPose);
	virtual Quaternionf GetOrientation()=0;
	virtual Posef GetPose()=0;
};

//@}
}
#endif
