/*
 *  Copyright (c) 2003-2006, Shoichi Hasegawa and Springhead development team 
 *  All rights reserved.
 *  This software is free software. You can freely use, distribute and modify this 
 *  software. Please deal with this software under one of the following licenses: 
 *  This license itself, Boost Software License, The MIT License, The BSD License.   
 */
/**
 *	@file SprPHSdk.h
 *	@brief V~[VSDK
*/
#ifndef SPR_PHSDKIF_H
#define SPR_PHSDKIF_H
#include <Collision/SprCDShape.h>

namespace Spr{;

/** \addtogroup gpPhysics */
//@{

struct PHSceneIf;
struct PHSceneDesc;

//	[ĥ߂̒gȂ̃fXNv^
struct PHSdkDesc{
};

///	V~[VSDK
struct PHSdkIf : public SdkIf{
	IF_DEF(PHSdk);
	//	API
	///	Scene̍쐬
	virtual PHSceneIf* CreateScene()=0;
	///	Scene̍쐬
	virtual PHSceneIf* CreateScene(const PHSceneDesc& desc)=0;
	///	Scene̐擾
	virtual int NScene()=0;
	///	Scene̎擾
	virtual PHSceneIf* GetScene(size_t i)=0;
	/// Scenẽ}[W
	virtual void MergeScene(PHSceneIf* scene0, PHSceneIf* scene1)=0;
	/** @brief Shape쐬
		@param desc 쐬ShapẽfBXNv^
		@return ShapẽC^tF[X
	 */
	virtual CDShapeIf* CreateShape(const IfInfo* ii, const CDShapeDesc& desc)=0;
	template <class T> CDShapeIf* CreateShape(const T& desc){
		return CreateShape(T::GetIfInfo(), desc);
	}
	
	
	///	Shape̐
	virtual int NShape()=0;

	///	Shape̎擾
	virtual CDShapeIf* GetShape(int i)=0;

	//	SDKAo^֐
	///	PHSdk̃CX^X쐬
	static PHSdkIf* SPR_CDECL CreateSdk();
	///	PHSdkt@C[_[Ȃǂɓo^
	static void SPR_CDECL RegisterSdk();
};

//@}

}	//	namespace Spr
#endif
