/*
 *  Copyright (c) 2003-2006, Shoichi Hasegawa and Springhead development team 
 *  All rights reserved.
 *  This software is free software. You can freely use, distribute and modify this 
 *  software. Please deal with this software under one of the following licenses: 
 *  This license itself, Boost Software License, The MIT License, The BSD License.   
 */
#ifndef BASETYPEINFO_H
#define BASETYPEINFO_H
#include "BaseUtility.h"
/**	@file BaseTypeInfo.h
	s^ev[gCu.
	RpCrttig킸}Nƃev[gŎĂD
*/
namespace Spr{;

///	s^
class UTTypeInfo: public UTRefCount{
public:
	const char* className;
	UTTypeInfo** base;

	UTTypeInfo(const char* cn, UTTypeInfo** b): className(cn), base(b){}
	virtual bool Inherit(const UTTypeInfo* key) const ;
	virtual bool Inherit(const char* str) const ;
	virtual const char* ClassName() const = 0;
	virtual void* CreateInstance() const = 0;
	virtual ~UTTypeInfo() {};
};

///	s^NX̎
template <class T>
class UTTypeInfoImp: public UTTypeInfo{
public:
	UTTypeInfoImp(const char* cn, UTTypeInfo** b): UTTypeInfo(cn, b){}
	virtual void* CreateInstance() const { return new T; }
	virtual const char* ClassName() const { return className; }
};

///	s^NX̎DۃNX
template <class T>
class UTTypeInfoImpAbst: public UTTypeInfo{
public:
	UTTypeInfoImpAbst(const char* cn, UTTypeInfo** b): UTTypeInfo(cn, b){}
	virtual void* CreateInstance() const { return 0; }
	virtual const char* ClassName() const { return className; }
};

///	s^NX̊{NX
class UTTypeInfoObjectBase{
public:
	virtual const UTTypeInfo* GetTypeInfo() const =0;
protected:
	virtual ~UTTypeInfoObjectBase() {};
};

//----------------------------------------------------------------------
//	NX̐錾(wb_)ɏ
///	s^NXׂo̐錾
#define DEF_UTTYPEINFODEF(cls)							\
public:													\
	static UTTypeInfoImp<cls> typeInfo;					\
	virtual const UTTypeInfo* GetTypeInfo() const {		\
		return &typeInfo;								\
	}													\
	static const UTTypeInfo* GetTypeInfoStatic(){		\
		return &typeInfo;								\
	}													\

///	s^NXׂo̐錾DۃNX
#define DEF_UTTYPEINFOABSTDEF(cls)						\
public:													\
	static UTTypeInfoImpAbst<cls> typeInfo;				\
	virtual const UTTypeInfo* GetTypeInfo() const {		\
		return &typeInfo;								\
	}													\
	static const UTTypeInfo* GetTypeInfoStatic(){		\
		return &typeInfo;								\
	}													\


///	s^NXׂo̎D
#define DEF_UTTYPEINFO(cls)									\
	UTTypeInfo* cls##_BASE[] = {NULL};						\
	UTTypeInfoImp<cls> cls::typeInfo = UTTypeInfoImp<cls>(#cls, cls##_BASE);

///	s^NXׂo̎D1̃NXpꍇ
#define DEF_UTTYPEINFO1(cls, base1)							\
	UTTypeInfo* cls##_BASE[] = {&base1::typeInfo, NULL};	\
	UTTypeInfoImp<cls> cls::typeInfo = UTTypeInfoImp<cls>(#cls, cls##_BASE);

///	s^NXׂo̎D2̃NXpꍇ
#define DEF_UTTYPEINFO2(cls, base1, base2)									\
	UTTypeInfo* cls##_BASE[] = {&base1::typeInfo, &base2::typeInfo, NULL};	\
	UTTypeInfoImp<cls> cls::typeInfo = UTTypeInfoImp<cls>(#cls, cls##_BASE);

///	s^NXׂo̎D3̃NXpꍇ
#define DEF_UTTYPEINFO3(cls, base1, base2, base3)												\
	UTTypeInfo* cls##_BASE[] = {&base1::typeInfo, &base2::typeInfo, &base3::typeInfo, NULL};	\
	UTTypeInfoImp<cls> cls::typeInfo = UTTypeInfoImp<cls>(#cls, cls##_BASE);

///	s^NXׂo̎DۃNX
#define DEF_UTTYPEINFOABST(cls)								\
	UTTypeInfo* cls##_BASE[] = {NULL};						\
	UTTypeInfoImpAbst<cls> cls::typeInfo = UTTypeInfoImpAbst<cls>(#cls, cls##_BASE);

///	s^NXׂo̎DۃNXŁD1̃NXpꍇ
#define DEF_UTTYPEINFOABST1(cls, base)						\
	UTTypeInfo* cls##_BASE[] = {&base::typeInfo,NULL};		\
	UTTypeInfoImpAbst<cls> cls::typeInfo = UTTypeInfoImpAbst<cls>(#cls, cls##_BASE);

///	s^NXׂo̎DۃNXŁD2̃NXpꍇ
#define DEF_UTTYPEINFOABST2(cls, base1, base2)									\
	UTTypeInfo* cls##_BASE[] = {&base1::typeInfo, &base2::typeInfo, NULL};		\
	UTTypeInfoImpAbst<cls> cls::typeInfo = UTTypeInfoImpAbst<cls>(#cls, cls##_BASE);

///	s^NXׂo̎DۃNXŁD2̃NXpꍇ
#define DEF_UTTYPEINFOABST3(cls, base)															\
	UTTypeInfo* cls##_BASE[] = {&base1::typeInfo, &base2::typeInfo, &base3::typeInfo, NULL};	\
	UTTypeInfoImpAbst<cls> cls::typeInfo = UTTypeInfoImpAbst<cls>(#cls, cls##_BASE);

#define GETCLASSNAME(p)		(p->GetTypeInfo()->className)
#define GETCLASSNAMES(T)	(T::GetTypeInfoStatic()->className)

///	_Ci~bNLXg
#define DCAST(T, p)	UTDcastImp<T>(p)
template <class T, class P> T* UTDcastImp(P p){
	if (p && p->GetTypeInfo()->Inherit(T::GetTypeInfoStatic())) return (T*)&*(p);
	return NULL;
}

///	LXgɎsassert_Ci~bNLXg
#define ACAST(T, p)	UTAcastImp<T>(p)
template <class T, class P> T* UTAcastImp(P p){
	if (p && p->GetTypeInfo()->Inherit(T::GetTypeInfoStatic())) return (T*)&*(p);
	UTAcastError((p)->GetTypeInfo()->className);
	return NULL;
}
///	_Ci~bNLXgD^Ƀ|C^^go[W
#define DCASTP(TP, p)	UTDcastpImp<TP>(p)
template <class TP, class P> TP UTDcastpImp(P p){
	TP tp=NULL;
	if (p && p->GetTypeInfo()->Inherit(tp->GetTypeInfoStatic())) return (TP)&*(p);
	return NULL;
}
///	LXgɎsassert_Ci~bNLXgD^Ƀ|C^^go[W
#define ACASTP(TP, p)	UTAcastpImp<TP>(p)
template <class TP, class P> TP UTAcastpImp(P p){
	TP tp=NULL;
	if (p && p->GetTypeInfo()->Inherit(tp->GetTypeInfoStatic())) return (TP)&*(p);
	UTAcastError((p)->GetTypeInfo()->className);
	return NULL;
}
///	LXgɎsꍇassert֐
char* UTAcastError(const char* );

}
#endif
