/*
 *  Copyright (c) 2003-2006, Shoichi Hasegawa and Springhead development team 
 *  All rights reserved.
 *  This software is free software. You can freely use, distribute and modify this 
 *  software. Please deal with this software under one of the following licenses: 
 *  This license itself, Boost Software License, The MIT License, The BSD License.   
 */
#ifndef BASE_COMBINATION_H
#define BASE_COMBINATION_H

/**	@file Combination.h gݍ킹z̒`*/
namespace Spr {;

/**	gݍ킹ziւsC4p`ɂȂj*/
template <class T>
class UTCombination:public std::vector<T>{
	int height_;
	int width_;
public:
	typedef std::vector<T> base_type;
	UTCombination(){ height_ = 0; width_ = 0; }
	
	///	TCY̕ύX
	/// [0, min(height(), hnew))sC[0, min(width(), wnew)̗vf͕ۑ
	/// VłvfɂT()
	void resize(int hnew, int wnew){
		if (hnew * wnew > height_ * width_){	//	傫ȂȂCɃTCY
			base_type::resize(hnew * wnew);
		}
		typename base_type::iterator b = this->begin();
		int hmin = min(hnew, height_);
		int r, c;
		if (wnew > width_){	//	ꍇC납ړ
			for(r = hmin-1; r >= 0; --r){
				for(c = wnew-1; c >= width_; --c)
					b[wnew * r + c] = T();
				for(; c >= 0; --c)
					b[wnew * r + c] = b[width_ * r + c];
			}
		}
		else if (wnew < width_){	//	ꍇCOړ
			for(r = 1; r < hmin; ++r){
				for(c = 0; c < wnew; ++c)
					b[wnew * r + c] = b[width_ * r + c];
			}
		}
		if (hnew * wnew < height_ * width_)	// ȂȂŌɃTCY
			base_type::resize(hnew * wnew);

		height_ = hnew;
		width_ = wnew;
	}
	/// rԖڂ̍s폜C[r+1, height())Ԗڂ̍s1ɋl߂
	void erase_row(int row){
		assert(0 <= row && row < height_);
		if(row != height_ - 1){
			int r, c;
			for(r = row+1; r < height_; r++)
				for(c = 0; c < width_; c++)
					item(r, c) = item(r-1, c);
		}
		height_--;
		base_type::resize(height_ * width_);
	}
	/// cԖڂ̗폜C[c+1, width())Ԗڂ̗1ɋl߂
	void erase_col(int col){
		assert(0 <= col && col < width_);
		if(col != width_ - 1){
			int r, c;
			for(c = col+1; c < width_; c++)
				for(r = 0; r < height_; r++)
					item(r, c) = item(r, c-1);
		}
		width_--;
		base_type::resize(height_ * width_);
	}
	int height() const { return height_; };
	int width() const { return width_; };
	T& item(int i, int j){
		assert(i < height());
		assert(j < width());
		return this->begin()[i*width() + j];
	}
	void clear(){
		base_type::clear();
		height_ = 0;
		width_ = 0;
	}
	const T& item(int i, int j) const { return ((UTCombination<T>*)this)->item(i,j); }
};

}

#endif
