/*
 *  Copyright (c) 2003-2006, Shoichi Hasegawa and Springhead development team 
 *  All rights reserved.
 *  This software is free software. You can freely use, distribute and modify this 
 *  software. Please deal with this software under one of the following licenses: 
 *  This license itself, Boost Software License, The MIT License, The BSD License.   
 */
#ifndef PTMATRIX_TVECTOR_H
#define PTMATRIX_TVECTOR_H

/**	\defgroup gpLinearAlgebra xNgEsEWϊ	*/
//@{
/**	@file TVector.h
	ev[gɂNxNg̒`.
	vf̌^ƃTCYev[g̈ɂ邱ƂŁC
	ǗɎɁCʂ̍sD
	zLXgăxNgɂ邱ƂłD*/
#include <algorithm>
#include <iostream>
#include <math.h>
#include <assert.h>
#include <stddef.h>
#include <vector>
#ifdef _MSC_VER
 #define for if(0); else for
 #pragma warning (disable: 4786)
 #pragma warning (disable: 4200)
#endif

#ifdef __BORLANDC__
 #pragma warn -8027
#endif


namespace PTM {;

#ifdef _WIN32
 #pragma pack(push, 4)
 
 #ifdef _DEBUG
  #pragma optimize ("awgity", on)
 #endif
 #pragma inline_recursion(on)
 #pragma inline_depth(255)
#endif

#if defined _MSC_VER && _MSC_VER < 1300
/*	VisualC++̃ev[g΍D
	VC͂ǂCev[gɓ^̈𕡐ƁCSŏ
	̒lƂ炵Dł́Csize_t 2ȏnƂłȂD
	ŁCTCYnɂȂNXāC sizeof ŃTCYoƂ
	 size_t œn悤ɂD*/
 template <size_t N> class TVectorDim{
	char dim[N];
 };
 #define DIMTYPE		class
 #define DIMENC(n)		PTM::TVectorDim<((n)+1)>
 #define DIMDEC(T)		((sizeof(T)-1))
 #define DIMDEF(T, t)	typedef T t
 #define TYPENAME

#else
 //	̃RpCɂ͂ȕςȖ͂Ȃ悤
 #define DIMTYPE size_t
 #define DIMENC(n) (n)
 #define DIMDEC(n) (n)
 #define DIMDEF(T, t) static const size_t t = T
 #define TYPENAME typename
#endif

template <size_t N>
class TVecDim{
public:
	DIMDEF(DIMENC(N), SIZE);
	DIMDEF(DIMENC(N), STRIDE);
};

template <size_t STR, class EXP, class RET, class E, class Z=E>
class TVectorDesc{
public:
	DIMDEF(DIMENC(STR), STRIDE);	///<	stride
	typedef EXP		exp_type;		///<	
	typedef RET		ret_type;		///<	Ԃľ^
	typedef E		element_type;	///<	vf̌^
	typedef Z		zero;			///<	zero(0)  vf̌^0Ԃ^
};
template <class EXP, class RET, class E, class Z=E>
class VectorDesc{
public:
	typedef EXP		exp_type;		///<	
	typedef RET		ret_type;		///<	Ԃľ^
	typedef E		element_type;	///<	vf̌^
	typedef Z		zero;			///<	zero(0)  vf̌^0Ԃ^
};

///@name Z.
//@{
template <class D> class VectorImp;
template <DIMTYPE N, class D> class TVectorBase;
/**	xNg̗vfSvɂ.
	@param v vf^̒l.	*/
template <class D>
void clear(VectorImp<D>& a, const TYPENAME D::element_type v= D::zero(0)){
	for(size_t i=0; i<a.size(); ++i) a.item(i) = v;
}
/**	(a = b).
	@param b TCỸxNg.	*/
template <class AD, class BD>
void assign(VectorImp<AD>& a, const VectorImp<BD>& b) {
	a.resize(b.size());
	assert(a.size() == b.size());
	for(size_t i=0; i<a.size(); ++i) a.item(i) = b.item(i);
}
///	(a = b) 2vfp
template <class AD, class BD>
void assign(TVectorBase<DIMENC(2), AD>& a, const TVectorBase<DIMENC(2), BD>& b) {
	assert(a.size() == b.size());
	a.item(0) = b.item(0);
	a.item(1) = b.item(1);
}
///	(a = b) 3vfp
template <class AD, class BD>
void assign(TVectorBase<DIMENC(3), AD>& a, const TVectorBase<DIMENC(3), BD>& b) {
	assert(a.size() == b.size());
        typedef TYPENAME AD::element_type ET;
	a.item(0) = ET(b.item(0));
	a.item(1) = ET(b.item(1));
	a.item(2) = ET(b.item(2));
}
///	(a = b) 4vfp
template <class AD, class BD>
void assign(TVectorBase<DIMENC(4), AD>& a, const TVectorBase<DIMENC(4), BD>& b) {
	assert(a.size() == b.size());
	a.item(0) = (TYPENAME AD::element_type)b.item(0);
	a.item(1) = (TYPENAME AD::element_type)b.item(1);
	a.item(2) = (TYPENAME AD::element_type)b.item(2);
	a.item(3) = (TYPENAME AD::element_type)b.item(3);
}
/**	(*this = b).
	@param b TCỸxNg.	*/
template <class AD>
void assign(VectorImp<AD>& a, const TYPENAME AD::element_type* b) {
	for(size_t i=0; i<a.size(); ++i) a.item(i) = b[i];
}
/**	Z(*this += b).
	@param b TCỸxNg.	*/
template <class AD, class BD>
void add(VectorImp<AD>& a, const VectorImp<BD>& b){
	assert(b.size() ==a. size());
	for(size_t i=0; i<a.size(); ++i) a.item(i) += (TYPENAME AD::element_type) b.item(i);
}
/**	Z(*this -= b).
	@param b TCỸxNg.	*/
template <class AD, class BD>
void sub(VectorImp<AD>& a, const VectorImp<BD>& b){
	assert(b.size() == a.size());
	for(size_t i=0; i<a.size(); ++i) a.item(i) -= (TYPENAME AD::element_type) b.item(i);
}
/**	萔{(*this *= b).
	@param b vf^.				*/
template <class AD>
void multi(VectorImp<AD>& a, const TYPENAME AD::element_type& b){
	for(size_t i=0; i<a.size(); ++i) a.item(i) *= b;
}
/**	萔{(*this *= b).
	@param b vf^.				*/
template <class AD, class BD>
void multi_each(VectorImp<AD>& a, const VectorImp<BD>& b){
	for(size_t i=0; i<a.size(); ++i) a.item(i) *= b.item(i);
}
/**	萔̂P(*this /= b).
	@param b vf^.				*/
template <class AD>
void div(VectorImp<AD>& a, const TYPENAME AD::element_type& b){
	for(size_t i=0; i<a.size(); ++i) a.item(i) /= b;
}
/**	(return *this * b).
	@param	b	TCỸxNg.
	@return		ς̒l(vf^)	*/
template <class AD, class BD>
TYPENAME AD::element_type dot(const VectorImp<AD>& a, const VectorImp<BD>& b){
	assert(b.size() == a.size());
	typedef TYPENAME AD::zero zero;
	TYPENAME AD::element_type rv = zero(0);
	for(size_t i=0; i<a.size(); ++i) rv += a.item(i)*b.item(i);
	return rv;
}
template <class AD, class BD>
TYPENAME AD::element_type dot(const TVectorBase<DIMENC(3), AD>& a, const TVectorBase<DIMENC(3), BD>& b){
        typedef TYPENAME AD::element_type ET;
	return ET(a.item(0)*b.item(0) + a.item(1)*b.item(1) + a.item(2)*b.item(2));
}
/**	r(return *this == b).
	@param	b	TCỸxNg.
	@return		booll.	*/
template <class AD, class BD>
bool equal(const VectorImp<AD>& a, const VectorImp<BD>& b){
	if (b.size() != a.size()) return false;
	for(size_t i=0; i<a.size(); ++i){
		if (a.item(i) != b.item(i)) return false;
	}
	return true;
}

/**	vfƂ̍ŏl(min(*this, b)).
	@param b TCỸxNg.	*/
template <class AD, class BD>
void element_min_impl(VectorImp<AD>& a, const VectorImp<BD>& b){
	assert(b.size() == a.size());
	for(size_t i=0; i<a.size(); ++i) a.item(i) = std::min(a.item(i), b.item(i));
}
template <class AD, class BD>
TYPENAME AD::ret_type element_min(const VectorImp<AD>& a, const VectorImp<BD>& b){
	TYPENAME AD::ret_type r(a);
	element_min_impl(r, b);
	return r;
}
/**	vfƂ̍ől(max(*this, b)).
	@param b TCỸxNg.	*/
template <class AD, class BD>
void element_max_impl(VectorImp<AD>& a, const VectorImp<BD>& b){
	assert(b.size() == a.size());
	for(size_t i=0; i<a.size(); ++i) a.item(i) = std::max(a.item(i), b.item(i));
}
template <class AD, class BD>
TYPENAME AD::ret_type element_max(const VectorImp<AD>& a, const VectorImp<BD>& b){
	TYPENAME AD::ret_type r(a);
	element_max_impl(r, b);
	return r;
}
///	NbsO(be𒸓_Ƃ`Ɏ܂悤ɂ).
template <class AD, class BD, class ED>
void clip(const VectorImp<AD>& a, const VectorImp<BD>& b, const VectorImp<ED>& e){
	for(size_t i=0; i<a.size(); ++i){
		if (a.item(i) < b.item(i)) a.item(i) = b.item(i);
		if (a.item(i) > e.item(i)) a.item(i) = e.item(i);
	}
}
//@}


template<size_t SZ, size_t STR, class OD> class TVectorSlice;
template<size_t SZ, class OD> class TSubVector;
template<class D> class EVectorSlice;
template<class D> class EVectorRange;
///	xNg̉ZȂǂ̎
template <class D>
class VectorImp{
public:
	typedef D desc;
	typedef TYPENAME desc::exp_type exp_type;
	typedef TYPENAME desc::ret_type ret_type;
	typedef TYPENAME desc::element_type element_type;
	typedef TYPENAME desc::zero zero;
	///	RXgN^
	VectorImp(){}

	///@name {.
	//@{
	///	̂̎擾
	exp_type& exp(){ return *(exp_type*)this; }
	const exp_type& exp() const { return *(const exp_type*)this; }
	///	nԖڂ̗vfԂ(0).
	element_type& item(size_t n){ return exp().item_impl(n); }
	const element_type& item(size_t n) const { return exp().item_impl(n); }
	///	TCY̎擾
	size_t size() const { return exp().size_impl(); }
	///	TCY̐ݒ
	void resize(size_t sz){ exp().resize_impl(sz); }
	///	XgCh̎擾
	size_t stride(){ return exp().stride_impl(); }
	//@}
	
	///@name xNg
	//@{
	/**	XCXԂDev[g
		̃xNgSZ::OFFSETvf SZ::OFFSET + SZ::SIZEvf܂ł
		xNgւ̎QƂԂD
		@param	SZ::OFFSET	xNg̍ŏ̗vf̈ʒu.
		@param	SZ::SIZE	xNg̃TCY.
		@return	SZ Ŏw肳ꂽxNgւ̎QƂԂ.	*/
	template <class SZ> TVectorSlice<DIMDEC(SZ::SIZE), DIMDEC(SZ::STRIDE), desc>&
	t_slice(SZ){ return (TVectorSlice<DIMDEC(SZ::SIZE), DIMDEC(SZ::STRIDE), desc>&)item(DIMDEC(SZ::OFFSET)); }
	template <class SZ>	const TVectorSlice<DIMDEC(SZ::SIZE), DIMDEC(SZ::STRIDE), desc>&
	t_slice(SZ) const { return (TVectorSlice<DIMDEC(SZ::SIZE), DIMDEC(SZ::STRIDE), desc>&)item(DIMDEC(SZ::OFFSET)); }
	///	xNgԂDev[g
	template <class SZ> TSubVector<DIMDEC(SZ::SIZE), desc>&
	sub_vector(SZ){ return (TSubVector<DIMDEC(SZ::SIZE), desc>&)item(DIMDEC(SZ::OFFSET)); }
	template <class SZ>	const TSubVector<DIMDEC(SZ::SIZE), desc>&
	sub_vector(SZ) const { return (TSubVector<DIMDEC(SZ::SIZE), desc>&)item(DIMDEC(SZ::OFFSET)); }
	/**	XCXԂDTCYev[g
		̃xNg off vf off + SZ::SIZEvf܂ł
		xNgւ̎QƂԂD
		@param	SZ::OFFSET	xNg̍ŏ̗vf̈ʒu.
		@param	SZ::SIZE	xNg̃TCY.
		@return	SZ Ŏw肳ꂽxNgւ̎QƂԂ.	*/
	template <class SZ> TVectorSlice<DIMDEC(SZ::SIZE), DIMDEC(SZ::STRIDE), desc>&
	t_slice(size_t off, SZ){ return (TVectorSlice<DIMDEC(SZ::SIZE), DIMDEC(SZ::STRIDE), desc>&)item(off); }
	template <class SZ>	const TVectorSlice<DIMDEC(SZ::SIZE), DIMDEC(SZ::STRIDE), desc>&
	t_slice(size_t off, SZ) const { return (TVectorSlice<DIMDEC(SZ::SIZE), DIMDEC(SZ::STRIDE), desc>&)item(off); }
	///	xNgԂDTCYev[g
	template <class SZ> TSubVector<DIMDEC(SZ::SIZE), desc>&
	sub_vector(size_t off, SZ){ return (TSubVector<DIMDEC(SZ::SIZE), desc>&)item(off); }
	template <class SZ>	const TSubVector<DIMDEC(SZ::SIZE), desc>&
	sub_vector(size_t off, SZ) const { return (TSubVector<DIMDEC(SZ::SIZE), desc>&)item(off); }
	
	///	xNgԂDϐ
	EVectorSlice<element_type> v_range(size_t off, size_t sz){
		return EVectorSlice<element_type>(sz, stride(), &item(off));
	}
	EVectorSlice<element_type> v_range(size_t off, size_t sz) const {
		return EVectorSlice<element_type>(sz, stride(), &item(off));
	}
	///	xNg̃XCXԂD
	EVectorSlice<element_type> v_slice(size_t off, size_t sz, size_t str){
		return EVectorSlice<element_type>(sz, stride()*str, &item(off));
	}
	EVectorSlice<element_type> v_slice(size_t off, size_t sz, size_t str) const {
		return EVectorSlice<element_type>(sz, stride()*str, &item(off));
	}
	//@}
	
	///@name Z.
	//@{
	/**	xNg̗vfSvɂ.
		@param v vf^̒l.	*/
	void clear(const element_type v=zero(0)){ PTM::clear(exp(), v);	}
	/**	(*this = b).
		@param b TCỸxNg.	*/
	template <class B>
		void assign(const VectorImp<B>& b) { PTM::assign(exp(), b.exp()); }
	/**	(*this = b).
		@param b TCỸxNg.	*/
	void assign(const element_type* b) { PTM::assign(exp(), b); }
	/**	Z(*this += b).
		@param b TCỸxNg.	*/
	template <class B>
		void add(const VectorImp<B>& b){ PTM::add(exp(), b.exp()); }
	/**	Z(*this -= b).
		@param b TCỸxNg.	*/
	template <class B>
		void sub(const VectorImp<B>& b){ PTM::sub(exp(), b.exp()); }
	/**	萔{(*this *= b).
		@param b vf^.				*/
	void multi(const element_type& b){ PTM::multi(exp(), b); }
	/**	萔̂P(*this /= b).
		@param b vf^.				*/
	void div(const element_type& b){ PTM::div(exp(), b); }
	/**	(return *this * b).
		@param	b	TCỸxNg.
		@return		ς̒l(vf^)	*/
	template <class B>
		element_type dot(const VectorImp<B>& b) const { return PTM::dot(exp(), b.exp()); }
	/**	r(return *this == b).
		@param	b	TCỸxNg.
		@return		booll.	*/
	template <class B>
		bool equal(const VectorImp<B>& b) const { return PTM::equal(exp(), b.exp()); }

	/**	vfƂ̍ŏl(min(*this, b)).
		@param b TCỸxNg.	*/
	template <class B>
		void element_min(const VectorImp<B>& b){ element_min_impl(exp(), b.exp()); }
	/**	vfƂ̍ől(max(*this, b)).
		@param b TCỸxNg.	*/
	template <class B>
		void element_max(const VectorImp<B>& b){ element_max_impl(exp(), b.exp()); }
	///	xNg̃m(傫)2Ԃ.
	element_type square() const { return PTM::dot(exp(),exp()); }
	///	xNg̃m(傫)Ԃ.
	element_type norm() const { return element_type( sqrt(square()) ); }
	///	PʃxNgɂD
	void unitize(){ div(norm()); }
	///	NbsO(be𒸓_Ƃ`Ɏ܂悤ɂ).
	template <class BD, class ED>
		void clip(const VectorImp<BD>& b, const VectorImp<ED>& e){ clip(exp(), b.exp(), e.exp()); }
	//@}

	///@name o
	//@{
	/**	\.
		@param os o͐Xg[	*/
	void print(std::ostream& os, char* sep="( )") const {
		if (sep[0]) os << sep[0];
		if (size()){ os.width(6); os << item(0); }
		for(size_t i=1; i<size(); ++i){
			if (sep[1]) os << sep[1];
			os.width(6); os << item(i);
		}
		if (sep[2]) os << sep[2];
	}
	/**	\.
		@param is ͌Xg[	*/
	template <class T>
	void input(T& is) {
		is >> std::ws;
		if (is.peek() != '('){
			is.setstate(std::ios::badbit);
			return;
		}
		is.get();
		std::vector<element_type> v;
		while(1){
			v.push_back(element_type());
			is >> v.back();
			if (!is.good()) break;
			if (size()<v.size()) resize(v.size());
			if (size()<v.size()) break;
		}
		v.pop_back();
		for(unsigned i=0; i<v.size(); ++i){
			item(i) = v[i];
		}
		is.clear();
		is >> std::ws;
		if (is.peek() == ')'){
            is.get();
			return;
		}
		is.setstate(std::ios::badbit);
	}
	//@}

	///@name Zq
	//@{
	///	[] Zq(0).
	template <class I> element_type& operator[] (I n) { return item(n); }
	///	[] Zq(0) (const ).
	template <class I> const element_type& operator[] (I n) const { return item(n); }
	///	element_type * ւ̕ϊ
	operator element_type* (){ return &item(0); }
	operator const element_type* () const { return &item(0); }
	/**	xNg̃XJ[{(return this * b).
		@param	b	vf^
		@return	thisƓxNg^	*/
	ret_type operator * (element_type b) const { ret_type rv(*this); rv.multi(b); return rv; }
	/**	xNg̃XJ[̂P(return this / b).
		@param	b	vf^
		@return	thisƓxNg^	*/
	ret_type operator / (element_type b) const { ret_type rv(*this); rv.div(b); return rv; }
	/**	+= Zq(*this = *this + b).
		@param b TCYxNg^.	*/
	template <class BD>
	ret_type operator+= (const VectorImp<BD>& b) { add(b); return *this; }
	/**	-= Zq(*this = *this - b)
		@param b TCYxNg^.	*/
	template <class BD>
	ret_type operator-= (const VectorImp<BD>& b) { sub(b); return *this; }
	/**	*= Zq (*this = *this * b)
		@param b vf^.	*/
	template <class T> ret_type operator*= (T b) { multi(element_type(b)); return *this; }
	/**	/= Zq (*this = 1/b * *this).
		@param b vf^.	*/
	template <class T> ret_type operator/= (T b) { div(element_type(b)); return *this; }
	/**	- Zq (return -*this).	*/
	ret_type operator- () const { ret_type r(*this); r*=element_type(-1); return r; }
	///	PʃxNgԂD
	ret_type unit() const { ret_type r(*this); r.unitize(); return r; }
	//@}
protected:
	///	obt@̏DȂD
	void init_buffer(){}
	///	ftHgRXgN^
	void set_default(){}
};

///	ev[gŎxNg̊{^
template<DIMTYPE N, class D>
class TVectorBase: public VectorImp<D> {
protected:
	TVectorBase(){}
public:
	DIMDEF(N, SIZE);
	size_t size_impl() const { return DIMDEC(N); }
	void resize_impl(size_t sz) { assert(sz==DIMDEC(N)); }
};


/**	xNg^hNXɕKvȃo̒`.
	hNX邽тɁC̃}Ngăo.
	ftHgRXgN^C TCỸxNgɂ
	EȂǂ`D
	@param	THIS	Vɐ錾hNX̌^.
	@see	TVector	*/
#define DEF_VECTOR_BASIC_MEMBER(THIS)										\
	typedef THIS this_type;			/*  ̃NX̌^`Ă. */	\
	typedef TYPENAME desc::element_type element_type;						\
	typedef TYPENAME desc::ret_type ret_type;								\
	/*	Rs[RXgN^	*/											\
	THIS& operator =(const THIS& b){										\
		assign(b); return *this;											\
	}																		\
	/*  xNg b 	*/												\
	template <class D>														\
	THIS& operator =(const PTM::VectorImp<D>& b){							\
		this->exp().assign(b); return *this;										\
	}																		\
	/*  xNg b Z	*/												\
	template <class D>														\
	THIS& operator +=(const PTM::VectorImp<D>& b){							\
		this->exp().add(b); return *this;											\
	}																		\
	/*  xNg b Z	*/												\
	template <class D>														\
	THIS& operator -=(const PTM::VectorImp<D>& b){							\
		this->exp().sub(b); return *this;											\
	}																		\
	/*  vfz p ̑	*/										\
	THIS& operator =(const element_type* p){								\
		this->exp().assign(p);											\
		return *this;														\
	}																		\

#define DEF_TVECTOR_BASIC_MEMBER(THIS)										\
	DEF_VECTOR_BASIC_MEMBER(THIS)											\
	/*  xNg b ɂ鏉		*/										\
	template <class D>														\
	THIS(const PTM::VectorImp<D>& b){										\
		this->init_buffer(); this->assign(b);}								\
	/*  vfz p ɂ鏉	*/								\
	THIS(const element_type* p){											\
		assign(p);															\
	}																		\
	/*	ftHgRXgN^	*/										\
	THIS(){ this->init_buffer(); this->set_default(); }			\

//----------------------------------------------------------------------------
/**	xNg^쐬̂߂̃[eBeB[NX.
	TVecDim<> ŕxNg^擾łB	*/
template <const size_t SOFF, const size_t SDIM>
class TSubVectorDim{
public:
	DIMDEF(DIMENC(SOFF),	OFFSET);
	DIMDEF(DIMENC(SDIM),	SIZE);
	DIMDEF(DIMENC(1),		STRIDE);
};
//----------------------------------------------------------------------------
/**	xNg^. TVector<3, float> v; ̂悤Ɏg
	@param	N	vf.
	@param	T	vf̌^.
	@see		TVector^̉Zq
*/
template <size_t N, class T>
class TVector:public TVectorBase<DIMENC(N), TVectorDesc<1, TVector<N,T>, TVector<N,T>, T> >{
public:
	DIMDEF(DIMENC(1), STRIDE);
	typedef TVectorDesc<1, TVector<N,T>, TVector<N,T>, T> desc;	///<	^
	typedef TVectorBase<DIMENC(N),desc> base_type;				///<	{NX^
	/**	pȂ{Iȃo̒`.
		@see ::DEF_TVECTOR_BASIC_MEMBER	*/
	DEF_TVECTOR_BASIC_MEMBER(TVector);
private:
	element_type data[N];										///<	f[^
public:	
	///	vf̃ANZX
	T& item_impl(size_t i){ return data[i]; }
	///	vf̃ANZX
	const T& item_impl(size_t i) const { return data[i]; }
	///	XgCh
	size_t stride_impl() const { return 1; }
};

template<size_t SZ, size_t STR, class OD>
class TVectorSlice: public TVectorBase<DIMENC(SZ),
	TVectorDesc< STR*DIMDEC(OD::STRIDE), 
		TVectorSlice<SZ, STR, OD>, TVector<SZ, TYPENAME OD::element_type>, TYPENAME OD::element_type, TYPENAME OD::zero> > {
public:
	DIMDEF(DIMENC(SZ), SIZE);
	DIMDEF(DIMENC(STR), STRIDE);
	typedef void array_type;
	typedef void const_array_type;
	typedef TVectorDesc< STR*DIMDEC(OD::STRIDE), TVectorSlice<SZ, STR, OD>, TVector<SZ, TYPENAME OD::element_type>, TYPENAME OD::element_type, TYPENAME OD::zero> desc;
	typedef TVectorBase<DIMENC(SZ), desc> base_type;
	///	pȂ{Iȃo̒`  @see ::DEF_VECTOR_BASIC_MEMBER
	DEF_VECTOR_BASIC_MEMBER(TVectorSlice);
	///	vf̃ANZX
	element_type& item_impl(size_t i){ return data[i][0]; }
	const element_type& item_impl(size_t i) const { return data[i][0]; }
	///	XgCh
	size_t stride_impl() const { return DIMDEC(STRIDE); }
protected:
	element_type data[DIMDEC(SIZE)][DIMDEC(STRIDE)];
};


template<size_t SZ, class OD>
class TSubVector: public TVectorBase<DIMENC(SZ),
	TVectorDesc< DIMDEC(OD::STRIDE), TSubVector<SZ, OD>, TVector<SZ, TYPENAME OD::element_type>, TYPENAME OD::element_type, TYPENAME OD::zero> > {
public:
	DIMDEF(DIMENC(SZ), SIZE);
	DIMDEF(OD::STRIDE, STRIDE);
	typedef void array_type;
	typedef void const_array_type;
	typedef TVectorDesc< DIMDEC(OD::STRIDE), TSubVector<SZ, OD>, TVector<SZ, TYPENAME OD::element_type>, TYPENAME OD::element_type, TYPENAME OD::zero> desc;
	typedef TVectorBase<DIMENC(SZ), desc> base_type;
	///	pȂ{Iȃo̒`  @see ::DEF_VECTOR_BASIC_MEMBER
	DEF_VECTOR_BASIC_MEMBER(TSubVector);
	///	vf̃ANZX
	element_type& item_impl(size_t i){ return data[i][0]; }
	const element_type& item_impl(size_t i) const { return data[i][0]; }
	///	XgCh
	size_t stride_impl() const { return DIMDEC(STRIDE); }
protected:
	element_type data[DIMDEC(SIZE)][DIMDEC(STRIDE)];
};

//----------------------------------------------------------------------------

/**	xNg^. VVector<float> v; ̂悤Ɏg
	@param	T	vf̌^.
	@see		TVector^̉Zq
*/
template <class T>
class VVector:public VectorImp<TVectorDesc<1, VVector<T>,VVector<T>,T> >{
public:
	typedef TVectorDesc<1,VVector<T>,VVector<T>,T> desc;
	typedef VectorImp<desc> base_type;
	/**	pȂ{Iȃo̒`.
		@see ::DEF_VECTOR_BASIC_MEMBER	*/
	DEF_VECTOR_BASIC_MEMBER(VVector);
	///	{^̒`
	typedef element_type* array_type;
	typedef const element_type* const_array_type;
private:
	///	̎
	array_type data;
	///
	size_t size_;
public:
	///	ftHgRXgN^
	VVector(){
		init_buffer();
		this->set_default();
	}
	///	Rs[RXgN^
	VVector(const VVector& s){
		init_buffer();
		resize(s.size_);
		memcpy(data, s.data, sizeof(element_type) * size_);
	}
	template <class D>
	VVector(const VectorImp<D>& b){
		init_buffer();
		assign(b);
	}
	///	
	~VVector(){
    	delete [] data;
    }
	///	xNg̃TCY.
	size_t size_impl() const { return size_; }
	///	xNg̃TCY̐ݒ
	void resize_impl(size_t s){
		if (s > size_){
			delete data;
			data = new element_type[s];
		}
		size_ = s;
	}
	///	XgCh
	size_t stride_impl() const { return 1; }
	///	vf̃ANZX
	T& item_impl(size_t i){ return data[i]; }
	///	vf̃ANZX
	const T& item_impl(size_t i) const { return data[i]; }
protected:
	void init_buffer(){data=0; size_=0;}
};

/**	xNg^. EVector<float> v; ̂悤Ɏg
	@param	T	vf̌^.
	@see		Vector^̉Zq
*/
template <class T>
class ConstEVector:public VectorImp< TVectorDesc<1, ConstEVector<T>, VVector<T>,T,T> >{
public:
	typedef TVectorDesc<1, ConstEVector<T>,VVector<T>,T,T> desc;
	typedef VectorImp<desc> base_type;
	/**	pȂ{Iȃo̒`.
		@see ::DEF_VECTOR_BASIC_MEMBER	*/
	DEF_VECTOR_BASIC_MEMBER(ConstEVector);
	typedef const element_type* array_type;
private:
	///	̎
	array_type data;
	///
	size_t size_;
public:
	///
	ConstEVector(array_type v, size_t sz):data(v), size_(sz){}
	//
	ConstEVector(size_t sz, size_t str, array_type v):data(v), size_(sz){ assert(str==1);}
	///	xNg̃TCY.
	size_t size_impl() const { return size_; }
	///	xNg̃TCY̐ݒ
	void resize_impl(size_t s){
		assert(size_ == s);
	}
	///	vf̃ANZX
	const T& item_impl(size_t i) const { return data[i]; }
	///	XgCh
	size_t stride_impl() const { return 1; }
};
template <class T>
class EVector:public VectorImp< TVectorDesc<1, EVector<T>, VVector<T>,T,T> >{
public:
	typedef ConstEVector<T> const_type;
	typedef TVectorDesc<1, EVector<T>,VVector<T>,T,T> desc;
	typedef VectorImp<desc> base_type;
	/**	pȂ{Iȃo̒`.
		@see ::DEF_VECTOR_BASIC_MEMBER	*/
	DEF_VECTOR_BASIC_MEMBER(EVector);
	typedef element_type* array_type;
private:
	///	̎
	array_type data;
	///
	size_t size_;
public:
	///
	EVector(size_t sz, array_type v):data(v), size_(sz){}
	EVector(size_t sz, size_t str, array_type v):data(v), size_(sz){ assert(str==1); }
	///	xNg̃TCY.
	size_t size_impl() const { return size_; }
	///	xNg̃TCY̐ݒ
	void resize_impl(size_t s){
		assert(size_ == s);
	}
	///	vf̃ANZX
	const T& item_impl(size_t i) const { return data[i]; }
	T& item_impl(size_t i) { return data[i]; }
	///	XgCh
	size_t stride_impl() const { return 1; }
};
template<class T>
class ConstEVectorSlice: public VectorImp< VectorDesc<ConstEVectorSlice<T>, VVector<T>, T> >{
public:
	typedef void array_type;
	typedef void const_array_type;
	typedef VectorDesc<EVectorSlice<T>, VVector<T>, T> desc;
	typedef VectorImp<desc> base_type;
	///	pȂ{Iȃo̒`.	@see ::DEF_VECTOR_BASIC_MEMBER
	DEF_VECTOR_BASIC_MEMBER(ConstEVectorSlice);
	///
	ConstEVectorSlice(size_t sz, size_t str, const T* d):data(d), size_(sz), stride_(str){}
	///
	ConstEVectorSlice(const ConstEVectorSlice& v):data(v.data), size_(v.size_), stride_(v.stride_){}
	///	vf̃ANZX
	element_type& item_impl(size_t i){ return data[index(i)]; }
	///	vf̃ANZX
	const element_type& item_impl(size_t i) const { return data[index(i)]; }
	///	TCY
	size_t size_impl() const { return size_; }
	///	TCY̐ݒ
	void resize_impl(size_t sz) { size_ = sz; }
	///	XgCh
	size_t stride_impl() const { return stride_; }
protected:
	const element_type* data;
	size_t size_;
	size_t stride_;
	///	̍sւ̃ANZX
	size_t index(size_t i) const { return i*stride_; }
};
template<class T>
class EVectorSlice: public VectorImp< VectorDesc<EVectorSlice<T>, VVector<T>, T> >{
public:
	typedef ConstEVectorSlice<T> const_type;
	typedef void array_type;
	typedef void const_array_type;
	typedef VectorDesc<EVectorSlice<T>, VVector<T>, T> desc;
	typedef VectorImp<desc> base_type;
	///	pȂ{Iȃo̒`.	@see ::DEF_VECTOR_BASIC_MEMBER
	DEF_VECTOR_BASIC_MEMBER(EVectorSlice);
	///
	EVectorSlice(size_t sz, size_t str, T* d):data(d), size_(sz), stride_(str){}
	///
	EVectorSlice(const EVectorSlice& v):data(v.data), size_(v.size_), stride_(v.stride_){}
	///	vf̃ANZX
	element_type& item_impl(size_t i){ return data[index(i)]; }
	///	vf̃ANZX
	const element_type& item_impl(size_t i) const { return data[index(i)]; }
	///	TCY
	size_t size_impl() const { return size_; }
	///	TCY̐ݒ
	void resize_impl(size_t sz) { size_ = sz; }
	///	XgCh
	size_t stride_impl() const { return stride_; }
protected:
	element_type* data;
	size_t size_;
	size_t stride_;
	///	̍sւ̃ANZX
	size_t index(size_t i) const { return i*stride_; }
};

//----------------------------------------------------------------------------
//	O[o֐EZq

/**	xNg̘a(return a + b).
	@param	a	xNg^
	@param	b	aƓ̃xNg^
	@return		aƓTVector^	*/
template <class AD, class BD>
TYPENAME AD::ret_type operator + (const VectorImp<AD>& a, const VectorImp<BD>& b) {
	TYPENAME AD::ret_type rv(a);
	rv.add(b);
	return rv;
}
/**	xNg̍(return a - b).
	@param	a	xNg^
	@param	b	aƓ̃xNg^
	@return		aƓ̃xNg^	*/
template <class AD, class BD>
TYPENAME AD::ret_type operator - (const VectorImp<AD>& a, const VectorImp<BD>& b) {
	TYPENAME AD::ret_type rv(a);
	rv.sub(b);
	return rv;
}
/**	XJ[ƃxNg̐(return a * b).
	@param	a	xNg^
	@param	b	vf^
	@return		xNg^	*/
template <class BD>
typename BD::ret_type operator * (const TYPENAME BD::element_type& a, const VectorImp<BD>& b) {
	TYPENAME BD::ret_type r(b);
	r.multi(a);
	return r;
}

/**	xNg̓(return a * b).
	@param	a	xNg^
	@param	b	aƓ̃xNg^
	@return		vf^	*/
template <class AD, class BD>
typename AD::element_type operator * (const VectorImp<AD>& a, const VectorImp<BD>& b) {
	return a.dot(b);
}

/**	r(return a == b).
	@param	a	xNg^
	@param	b	vf^aƓ̃xNg^
	@return		bool	*/
template <class AD, class BD>
bool operator == (const VectorImp<AD>& a, const VectorImp<BD>& b) { return a.equal(b); }
/**	r(return a != b).
	@param	a	xNg^
	@param	b	vf^aƓ̃xNg^
	@return		bool	*/
template <class AD, class BD>
bool operator != (const VectorImp<AD>& a, const VectorImp<BD>& b) { return !a.equal(b); }

///	Xg[ɏtŏo͂.
template <class BD>
std::ostream& operator << (std::ostream& os, const VectorImp<BD>& v){
	v.print(os);
	return os;
}
///	Xg[珑tœ͂.
template <class BD>
std::istream& operator >> (std::istream& is, VectorImp<BD>& v){
	v.input(is);
	return is;
}
/**	2xNg̊O(return a x b).
	@param	a	2xNg^
	@param	b	2xNg^
	@return		vf^	*/
template <class	AD, class BD>
typename AD::element_type cross (const TVectorBase<DIMENC(2), AD>& a, const TVectorBase<DIMENC(2), BD>& b) {
	return a[0] * b[1] - a[1] * b[0];
}
template <class	AD, class BD>
typename AD::element_type operator % (const TVectorBase<DIMENC(2), AD>& a, const TVectorBase<DIMENC(2), BD>& b) {
	return cross(a, b);
}
template <class	AD, class BD>
typename AD::element_type operator ^ (const TVectorBase<DIMENC(2), AD>& a, const TVectorBase<DIMENC(2), BD>& b) {
	return cross(a, b);
}

/**	3xNg̊O(return a x b).
	@param	a	3xNg^
	@param	b	3xNg^
	@return		3xNg^	*/
template <class	AD, class BD>
TYPENAME AD::ret_type cross (const TVectorBase<DIMENC(3), AD>& a, const TVectorBase<DIMENC(3), BD>& b) {
	TYPENAME AD::ret_type r;
	typedef TYPENAME AD::element_type ADET;
	r[0] = ADET(a[1] * b[2] - a[2] * b[1]);
	r[1] = ADET(a[2] * b[0] - a[0] * b[2]);
	r[2] = ADET(a[0] * b[1] - a[1] * b[0]);
	return r;
}

template <class	AD, class BD>
TYPENAME AD::ret_type operator % (const TVectorBase<DIMENC(3), AD>& a, const TVectorBase<DIMENC(3), BD>& b) {
	return cross(a, b);
}
template <class	AD, class BD>
TYPENAME AD::ret_type operator ^ (const TVectorBase<DIMENC(3), AD>& a, const TVectorBase<DIMENC(3), BD>& b) {
	return cross(a, b);
}

//@}

#ifdef _WIN32
 #ifdef _DEBUG
  #pragma optimize ("", on)
  #pragma auto_inline(off)
  #pragma inline_recursion(off)
 #endif
 #pragma pack(pop)
#endif

}	//	namespace PTM
#endif

