/*
 *  Copyright (c) 2003-2006, Shoichi Hasegawa and Springhead development team 
 *  All rights reserved.
 *  This software is free software. You can freely use, distribute and modify this 
 *  software. Please deal with this software under one of the following licenses: 
 *  This license itself, Boost Software License, The MIT License, The BSD License.   
 */
#ifndef CDBOX_H
#define CDBOX_H

#include <SprCollision.h>
#include <Foundation/Object.h>
#include "CDConvex.h"

namespace Spr{;



/**	̖̂(lp`)\NXDCDBoxLD
	CDContactAnalysis ŎgD
*/
class CDQuadFace: public CDFaceIf{
public:
	int vtxs[4];	///< ʂ̒_ID
	Vec3f normal;	///< ʂ̖@

	/// CDQuadFace̖ʂ̃CfbNX
	virtual int NIndex(){ return 4; }
	/// CDQuadFaceCfbNXz擾
	virtual int* GetIndices(){ return vtxs; }
};

class CDQuadFaces:public std::vector<CDQuadFace>{
};

/// 
class CDBox: public CDConvex, public CDBoxIfInit{
public:
	mutable int curPos;
	OBJECTDEF(CDBox, CDConvex);
	
	Vec3f boxsize;				/// ̂̃TCYieӂ̒j
	CDQuadFaces qfaces;			/// ʁilp`:quadrangular facej
	std::vector<Vec3f> base;	/// _̍W([JWn)
	
	CDBox();
	CDBox(const CDBoxDesc& desc);
	///	T|[g|Cg߂D
	virtual Vec3f Support(const Vec3f& p) const;
	///	؂߂DڐG͂ɎgD
	/// ÂɊւẮA؂͋߂ȂBڐG͎ɂ͍ŋߖT̂P_΂B
	/// ̂ɊւFindCutRing()Ăяoꂽꍇɂ́AassertionB
	virtual bool FindCutRing(CDCutRing& r, const Posed& toW);
	
	/// ̂̃TCY擾
	Vec3f GetBoxSize();
	Vec3f* GetVertices();
	CDFaceIf* GetFace(size_t i);
};
	

}	//	namespace Spr

#endif	// CDBOX_H
