/*
 *  Copyright (c) 2003-2006, Shoichi Hasegawa and Springhead development team 
 *  All rights reserved.
 *  This software is free software. You can freely use, distribute and modify this 
 *  software. Please deal with this software under one of the following licenses: 
 *  This license itself, Boost Software License, The MIT License, The BSD License.   
 */
#ifndef CDCapsule_H
#define CDCapsule_H

#include <SprCollision.h>
#include <Foundation/Object.h>
#include "CDConvex.h"

namespace Spr{;

	
/// 
class CDCapsule: public CDConvex, public CDCapsuleIfInit, CDCapsuleDesc{
public:
	OBJECTDEF(CDCapsule, CDConvex);

	CDCapsule();
	//CDCapsule(float r = 0.0f, Vec3f c = Vec3f()):radius(r), center(c){}
	//CDCapsule(Vec3f c = Vec3f(), float r = 0.0f):center(c), radius(r){}
	CDCapsule(const CDCapsuleDesc& desc);
	
	///	T|[g|Cg߂D
	virtual Vec3f Support(const Vec3f& p) const;
	///	؂߂DڐG͂ɎgD
	/// ÂɊւẮA؂͋߂ȂBڐG͎ɂ͍ŋߖT̂P_΂B
	/// ̂ɊւFindCutRing()Ăяoꂽꍇɂ́AassertionB
	virtual bool FindCutRing(CDCutRing& r, const Posed& toW);
	
	float GetRadius();
	float GetLength();
};

	
}	//	namespace Spr

#endif	// CDCapsule_H
