/*
 *  Copyright (c) 2003-2006, Shoichi Hasegawa and Springhead development team 
 *  All rights reserved.
 *  This software is free software. You can freely use, distribute and modify this 
 *  software. Please deal with this software under one of the following licenses: 
 *  This license itself, Boost Software License, The MIT License, The BSD License.   
 */
#ifndef CDCONVEXMESH_H
#define CDCONVEXMESH_H

#include <SprCollision.h>
#include <Foundation/Object.h>
#include "CDConvex.h"

namespace Spr{;

class CDVertexIDs:public std::vector<int>{
public:
	int FindPos(int id) const;
};

/**	ʑʑ̖̂ʂ\NXDCDConvexMesh LD
	CDContactAnalysis ŎgD
*/
class CDFace: public CDFaceIf{
public:
	int vtxs[3];	///< ʂ̒_ID

	/// CDFace̖ʂ̃CfbNX
	virtual int NIndex(){ return 3; }
	/// CDFacẽCfbNXz擾
	virtual int* GetIndices(){ return vtxs; }
};

class CDFaces:public std::vector<CDFace>{
};

///	ʑʑ
class CDConvexMesh : public CDConvex, public CDConvexMeshIfInit{
public:
	OBJECTDEF(CDConvexMesh, CDConvex);

	///	TJn_ԍ
	mutable int curPos;
	///	_̍W([JWn)
	std::vector<Vec3f> base;

	///	_ׂ̗̒_̈ʒuz
	std::vector< std::vector<int> > neighbor;
	///	(3p` 0..nPlanes-1 ƗȖʁCȍ~MargeFaceō폜铯ꕽʏ̖)
	CDFaces faces;
	///	(3p`̂CMergeFace()Ŏc)
	int nPlanes;

public:
	CDConvexMesh();
	CDConvexMesh(const CDConvexMeshDesc& desc);

	///	_ʂڑ𐶐D
	void CalcFace();
	///	ꕽʏŐڑĂ3p`}[W
	void MergeFace();
	
	///	T|[g|Cg߂D
	virtual Vec3f Support(const Vec3f& p) const;
	
	///	؂߂DڐG͂ɎgD
	virtual bool FindCutRing(CDCutRing& r, const Posed& toW);

	CDFaceIf* GetFace(size_t i);
	size_t NFace();
	Vec3f* GetVertices();
	size_t NVertex();

	virtual bool GetDesc(void *desc) const ;
};

}	//	namespace Spr
#endif
