/*
 *  Copyright (c) 2003-2006, Shoichi Hasegawa and Springhead development team 
 *  All rights reserved.
 *  This software is free software. You can freely use, distribute and modify this 
 *  software. Please deal with this software under one of the following licenses: 
 *  This license itself, Boost Software License, The MIT License, The BSD License.   
 */
#ifndef CDCUTRING_H
#define CDCUTRING_H

#include <SprCollision.h>
#include <Collision/CDQuickHull2D.h>
#include <Foundation/Object.h>

namespace Spr{;

///	ڐG͂ɎgNXDڐG̐؂̐\D
class CDCutLine{
public:
	Vec2d normal;
	double dist;
	double distInv;
public:
	CDCutLine(Vec2d n, double d):normal(n), dist(d){
		const double epsilon = 1e-10;
		assert(finite(n.x));
		assert(finite(n.y));
		assert(finite(d));
		if (dist < epsilon) dist = epsilon;
		distInv = 1/dist;
	}
	Vec2d GetPos() const { 
		return normal*distInv; 
	}
	friend class CDCutRing;
};
///	ڐG͂ɎgNXDڐG̐؂
class CDCutRing{
public:
	///	؂̒1_ƁC؂ʂ̍WnDex @
	Posed local, localInv;
	///	؂\钼
	std::vector<CDCutLine> lines;
	///	oΕϊ  QuickHull ňԓ̓ʑp`̒_߂D
	static CDQHLines<CDCutLine> vtxs;	//	ԓ̓ʑp`̒_

	CDCutRing(Vec3d c, Matrix3d l){
		local.Ori().FromMatrix(l);
		local.Pos() = c;
		localInv = local.Inv();
	}
	void MakeRing();
	void Print(std::ostream& os);
};

}

#endif
