/*
 *  Copyright (c) 2003-2006, Shoichi Hasegawa and Springhead development team 
 *  All rights reserved.
 *  This software is free software. You can freely use, distribute and modify this 
 *  software. Please deal with this software under one of the following licenses: 
 *  This license itself, Boost Software License, The MIT License, The BSD License.   
 */
#ifndef CDQUICKHULL2D_H
#define CDQUICKHULL2D_H

#include <Base/Affine.h>
#include <Base/TQuaternion.h>
#include <vector>

//#define HULL_DEBUG	//	fobOo
#ifdef HULL_DEBUG
 #define HULL_DEBUG_EVAL(x) x
#else
 #define HULL_DEBUG_EVAL(x)
#endif

namespace Spr{;

///	QuickHullō
template <class TVtx>
class CDQHLine{
public:
	Vec2d normal;			///<	ʂ̖@
	double dist;			///<	ʂ̌_̋
	
	TVtx* vtx[2];			///<	ʂ\钸_
	CDQHLine* neighbor[2];	///<	ׂ̖ vtx[0] ׂ̗ neighbor[0]
	bool deleted;			///<	폜ꂽʂtrue
	void Clear();			///<	NADgOɌĂԁD
	void Reverse();			///<	ӂ̗\ЂԂD
	bool Visible(TVtx* p);	///<	_ v \邩ǂ
	///	v̒_ԍԂ(0..1Ԃ)DȂ3ԂD
	int GetVtxID(TVtx* v);
	void CalcNormal();		///<	@xNgƋvZD
	///	_Ƃ̋vZDxlĈԋ߂_ŌvZD
	double CalcDist(TVtx* v);
	///	fobOp\
	void Print(std::ostream& os) const;
};

///	ʂ̃obt@
template <class TVtx>
class CDQHLines{
public:
	double epsilon;
	double infinite;

	TVtx** vtxBeginInput;	///<	cĂ钸_̐擪
	TVtx** vtxEndInput;		///<	cĂ钸_̍Ō̎
	///	_Vector
	class TVtxs: public std::vector<TVtx*>{
	public:
		void Print(std::ostream& os) const{
			for(typename TVtxs::const_iterator it = begin(); it != end(); ++it){
				(*it)->Print(os);
			}
		}
 	};
	typedef CDQHLine<TVtx> CDQHLine;

	CDQHLine* buffer;	///<	obt@ւ̃|C^ new D
	int len;			///<	obt@̒
	CDQHLine* begin;	///<	ŏ̕
	CDQHLine* end;		///<	Ō̕ӂ̎
	TVtx** vtxBegin;	///<	cĂ钸_̐擪
	TVtx** vtxEnd;		///<	cĂ钸_̍Ō̎
	int nLines;			///<	ӂ̐
	unsigned size();	///<	gpς݃obt@̃TCY
	CDQHLines(int l);
	void Clear();
	~CDQHLines();
	/**	be܂ł̒_ʕDgp_bvtxBeginC
		gpȂ_́CvtxBegineɈړD	
		beginend͒_3܂ޖʂɂȂD̖ʂʕɎgꂽ
		 CDQHLine::deleted  false ɂȂĂD	*/
	void CreateConvexHull(TVtx** b, TVtx** e);
	void Print(std::ostream& os) const;

private:
	/**	ŏ̓ʑʑ́2{̕(\)D
		ł邾傫ӂƌǂD	*/
	bool CreateFirstConvex();
	/**	curƁC̖ʂԉ_ top 󂯎C
		curƂ̎͂̕ӂ폜Cʕtop܂߂D
		end[-1], end[-2]VɍꂽӂɂȂD	*/
	void CreateCone(CDQHLine* cur, TVtx* top);
	/**	ԉ̒_D炻𒸓_Xg͂	*/
	bool FindFarthest(CDQHLine* plane);
	/*	O  ̏ɕׂD
		ȌI聁̎n܂肪 inner	*/
	TVtx** DivideByPlaneR(CDQHLine* plane, TVtx** start, TVtx** end);
	TVtx** DivideByPlane(CDQHLine* plane, TVtx** start, TVtx** end);
	/**	̖ʂɑ΂鏈sDԉ̒_C
		n𒲂ׁCR[C̒_͂D*/
	void TreatPlane(CDQHLine* cur);
};

///	_NX̗
class CDQHVtx2DSample{
public:
	///@name QuickHullgp郁oDK{D
	//@{
	///  _̈ʒu
	Vec2f GetPos() const { return pos; }
	//@}
public:
	Vec2f pos;		///<	ʒu
	int id_;
	void Print(std::ostream& os) const;
};

}

#endif
