/*
 *  Copyright (c) 2003-2006, Shoichi Hasegawa and Springhead development team 
 *  All rights reserved.
 *  This software is free software. You can freely use, distribute and modify this 
 *  software. Please deal with this software under one of the following licenses: 
 *  This license itself, Boost Software License, The MIT License, The BSD License.   
 */
#include <Springhead.h>
#include <Foundation/Scene.h>
#include "Collision.h"
#include <set>
#ifdef USE_HDRSTOP
#pragma hdrstop
#endif
#include "CDQuickHull3DImp.h"

namespace Spr{;
	
//----------------------------------------------------------------------------
//	CDSphere
IF_OBJECT_IMP(CDSphere, CDConvex);	
	
CDSphere::CDSphere() {
}

CDSphere::CDSphere(const CDSphereDesc& desc) {
	radius = desc.radius;
}

// T|[g|Cg߂
Vec3f CDSphere::Support(const Vec3f& p) const {	
	float n = p.norm();
	if(n < 1.0e-10f)
		return Vec3f();
	else return (radius / n) * p;
	/*Vec3f center = GetPose().Pos();		// ̂̒SW擾
	Vec3f p_ = p;
	p_ -= center;						// pcenterւ̃xNg߂
	float s = p_.norm();				// pcenterւ̃xNg̒
	if (s > 1e-8f) {		
		float r = radius / s;	
		return r*p_ + center;			// ՓˌoɕKvȋ̍ŋߖT_
	}else{
		return center;
	}*/
}

// ؂߂. ڐG͂s.
bool CDSphere::FindCutRing(CDCutRing& r, const Posed& toW) {
	return false;
}

// ̂̔a擾
float CDSphere::GetRadius() {
	return radius;
}

}	//	namespace Spr
