// DRUsb20Simple.h: DRUsb20Simple NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#ifndef SPR_DRUSB20SIMPLE_H
#define SPR_DRUSB20SIMPLE_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "DVCounterBase.h"
#include "DVDaBase.h"
#include "DVPioBase.h"
#include "DRRealDevice.h"
#include <WinBasis/WBWin.h>

namespace Spr {

///	CyverseUSB2.0(LDR-SPIDAR-AMP)̃hCo
class SPR_DLL DRUsb20Simple : public DRRealDevice  
{
	///	zfoCX(DA)
	class VirtualDeviceDa:public DVDaBase{
	protected:
		int ch;
		DRUsb20Simple* realDevice;
		char name[100];
	public:
		VirtualDeviceDa(DRUsb20Simple* r, int c);
		virtual DRRealDevice* RealDevice() { return realDevice; }
		virtual void Voltage(float v){ realDevice->Voltage(ch, v); }
		virtual void Digit(int v){ realDevice->Digit(ch, v); }
		virtual const char* Name() const{ return name; }
	};
	///	zfoCX(Counter)
	class VirtualDeviceCounter:public DVCounterBase{
	protected:
		int ch;
		DRUsb20Simple* realDevice;
		char name[100];
	public:
		VirtualDeviceCounter(DRUsb20Simple* r, int c);
		virtual DRRealDevice* RealDevice() { return realDevice; }
		///	JE^l̐ݒ
		virtual void Count(long c){ realDevice->Count(ch, c); }
		///	JE^l̓ǂݏo
		virtual long Count(){ return realDevice->Count(ch); }
		///	O
		virtual const char* Name() const{ return name; }
	};
	///	zfoCX(Pio)
	class VirtualDevicePio:public DVPioBase{
	protected:
		int ch;
		DRUsb20Simple* realDevice;
		char name[100];
	public:
		VirtualDevicePio(DRUsb20Simple* r, int c);
		virtual DRRealDevice* RealDevice() { return realDevice; }
		virtual void Set(int l){ realDevice->Pio(ch, l!=0); }
		virtual int Get(){ return realDevice->Pio(ch) ? 1 : 0; }
		virtual const char* Name() const{ return name; }
	};

//----------------------------------------------------------------------------
protected:
	char name[100];
	int channel;
	HANDLE hSpidar;

	int sign[8]; //DAo͗p̕
	long count[8];
	long countOffset[8];
	int daOut[8];
	int adIn[8];
	int pioLevel[16];

public:
	///	RXgN^	ch͔wʂ̃XCb`ɂȂ\
	DRUsb20Simple(int ch);
	virtual ~DRUsb20Simple();

	///	foCX̖O
	virtual const char* Name() const { return name; }
	///	
	virtual bool Init();
	///	(`l, PIDVIDCɂɏ)
	virtual bool InitAny();
	///	zfoCX̓o^
	virtual void Register(DVVirtualDevicePool& vpool);
	
	///	do
	void Voltage(int ch, float v);
	///	do(lw)
	void Digit(int ch, int v);
	///	JE^l̐ݒ
	void Count(int ch, long c);
	///	JE^l̓ǂݏo
	long Count(int ch);
	///	Ԃ̍XV
	virtual void Update();
	
	///	PIO|[g̐ݒ
	void Pio(int ch, bool level);
	///	PIO|[g̓ǂݏo
	bool Pio(int ch);
	///	XCb`i|[g̏5-8rbgj̓ǂݏo
	int RotarySwitch();

	/// Zbg
	virtual void Reset();

	///	USB̃t@Cnh
	HANDLE GetHandle(){ return hSpidar; };
protected:
	virtual void UsbReset();
	virtual void UsbCounterGet();
	virtual void UsbCounterClear();
	virtual void UsbDaSet();
	virtual DWORD UsbVidPid(HANDLE h);
	virtual bool FindDevice(int ch);
	virtual HANDLE UsbOpen(int id);
	virtual bool UsbClose(HANDLE& h);
};

} //namespace Spr

#endif // SPR_DRUSB20SIMPLE_H
