/*
 *  Copyright (c) 2003-2006, Shoichi Hasegawa and Springhead development team 
 *  All rights reserved.
 *  This software is free software. You can freely use, distribute and modify this 
 *  software. Please deal with this software under one of the following licenses: 
 *  This license itself, Boost Software License, The MIT License, The BSD License.   
 */
#ifndef FISAVECONTEXT_H
#define FISAVECONTEXT_H

#include <Foundation/Object.h>
#include <Foundation/UTTypeDesc.h>
#include <Foundation/UTLoadContext.h>
#include <fstream>

namespace Spr{;

class FINodeHandlers;
class FISaveContext{
public:
	///	G[bZ[Wo͗p̃Xg[
	std::ostream* errorStream;
	///	Z[ut@C̖O
	UTString fileName;
	///	Z[ut@C̃t@CXg[
	std::ofstream file;
	///	typeDb ̃X^bN
	UTStack< UTRef<UTTypeDescDb> > typeDbs;
	///	handlerDb̃X^bN
	UTStack< UTRef<UTLoadHandlerDb> > handlerDbs;
	///	UTTypeDesc̃tB[hւ̃C^[^̃X^bN
	UTTypeDescFieldIts fieldIts;
	///	Z[ufBXNv^̃X^bNDlXggݗČ^ɔăX^bNɂȂĂD
	UTStack< UTRef<UTLoadedData> > datas;
	///
	std::set<ObjectIf*> savedObjects;
	
	FISaveContext();
	///	Z[ũIuWFNg̃X^bN
	ObjectIfs objects;
	///	Z[upɃt@CJ
	void Open(const char* fn);
	///	bZ[W̏o
	void Message(const char* msg);
	///	G[bZ[W̏o
	void ErrorMessage(const char* msg);

	UTString GetNodeTypeName();
	UTString GetNodeName();
};

}

#endif
