/*
 *  Copyright (c) 2003-2006, Shoichi Hasegawa and Springhead development team 
 *  All rights reserved.
 *  This software is free software. You can freely use, distribute and modify this 
 *  software. Please deal with this software under one of the following licenses: 
 *  This license itself, Boost Software License, The MIT License, The BSD License.   
 */
#ifndef FOUNDATION_OBJECT_H
#define FOUNDATION_OBJECT_H

#include <SprFoundation.h>
#include <Base/Base.h>

/*	hase memo
	Object  ObjectIfpȂ̒āD̗ǂƎv܂D
	TvF
	- IfNX͍܂łǂDObjectIfpȂD
	  IfImpObject̊֐Ăяoîʓ|Ȃ̂ŗvj
		- ObjectIfBuf(IfvtableĂ߂̃)p
		- IntfInit<Type>CTypeIfStubIfBuf
			class Object:IfBuf{}
			class PHSolid:PHObject, IfInit<PHSolid, PHSolidIf>{}
		- TypeIfStub́CTypeIfpC(this-4)->Type::Func()ĂяoD
	
	ǂ_F
		- Objecťp֌W肷DInheritObject<>svɁDfobO₷D
		- vtable_ptr2ōςށDIfvtable_ptrȂDߖɂȂD
		- ĂяoɎQƂVirtualIf̕P̂݁D
		- If̃|C^ItZbgŒȂ̂ŁCStatic_Cast If<-->Object ̕ϊłD
		- DebuggerłCLXgΌ:(Obj*)((char*)intf-4)
	_F
		- Stub̂ʓ|vD]ƈĖ[̔hNX܂StubKvD
		- IfBuf̏gbL[D
		- If͐΂ɕϐĂȂD
*/


namespace Spr{;

//	^ IfInfo  TypeInfõ|C^ێĂāAŌɊJNX
class TypeInfoManager:public UTRefCount{
protected:
	std::vector< UTRef< IfInfo > > ifs;
	std::vector< UTRef< UTTypeInfo > > objects;
	static TypeInfoManager* typeInfoManager;
public:
	TypeInfoManager();
	~TypeInfoManager();
	static TypeInfoManager* SPR_CDECL Get();
	void RegisterIf(IfInfo* i);
	void RegisterObject(UTTypeInfo* t);
	IfInfo* FindIfInfo(const char* cn);
	UTTypeInfo* FindTypeInfo(const char* cn);
};

///	ȉC^tF[X̌^̎
//@{
#define IF_IMP_COMMON(cls)															\
	IfInfoImp<cls##If> cls##If::ifInfo = IfInfoImp<cls##If>(#cls, cls##_BASEIF);	\
	const IfInfo* SPR_CDECL cls##If::GetIfInfoStatic(){								\
		static IfInfoImp<cls##If>* i;												\
		if (!i){																	\
			i= DBG_NEW IfInfoImp<cls##If>(#cls, cls##_BASEIF);						\
			TypeInfoManager::Get()->RegisterIf(i);									\
		}																			\
		return i;																	\
	}																				\

#define IF_IMP_BASE(cls)															\
	IfInfo* cls##_BASEIF[] = {NULL};												\
	IF_IMP_COMMON(cls)																\

#define IF_IMP(cls, base1)															\
	IfInfo* cls##_BASEIF[] = {(IfInfo*)base1##If::GetIfInfoStatic(), NULL};			\
	IF_IMP_COMMON(cls)

//@}

///	ObjecthNX̎s^
//@{
//	ׂẴNXɋ
#define OBJECTDEF_COMMON(cls)											\
	/*	If Object ǂɂȂ ^ϊ^ XCastPtrԂD*/		\
	XCastPtr<cls>& Cast() const{										\
		return *(XCastPtr<cls>*)(void*)this;							\
	}																	\
	/*	ٌ^IfObjectւ̓Iϊ	*/								\
	static cls* GetSelf(const ObjectIf* p) {							\
		return p ? (cls*)p->GetObj(cls::GetTypeInfoStatic()) : NULL;	\
	}																	\
	/*	ٌ^ObjectObjectւ̓Iϊ	*/							\
	static cls* GetSelf(const Object* p) {								\
		if (p && p->GetTypeInfo()->Inherit(cls::GetTypeInfoStatic()))	\
			return (cls*)p;												\
		else return NULL;												\
	}																	\

//	hNXp
#define OBJECTDEF_INHERIT(cls, base)	OBJECTDEF_COMMON(cls)			\
	/*	{NXGetIf𓱓	*/										\
	using base::GetIf;													\
	typedef base base_type;												\

//	ۃNX = UT+h
#define	OBJECTDEF_ABST_NOIF(cls, base)		DEF_UTTYPEINFOABSTDEF(cls) OBJECTDEF_INHERIT(cls, base)
//	NX = UT+h
#define	OBJECTDEF_NOIF(cls, base)			DEF_UTTYPEINFODEF(cls) OBJECTDEF_INHERIT(cls, base)

//	IfNXp
#define OBJECTDEF_IFUTIL_COMMON(cls)									\
	typedef cls##If	if_type;											\

//	IfhNXp
#define OBJECTDEF_IFUTIL_INHERIT(cls)	OBJECTDEF_IFUTIL_COMMON(cls)	\
	/*	^If擾	*/												\
	cls##If* GetIf(cls##If*) const {									\
		return (cls##If*)(ObjectIfBuf*)(Object*)this;					\
	}																	\
	/*	^IfObjectւ̐ÓIϊ	*/								\
	static cls* GetSelf(const cls##If* p) {								\
		return (cls*)(void*)(Object*)(ObjectIfBuf*)p;					\
	}																	\

//	pIfIuWFNgp
#define OBJECTDEF_IFUTIL_INHERIT1(cls)	OBJECTDEF_IFUTIL_INHERIT(cls)	\
	virtual ObjectIf* GetIfDynamic(const IfInfo* info) const {			\
		if (info == cls##If::GetIfInfoStatic())							\
			return (cls##If*)(ObjectIfBuf*)this;						\
		else return base_type::GetIfDynamic(info);						\
	}																	\

//	pIfIuWFNgp
#define OBJECTDEF_IFUTIL_INHERIT2(cls, if2)	OBJECTDEF_IFUTIL_INHERIT(cls)	\
	virtual ObjectIf* GetIfDynamic(const IfInfo* info) const {				\
		if (info == cls##If::GetIfInfoStatic()) return GetIf((cls##If*)0);	\
		else if (info == if2::GetIfInfoStatic()) return GetIf((if2*)0);		\
		else return base_type::GetIfDynamic(info);							\
	}																		\
	/*	pIf̎擾	*/													\
	if2* GetIf(if2*) const {												\
		return (if2*)(if2##For##cls*)this;									\
	}																		\

//	pIf2IuWFNgp
#define OBJECTDEF_IFUTIL_INHERIT3(cls, if2, if3)	OBJECTDEF_IFUTIL_INHERIT(cls)	\
	virtual ObjectIf* GetIfDynamic(const IfInfo* info) const {				\
		if (info == cls##If::GetIfInfoStatic()) return GetIf((cls##If*)0);	\
		else if (info == if2::GetIfInfoStatic()) return GetIf((if2*)0);		\
		else if (info == if3::GetIfInfoStatic()) return GetIf((if3*)0);		\
		else return base_type::GetIfDynamic(info);							\
	}																		\
	/*	pIf̎擾	*/													\
	if* GetIf(if2*) const {													\
		return (if2*)(if2##For##cls*)this;									\
	}																		\
	if* GetIf(if3*) const {													\
		return (if3*)(if3##For##cls*)this;									\
	}																		\

#define	OBJECTDEF_FOR_OBJ(cls)		DEF_UTTYPEINFODEF(cls) OBJECTDEF_COMMON(cls) OBJECTDEF_IFUTIL_COMMON(cls)

#define	OBJECTDEF_ABST(cls,base)	OBJECTDEF_ABST_NOIF(cls, base) OBJECTDEF_IFUTIL_INHERIT1(cls)
#define	OBJECTDEF(cls,base)			OBJECTDEF_NOIF(cls,base) OBJECTDEF_IFUTIL_INHERIT1(cls)

#define	OBJECTDEF_ABST2(cls,base,if2)		OBJECTDEF_ABST_NOIF(cls, base) OBJECTDEF_IFUTIL_INHERIT2(cls, if2)
#define	OBJECTDEF2(cls,base,if2)			OBJECTDEF_NOIF(cls,base) OBJECTDEF_IFUTIL_INHERIT2(cls, if2)

#define	OBJECTDEF_ABST3(cls,base,if2, if3)	OBJECTDEF_ABST_NOIF(cls, base) OBJECTDEF_IFUTIL_INHERIT3(cls, if2, if3)
#define	OBJECTDEF3(cls,base,if2, if3)		OBJECTDEF_NOIF(cls,base) OBJECTDEF_IFUTIL_INHERIT3(cls, if2, if3)

//@}

///	s^Object̔hNXׂo̎D
//@{
#define OBJECT_IMP_BASEABST(cls)		DEF_UTTYPEINFOABST(cls)
#define OBJECT_IMP_BASE(cls)			DEF_UTTYPEINFO(cls)
#define OBJECT_IMP(cls, base)			DEF_UTTYPEINFO1(cls, base)
#define OBJECT_IMP_ABST(cls, base)		DEF_UTTYPEINFOABST1(cls, base)
#define IF_OBJECT_IMP(cls, base)		IF_IMP(cls, base) OBJECT_IMP(cls, base)
#define IF_OBJECT_IMP_ABST(cls, base)	IF_IMP(cls, base) OBJECT_IMP_ABST(cls, base)
//@}

///	Xe[g̍쐬Ɣj̊֐`
#define ACCESS_STATE_NOINHERIT(cls)													\
	virtual size_t GetStateSize() const { return sizeof(cls##State); }				\
	virtual void ConstructState(void* m) const { new(m) cls##State;}				\
	virtual void DestructState(void* m) const { ((cls##State*)m)->~cls##State(); }	\

///	Xe[g̐ݒE擾܂߂ANZXp֐̒`
#define ACCESS_STATE(cls)															\
	ACCESS_STATE_NOINHERIT(cls)														\
	virtual const void* GetStateAddress() const { return (cls##State*)this; }		\
	virtual bool GetState(void* s) const { *(cls##State*)s=*this; return true; }	\
	virtual void SetState(const void* s){ *(cls##State*)this = *(cls##State*)s;}	\

///	fXNv^̐ݒE擾ȂǃANZXp֐̒`
#define ACCESS_DESC(cls)															\
	virtual const void* GetDescAddress() const { return (cls##Desc*)this; }			\
	virtual bool GetDesc(void* d) const { *(cls##Desc*)d=*this; return true; }		\
	virtual void SetDesc(const void* d) { *this = *(const cls##Desc*)d; }			\
	virtual size_t GetDescSize() const { return sizeof(cls##Desc); }				\

///	Xe[gƃfXNv^܂Ƃ߂Ē`
#define ACCESS_DESC_STATE(cls) ACCESS_STATE(cls) ACCESS_DESC(cls)


///	ObjectIfƂ̔hNX̃IuWFNĝ߂̃obt@
class ObjectIfBuf{
	void* vtable;
};
///	ObjectIfƂ̔hNX̃IuWFNĝ߂̃obt@t
template <class T>
class ObjectIfBufWithInit{
	void* vtable;
public:
	ObjectIfBufWithInit(){ ::new (this) T; }
};
///	ObjectIfBufhNX̃C^tF[Xɏ
template <class I, class O>
struct IfInitTemplate{
	IfInitTemplate(){
		ObjectIfBuf* buf = static_cast<ObjectIfBuf*>(static_cast<O*>(this));
		::new (buf) I;
	}
};

}	//	namespace Spr;


#include "IfStubFoundation.h"

namespace Spr{;

/**	SObject̊{^	*/
class Object:public ObjectIfBuf, public ObjectIfInit, public UTTypeInfoObjectBase, public UTRefCount{
	void GetIfInfo() { assert(0); }	//	don't call me
public:
	OBJECTDEF_FOR_OBJ(Object);		///<	NX̎擾Ȃǂ̊{@\̎
	Object* GetObj(const UTTypeInfo* info) const {
		if (GetTypeInfo()->Inherit(info)) return const_cast<Object*>(this);
		else return NULL;
	}
	template <class I> I* GetIf(I*) const {
//		DSTR << "Object::GetIf(I*) I=" << I::GetIfInfoStatic()->ClassName() << " is called." << std::endl;
		return (I*) GetIfDynamic(I::GetIfInfoStatic());
	}
	virtual ObjectIf* GetIfDynamic(const IfInfo* info) const {
		if (info == ObjectIf::GetIfInfoStatic())
			return (ObjectIf*)(ObjectIfBuf*)this;
		return NULL;
	}

	virtual int AddRef(){return UTRefCount::AddRef();}
	virtual int DelRef(){return UTRefCount::DelRef();}
	virtual int RefCount(){return UTRefCount::RefCount();}

	///	fobOp̕\
	virtual void Print(std::ostream& os) const;
	virtual void PrintShort(std::ostream& os) const;
	///	IuWFNg̍쐬
	virtual ObjectIf* CreateObject(const IfInfo* info, const void* desc);
	///	qIuWFNg̐
	virtual size_t NChildObject() const { return 0; }
	///	qIuWFNg̎擾
	virtual ObjectIf* GetChildObject(size_t pos) { return NULL; }
	virtual const ObjectIf* GetChildObject(size_t pos) const { 
		return ((Object*) this)->GetChildObject(pos);
	}
	///	qIuWFNg̒ǉ
	virtual bool AddChildObject(ObjectIf* o){ return false; }
	///	qIuWFNg̍폜
	virtual bool DelChildObject(ObjectIf* o){ return false; }
	///	ׂĂ̎qIuWFNg̍폜ƃvpeB̃NA
	virtual void Clear(){}

	///	fXNv^̓ǂݏo(Rs[)
	virtual bool GetDesc(void* desc) const { return false; }
	/// fXNv^̐ݒ
	virtual void SetDesc(const void* desc) {}
	///	fXNv^̓ǂݏo(QƔ)
	virtual const void* GetDescAddress() const { return NULL; }
	///	fXNv^̃TCY
	virtual size_t GetDescSize() const { return 0; };
	///	Ԃ̓ǂݏo(Rs[)
	virtual bool GetState(void* state) const { return false; }
	///	Ԃ̓ǂݏo(QƔ)
	virtual const void* GetStateAddress() const { return NULL; }
	///	Ԃ̐ݒ
	virtual void SetState(const void* state){}
	///	Ԃ̃TCY
	virtual size_t GetStateSize() const { return 0; };
	///	ubNԌ^ɏ
	virtual void ConstructState(void* m) const {}
	///	Ԍ^ubNɖ߂
	virtual void DestructState(void* m) const {}
protected:
	virtual void PrintHeader(std::ostream& os, bool bClose) const;
	virtual void PrintChildren(std::ostream& os) const;
	virtual void PrintFooter(std::ostream& os) const;
	///	soStateƂďD
	static void ConstructState(ObjectIf* o, char*& s);
	///	soState烁ubNɖ߂D
	static void DestructState(ObjectIf* o, char*& s);
};
///	coutȂǂ̃Xg[Objecto͂鉉ZqDObjectPrintĂяoD
inline std::ostream& operator << (std::ostream& os, const Object& o){
	o.Print(os);
	return os;
}

class NameManager;
/**	OObject^D
	SDKSceneɏLD	*/
class NamedObject: public Object, public NamedObjectIfInit{
	OBJECTDEF(NamedObject, Object);		///<	NX̎擾Ȃǂ̊{@\̎
protected:
	friend class ObjectNames;
	UTString name;					///<	O
	NameManager* nameManager;	///<	ǑdǗ́DSceneSDKȂǁD
public:
	NamedObject():nameManager(NULL){}
	~NamedObject();
	///	O̎擾
	const char* GetName() const { return name.c_str(); }
	///	O̐ݒ
	void SetName(const char* n);
	///	NameManagerݒ
	void SetNameManager(NameManagerIf* s);
	///	NameManager̎擾
	virtual NameManagerIf* GetNameManager();
protected:
	virtual void PrintHeader(std::ostream& os, bool bClose) const;
};

class Scene;
/**	SceneLObject^D
	Sceneւ̃|C^	*/
class SceneObject:public NamedObject, public SceneObjectIfInit{
	OBJECTDEF(SceneObject, NamedObject);	///<	NX̎擾Ȃǂ̊{@\̎
public:
	virtual void SetScene(SceneIf* s);
	virtual SceneIf* GetScene();
};

///	Objectւ̎QƂ̔z
class ObjectRefs:public UTStack< UTRef<Object> >{
public:
	///	T̔hNXX^bNTopTD
	template <class T> bool Find(T*& t){
		for(iterator it = end(); it != begin();){
			--it;
			T* tmp = DCAST(T, *it);
			if (tmp){
				t = tmp;
				return true;
			}
		}
		return false;
	}
};

///	t@Ng[̎
template <class T, class IF, class DESC>
class FactoryImpTemplate: public FactoryBase{
public:
	virtual ObjectIf* Create(const void* desc, ObjectIf* parent){
		T* t = DBG_NEW T(*(DESC*)desc);

		//	V[̐ݒ
		SceneObject* o = DCAST(SceneObject, t);
		SceneIf* s = DCAST(SceneIf, parent);
		if (o && !s){		//	eV[ł͖ꍇCesceneɓo^
			SceneObject* po = DCAST(SceneObject, parent);
			if (po) s = po->GetScene();
		}
		if (o && s){
			o->SetScene(s);
		}else{	//	V[ɐݒłȂꍇCOǗIuWFNg̐ݒ
			NamedObject* o = DCAST(NamedObject, t);
			NameManagerIf* m = DCAST(NameManagerIf, parent);
			if (o && !m){	//	eNameMangerł͂ȂꍇCeNameManagerɓo^
				NamedObject* po = DCAST(NamedObject, parent);
				if (po) m = po->GetNameManager();
			}
			if (o && m) o->SetNameManager(m);
		}
		return t->Cast();
	}
	virtual const IfInfo* GetIfInfo() const {
		return IF::GetIfInfoStatic();
	}
};
///	t@Ng[̎
template <class T, class IF>
class FactoryImpTemplateNoDesc: public FactoryBase{
public:
	virtual ObjectIf* Create(const void* desc, ObjectIf* parent){
		T* t = DBG_NEW T;

		//	V[̐ݒ
		SceneObject* o = DCAST(SceneObject, t);
		SceneIf* s = DCAST(SceneIf, parent);
		if (o && !s){		//	eV[ł͖ꍇCesceneɓo^
			SceneObject* po = DCAST(SceneObject, parent);
			if (po) s = po->GetScene();
		}
		if (o && s){
			o->SetScene(s);
		}else{	//	V[ɐݒłȂꍇCOǗIuWFNg̐ݒ
			NamedObject* o = DCAST(NamedObject, t);
			NameManagerIf* m = DCAST(NameManagerIf, parent);
			if (o && !m){	//	eNameMangerł͂ȂꍇCeNameManagerɓo^
				NamedObject* po = DCAST(NamedObject, parent);
				if (po) m = po->GetNameManager();
			}
			if (o && m) o->SetNameManager(m);
		}
		return t->Cast();
	}
	virtual const IfInfo* GetIfInfo() const {
		return IF::GetIfInfoStatic();
	}
};

#define FactoryImp(cls)	FactoryImpTemplate<cls, cls##If, cls##Desc>
#define FactoryImpNoDesc(cls)	FactoryImpTemplateNoDesc<cls, cls##If>

///	V[Ot̏ԂۑDĐdg
class ObjectStates:public Object, public ObjectStatesIfInit{
protected:
	char* state;	///<	(XXxxxxState)ׂ
	size_t size;	///<	Ԃ̒
	///	ԃZ[u̍ċN
	void SaveState(ObjectIf* o, char*& s);
	///	ԃ[h̍ċN
	void LoadState(ObjectIf* o, char*& s);

public:
	OBJECTDEF(ObjectStates, Object);
	ObjectStates():state(NULL), size(0){}
	~ObjectStates(){ delete state; }
	///	oƂ̎qZ[u邽߂ɕKvȃmۂD
	void AllocateState(ObjectIf* o);
	///	ԂZ[uD
	void SaveState(ObjectIf* o);
	///	Ԃ[hD
	void LoadState(ObjectIf* o);
	///	Ԃ̃
	void ReleaseState(ObjectIf* o);
	///	Ԃ̃TCY߂
	size_t CalcStateSize(ObjectIf* o);
};


}
#endif
