/*
 *  Copyright (c) 2003-2006, Shoichi Hasegawa and Springhead development team 
 *  All rights reserved.
 *  This software is free software. You can freely use, distribute and modify this 
 *  software. Please deal with this software under one of the following licenses: 
 *  This license itself, Boost Software License, The MIT License, The BSD License.   
 */
#ifndef UTTYPEDESC_H
#define UTTYPEDESC_H

#include <Base/BaseUtility.h>
#include <Base/BaseTypeInfo.h>
#include <Foundation/Object.h>
#include <set>
#include <map>
#include <algorithm>

/*
	t@C[_́C^f[^ĂD
	|C^͂ĂāCŃND
	IuWFNĝǂɃ|C^𑫂/㏑̂wdg݂KvD


	źCϒf[^DvectorȂǂȂ̂ŁCƈႤǁD
	vector ̂܂܂ƁCȃLXgKvɂȂDǂH
	vectorANZX\bh\[X玩D

	𐔒lɕϊƂ܂ł̓p[T̎dD
	double  l^ɕϊ̂TypeDesc̎dD
	p[T^́ClCC|C^Cgݗ
	typedesĉ́Clchar int float double
	
	typedesc->CreateInstance();
	typedesc->SetData("o", f[^);
		:
		:
	typedesc->GetData("o", f[^);


	f[^Nodẽc[D
	NodéCtB[h̗
	tB[h́ClCC|C^Cgݗ
	gݗĂTypeDescD
*/
/*
	Fieldƍ\̂̊֌W̌Field = Č^ɂD

	Č^́CP^struct (̔z)
	 Field = P^ or struct (̔z)
		TypeDesc ͒P^struct
*/

namespace Spr{;
/**	@page UTTypeDesc hLgIuWFNgƌ^Lq
	C++̍\̂f[^oꍇȂǁC\̂f[^ɂ́C
	ϐϐ̌^ƌ͂ȂD
	ŁC^Lq^IuWFNg(UTTypeDesc)gċLqD
	UTTypeDesc̃IuWFNg邽߂̃\[X̓wb_t@C typedesc.exe 
	p[XĎD*/

///	Ώۂ̌^ɃANZX邽߂̃NX
class UTAccessBase:public UTRefCount{
public:
	virtual ~UTAccessBase(){}
	///	IuWFNg̍\z
	virtual void* Create()=0;
	///	IuWFNg̔j
	virtual void Delete(void* ptr)=0;
	///	vector<T>::push_back(); return &back();
	virtual void* VectorPush(void* v)=0;
	///	vector<T>::pop_back();
	virtual void VectorPop(void* v)=0;
	///	vector<T>::at(pos);
	virtual void* VectorAt(void* v, int pos)=0;
	///	vector<T>::size();
	virtual size_t VectorSize(const void* v)=0;
	///
	virtual size_t SizeOfVector()=0;
};
template <class T>
class UTAccess:public UTAccessBase{
	virtual void* Create(){ return DBG_NEW T; }
	virtual void Delete(void* ptr){delete (T*)ptr; }
	virtual void* VectorPush(void* v){
		((std::vector<T>*)v)->push_back(T());
		return &((std::vector<T>*)v)->back();
	}
	virtual void VectorPop(void* v){
		((std::vector<T>*)v)->pop_back();
	}
	virtual void* VectorAt(void* v, int pos){
		return &((std::vector<T>*)v)->at(pos);
	}
	size_t VectorSize(const void* v){
		return ((const std::vector<T>*)v)->size();
	}
	virtual size_t SizeOfVector(){
		return sizeof(std::vector<T>);
	}
};

class UTTypeDescDb;
///	^\
class SPR_DLL UTTypeDesc:public UTRefCount{
public:
	enum { BIGVALUE= 0x40000000 };
	///	R[h̃tB[h\
	class SPR_DLL Field{
	public:
		typedef std::vector<std::pair<std::string, int> > Enums;
		Enums enums;
		///	o
		std::string name;
		///	^
		std::string typeName;
		///	^
		UTRef<UTTypeDesc> type;
		///	ItZbg
		int offset;
		///	z̗vfD
		int length;
		///	vfʂ̃tB[hƂꍇ̃tB[h
		std::string lengthFieldName;
		///	vector/z񂩂ǂ
		enum VarType{
			SINGLE, ARRAY, VECTOR
		} varType;
		///	QƂǂ
		bool isReference;

		Field(): offset(-1), length(1), varType(SINGLE), isReference(false){}
		~Field();
		///	f[^̃TCY
		size_t GetSize();
		///
		void Print(std::ostream& os) const;
		///
		void AddEnumConst(std::string name, int val);
		void AddEnumConst(std::string name);
		///	tB[h̃AhXvZ
		const void* UTTypeDesc::Field::GetAddress(const void* base, int pos);
		void* UTTypeDesc::Field::GetAddress(void* base, int pos){
			return (void*)GetAddress((const void*)base, pos); 
		}
		///	tB[h̃AhXvZDvectorgD
		void* UTTypeDesc::Field::GetAddressEx(void* base, int pos);
		///	tB[hstd::vectoȑꍇCvector::size() ĂяoD
		size_t VectorSize(const void * base){ 
			return type->access->VectorSize(((char*)base)+offset); 
		}
		///	typebool̒P^̏ꍇɁCboolǂݏo֐
		bool ReadBool(const void* base, int pos=0){
			return type->ReadBool(GetAddress(base, pos));
		}
		///	typebool̒P^̏ꍇɁCboolފ֐
		void WriteBool(void* base, bool val, int pos = 0){
			if (base) type->WriteBool(val, GetAddressEx(base, pos));
		}
		///	typel̒P^̏ꍇɁClǂݏo֐
		double ReadNumber(const void* base, int pos=0){
			return type->ReadNumber(GetAddress(base, pos));
		}
		///	typel̒P^̏ꍇɁClފ֐
		void WriteNumber(void* base, double val, int pos = 0){
			if (base) type->WriteNumber(val, GetAddressEx(base, pos));
		}
		///	ǂݏo
		std::string ReadString(const void* base, int pos=0){
			return type->ReadString(GetAddress(base, pos));
		}
		///	񏑂
		void WriteString(void* base, const char* val, int pos=0){
			if (base) type->WriteString(val, GetAddressEx(base, pos));
		}
	};
	///	gݗČ^킷ꍇɎg
	class SPR_DLL Composit: public std::vector<Field>{
	public:
		///	f[^̃TCYԂ
		int Size(){ return Size(""); }
		///	f[^̃TCYԂ
		int Size(std::string id);
		///
		void Link(UTTypeDescDb* db);
		///
		void Print(std::ostream& os) const;
	};

	///	^
	std::string typeName;
	///	f[^̒
	size_t size;
	///	gݗČ^̒g̋LqDP^̏ꍇ́Csize() == 0
	Composit composit;
	///	IfInfo
	const IfInfo* ifInfo;
	///
	UTRef<UTAccessBase> access;

	friend class UTTypeDescDb;
public:
	///	RXgN^
	UTTypeDesc():size(0), ifInfo(NULL){}
	///	RXgN^
	UTTypeDesc(std::string tn, int sz=0): typeName(tn), size(sz), 
		ifInfo(NULL){}
	///	
	virtual ~UTTypeDesc(){}
	///
	void Print(std::ostream& os) const;
	///	^
	std::string GetTypeName() const { return typeName; }
	///	^
	void SetTypeName(const char* s) { typeName = s; }
	///	^̃TCY
	size_t GetSize() { return size; }
	///	tB[h̒ǉ
	Field* AddField(std::string pre, std::string ty, std::string n, std::string post);
	///	base̒ǉ
	Field* AddBase(std::string tn);

	///	gݗČ^ǂ
	bool IsComposit(){ return composit.size()!=0; }
	///	gݗČ^̗vf
	Composit& GetComposit(){ return composit; }
	///	tB[ȟ^̃N
	void Link(UTTypeDescDb* db);
	///
	const IfInfo* GetIfInfo(){ return ifInfo; }

	//	[eBeB֐
	///	TypeDescbool̒P^̏ꍇɁCboolǂݏo֐
	virtual bool ReadBool(const void* ptr){ assert(0); return 0;}
	///	TypeDescl̒P^̏ꍇɁClފ֐
	virtual void WriteBool(bool val, void* ptr){ assert(0);}
	///	TypeDescl̒P^̏ꍇɁClǂݏo֐
	virtual double ReadNumber(const void* ptr){ assert(0); return 0;}
	///	TypeDescl̒P^̏ꍇɁClފ֐
	virtual void WriteNumber(double val, void* ptr){ assert(0);}
	///	ǂݏo
	virtual std::string ReadString(const void* ptr){ assert(0);  return 0;}
	///	񏑂
	virtual void WriteString(const char* val, void* ptr){ assert(0); }

	///	IuWFNg̍\z
	void* Create(){
		return access ? access->Create() : NULL;
	}
	///	IuWFNǧn
	void Delete(void* ptr){ 
		if (ptr){
			assert(access);
			access->Delete(ptr);
		}
	}
	///	vector::push_back() return &vector::back();
	void* VectorPush(void* v){ return access->VectorPush(v); }
	///	vector::pop_back();
	void VectorPop(void* v){ access->VectorPop(v); }
	///	return &vector::at(pos);
	void* VectorAt(void* v, int pos){ return access->VectorAt(v, pos); }
	const void* VectorAt(const void* v, int pos){ return VectorAt((void*)v, pos); }
	///	return vector::size();
	size_t VectorSize(const void * v){ return access->VectorSize(v); }
	///
	size_t SizeOfVector(){ return access->SizeOfVector(); }
};
inline bool operator < (const UTTypeDesc& d1, const UTTypeDesc& d2){
	return d1.GetTypeName().compare(d2.GetTypeName()) < 0;
}

template <class N>
class SPR_DLL UTTypeDescNumber:public UTTypeDesc{
public:
	UTTypeDescNumber(){
		access = DBG_NEW UTAccess<N>;
	}
	UTTypeDescNumber(std::string tn): UTTypeDesc(tn, sizeof(N)){
		access = DBG_NEW UTAccess<N>;
	}
protected:
	///	lǂݏo
	virtual double ReadNumber(const void* ptr){
		return *(const N*)ptr;
	}
	///	l
	virtual void WriteNumber(double val, void* ptr){
		*(N*)ptr = (N)val;
	}
};

template <class N>
class SPR_DLL UTTypeDescBool:public UTTypeDesc{
public:
	UTTypeDescBool(){
		access = DBG_NEW UTAccess<N>;
	}
	UTTypeDescBool(std::string tn): UTTypeDesc(tn, sizeof(N)){
		access = DBG_NEW UTAccess<N>;
	}
protected:
	///	lǂݏo
	virtual bool ReadBool(const void* ptr){
		return *(const N*)ptr != 0;
	}
	///	l
	virtual void WriteBool(bool val, void* ptr){
		*(N*)ptr = (N)val;
	}
};

class SPR_DLL UTTypeDescString:public UTTypeDesc{
public:
	UTTypeDescString(){
		access = DBG_NEW UTAccess<std::string>;
	}
	UTTypeDescString(std::string tn): UTTypeDesc(tn, sizeof(std::string)){
		access = DBG_NEW UTAccess<std::string>;
	}
protected:
	///	lǂݏo
	virtual std::string ReadString(const void* ptr){
		return *(std::string*)ptr;
	}
	///	l
	virtual void WriteString(const char* val, void* ptr){
		*(std::string*)ptr = val;
	}
};

///	^̃f[^x[X
class SPR_DLL UTTypeDescDb: public UTRefCount{
	std::set<UTString, UTStringLess> addedGroups;
public:
	///	Reǐ^
	typedef std::set< UTRef<UTTypeDesc>, UTContentsLess< UTRef<UTTypeDesc> > > Db;
protected:
	std::string group;			///<	O[v
	std::string prefix;			///<	ÔvtBbNX̕
	Db db;						///<	UTTypeDesc ĂRei
public:
	UTTypeDescDb(UTString gp=""):group(gp){}
	///	
	~UTTypeDescDb();
	/**	^f[^x[Xɓo^D	*/
	void RegisterDesc(UTTypeDesc* n){
		if (prefix.length() && n->typeName.compare(0, prefix.length(), prefix) == 0){
			n->typeName = n->typeName.substr(prefix.length());
		}
		db.insert(n);
	}
	/**	^Aliaso^	*/
	void RegisterAlias(const char* src, const char* dest){
		UTTypeDesc* srcDesc = Find(src);
		assert(srcDesc);
		UTTypeDesc* destDesc =DBG_NEW UTTypeDesc(*srcDesc);
		destDesc->typeName = dest;
		RegisterDesc(destDesc);
	}
	/**	^vg^CvXgɓo^	*/
	void RegisterProto(UTTypeDesc* n);
	/**	^Prefix ݒD
		^FindŌۂɁCL[PrefixL[ł^D	*/
	void SetPrefix(std::string p);
	/**	^𖼑O猟D
		@param tn	^Dprefix ͏ȗĂ悢D	*/
	UTTypeDesc* Find(std::string tn);
	///	DB̌^ND
	void Link();
	///	DB̌^̕\
	void Print(std::ostream& os) const;
	UTTypeDescDb& operator += (const UTTypeDescDb& b){
		if (b.group.compare(group)!=0 && 
			addedGroups.find(b.group) == addedGroups.end()){
			db.insert(b.db.begin(), b.db.end());
			Link();
			addedGroups.insert(b.group);
		}
		return *this;
	}
	UTString GetGroup() const {
		return group;
	}
	void Clear(){
		db.clear();
	}
	friend class UTTypeDescDbPool;
};
inline bool operator < (const UTTypeDescDb& d1, const UTTypeDescDb& d2){
	return d1.GetGroup() < d2.GetGroup();
}

class UTTypeDescDbPool: public UTRefCount, 
	public std::set< UTRef<UTTypeDescDb>, UTContentsLess< UTRef<UTTypeDescDb> > >{
protected:
	static UTRef<UTTypeDescDbPool> pool;
	static UTTypeDescDbPool* SPR_CDECL GetPool();
public:
	static UTTypeDescDb* SPR_CDECL Get(std::string gp);
	static void SPR_CDECL Print(std::ostream& os);
};

/**	TypeDesc̃tB[h̃C^[^
	oCit@CXt@CC^̃f[^ɓǂݏoĂꍇC
	ǂݏõf[^UTTypeDesc̃c[̂ǂɑΉ邩ێĂKvD
*/
class UTTypeDescFieldIt{
public:
	/**	tB[h̎ނtOD
		قƂǂ̃t@CtH[}bgŁCCCŁCقȂp[TKvɂȂD
		ŁCŕށD
		gݗČ^́CUTTypeDescQƂēǂݏôŁCF_BLOCKpӂD
	*/
	enum FieldType{
		F_NONE, F_BOOL, F_INT, F_REAL, F_STR, F_BLOCK
	};
	UTTypeDesc* type;						///<	ǂݏoUTTypeDesc
	UTTypeDesc::Composit::iterator field;	///<	gݗČ^̏ꍇC̒̂ǂ̃tB[h
	//UTTypeDesc::Field* field;	///<	gݗČ^̏ꍇC̒̂ǂ̃tB[h
	int arrayPos;							///<	z̏ꍇCǂݏo̓Y
	int arrayLength;						///<	Œ蒷̏ꍇ̔z̒
	FieldType fieldType;					///<	ǂݏotB[ȟ^

	UTTypeDescFieldIt(UTTypeDesc* d);					///<	RXgN^
	bool NextField();						///<	̃tB[hɐi
	bool FindField(UTString n);				///<	w̃tB[hɐi
protected:
	void SetFieldInfo();					//<		NextField FindFieldg
	FieldType GetTypeId(UTTypeDesc* t);
};
class UTTypeDescFieldIts:public UTStack<UTTypeDescFieldIt>{
public:
	///
	void PushType(UTTypeDesc* t){
		Push(UTTypeDescFieldIt(t));
	}
	///	̃tB[hɐi
	bool NextField(){
		if(size()) return back().NextField();
		return false;
	}
	/**	݂̑gݗČ^̒Cw̖ÕtB[hTD
		炻̃tB[hwtrueԂD	*/
	bool FindField(UTString n){
		if(size()) return back().FindField(n);
		return false;
	}
	///	z񒆂ł̈ʒu
	int ArrayPos(){
		if(size()) return back().arrayPos;
		return -1;
	}
	///	z̒
	int ArrayLength(){
		if(size()) return back().arrayLength;
		return 0;
	}
	bool IncArrayPos(){
		if(!size()) return false;
		++ back().arrayPos;
		return back().arrayPos < back().arrayLength;
	}
	bool IsArrayRest(){
		if (!size()) return false;
		return back().arrayPos < back().arrayLength;
	}
	bool IsBool(){
		return back().fieldType==UTTypeDescFieldIt::F_BOOL;
	}
	bool IsNumber(){
		return back().fieldType==UTTypeDescFieldIt::F_INT || back().fieldType==UTTypeDescFieldIt::F_REAL;
	}
	bool IsString(){
		return back().fieldType==UTTypeDescFieldIt::F_STR;
	}
};

void SPR_CDECL UTRegisterTypeDescs();

///	P^o^D
#define REG_FIELD(type)	RegisterDesc( DBG_NEW UTTypeDesc(#type, sizeof(type)) )
/**	hLg烍[h\ȃNX̒`D
	NX{NXꍇ	*/
#define DEF_RECORDBASE(Type, Base, Def)					\
	struct Type: public Base Def;						\
	static const char* classNameOf##Type = #Type;		\
	static const char* classDefOf##Type = #Def;			\

/**	hLg烍[h\ȃNX̒`D
	{NXꍇ	*/
#define DEF_RECORD(Type, Def)							\
	struct Type Def;									\
	static const char* classNameOf##Type = #Type;		\
	static const char* classDefOf##Type = #Def;			\

/**	DER_RECORD Œ`^o^D*/
#define REG_RECORD(Type)	\
	Register(classNameOf##Type, classDefOf##Type)

/**	DER_RECORD Œ`^vg^CvƂĂo^D*/
#define REG_RECORD_PROTO(Type)	\
	Register(classNameOf##Type, classDefOf##Type, true)

/**	@page TypeDesc ^NX
C++̍\̐錾𕶎ƂĎ󂯎C^͂D
gFwb_t@CŁC`
DEF_RECORD( Test, {
	int x;
	char y;
}
)

āCNX̒`sC
.cppt@C̉̊֐̒
	REG_RECORD(Test);
ēo^܂D
*/


}
#endif
