/*
 *  Copyright (c) 2003-2006, Shoichi Hasegawa and Springhead development team 
 *  All rights reserved.
 *  This software is free software. You can freely use, distribute and modify this 
 *  software. Please deal with this software under one of the following licenses: 
 *  This license itself, Boost Software License, The MIT License, The BSD License.   
 */
#ifndef FWOLDSPRINGHEADNODEHANDLER_H
#define FWOLDSPRINGHEADNODEHANDLER_H

namespace SprOldSpringhead{;
using namespace Spr;

///	\defgroup gpFWOldSpringheadNode (Springhead1)t@C[hp݊m[h
//@{
/// Xt@C`̃o[WD
struct Header{
	unsigned int major;		
	unsigned int minor;		
	unsigned int flags;
};
	
///	DirectXFrameD GRFrameɑΉD
struct Frame{
};
	
///	DirectXFrameTransformMatrixDt[̕ϊs\DGRFrame::transformɑΉD
struct FrameTransformMatrix{
	Affinef matrix;
};

///	Springehead1̌DGRLightɑΉD
struct Light8{
	enum XLightType{
		XLIGHT_POINT = 1,			///< _
		XLIGHT_SPOT = 2,			/// X|bgCg
		XLIGHT_DIRECTIONAL = 3,		///< s
	} type;
    Vec4f diffuse;		///<	gU
    Vec4f specular;		///<	ʌ
    Vec4f ambient;		///<	
    Vec3f position;		///<	̈ʒu
    Vec3f direction;	///<	̕
    float range;		///<	͈͂
    float falloff;		///<	̑(傫قǋ}s)		0..
    ///@name	DAtten = 1/( att0 + att1 * d + att2 * d^2)
	//@{
	float attenuation0;	///<	att0	0..
    float attenuation1;	///<	att1	0..
    float attenuation2;	///<	att2	0..
	//@}
	float spotInner;	///<	X|bgCg̒S		0..spotCutoff
	float spotCutoff;	///<	X|bgCǧ͈	0..
};

///	DirectX̃}eADGRMateiralɑΉD
struct Material{
	Vec4f face;				// face color
	float power;			// shininess power
	Vec3f specular;			// specular color
	Vec3f emissive;			// emissive color
};

///	DirectXMesh̖ʁD
struct MeshFace{
	int nFaceVertexIndices;
	std::vector<int> faceVertexIndices;
};

///	DirectXMeshDGRMeshɑΉD
struct Mesh{
	int nVertices;
	std::vector<Vec3f> vertices;
	int nFaces;
	std::vector<MeshFace> faces;
};

///	DirectXMesh̖@xNgD
struct MeshNormals{
	int nNormals;
	std::vector<Vec3f> normals;
	int nFaceNormals;
	std::vector<MeshFace> faceNormals;
};

///	DirectXMesh̃}eAXgD
struct MeshMaterialList{
	int nMaterials;
	int nFaceIndexes;
	std::vector<int> faceIndexes;
};

/// DirectX̃eNX`t@CiMaterial̓^O)D
struct TextureFilename{
	std::string filename;
};

///	DirectXMesh̃eNX`WD
struct MeshTextureCoords{
	int nTextureCoords;
	std::vector<Vec2f> textureCoords;
};

///	Springhead1SceneD
struct Scene{
};

///	Springhead1SimulatorD
struct Simulator{
	double timeStep;	///< ϕXebv
	double decay;		///< ̂̑x̌	
};
	
///	Springhead1CameraD
struct Camera{
	Affinef view;
	float width;
	float height;
	float offsetX;
	float offsetY;
	float front;
	float back;
};

///	Springhead1SolidD
struct Solid{
	float mass;				///< 
	Matrix3f inertia;		///< [g
	Vec3f velocity;			///< x
	Vec3f angularVelocity;	///< px
	Vec3f center;			///< Sʒu
};

/// Springhead1SphereDGRSphereɑΉD
struct Sphere{
	float radius;			///< a
	int slices;				///< o̕
	int stacks;				///< ܐ̕
};	
	
/// Springhead1̕}eA
struct PhysicalMaterial{				
	float ns;				///< R͂̂΂ˌW
	float nd;				///< R͂̃_pW
	float fs;				///< C͂̂΂ˌW
	float fd;				///< C͂̃_pW
	float s;				///< őÎ~CW
	float d;				///< CW
};

/// Springhead1SolidContainerD
struct SolidContainer{
};
	
///	Springhead1GravityEngineD
struct GravityEngine{
	Vec3f gravity;
};

/// Springhead1ContactInactiveD
struct ContactInactive{
	int nSolids;
	std::vector<int> solidIndexes;
};

///	Springhead1ContactEngineD
struct ContactEngine{
};
	
/// Springhead1JointEngineD
struct JointEngine{
};
	
/// Springhead1JointD
struct Joint{
	int			nType;				///<	֐ߎ 0:, 1:XCh
	Vec3f		prj;				///<	ễt[猩֐߈ʒu
	Matrix3f	pRj;				///<	ễt[猩֐ߎp
	Vec3f		crj;				///<	q̂̃t[猩֐߈ʒu
	Matrix3f	cRj;				///<	q̂̃t[猩֐ߎp

	float		fPosition;			///<	ψ
	float		fVelocity;			///<	x
	float		fMaxTorque;			///<	őgN
	float		fMinPosition;		///<	͈(ől)
	float		fMaxPosition;		///<	͈(ŏl)
	int			nInputType;			///<	͂̎ @see PHJointInputType
	float		fInput;				///<	͒l̏l
	float		fPValue;			///<	PIDP̒l
	float		fIValue;			///<	PIDI̒l
	float		fDValue;			///<	PIDD̒l
};

/// Springhead1ImportD	
struct Import{
	std::string file;	
};

//@}

}
#endif
