#ifndef FWSCENE_H
#define FWSCENE_H

#include <Framework/SprFWScene.h>
#include <Framework/SprFWObject.h>
#include <Foundation/Object.h>
#include <Foundation/Scene.h>
#include "IfStubFramework.h"

namespace Spr{;


///	FWScenẽt@Ng
class FWSceneFactory : public FactoryBase {
public:
	const IfInfo* GetIfInfo() const {
		return FWSceneIf::GetIfInfoStatic();
	}
	ObjectIf* Create(const void* desc, const ObjectIf*){
		return CreateFWScene();
	}
};

///	GraphicsPhysicsScene܂Ƃ߂V[OtS
class FWScene : public Scene, public FWSceneIfInit, public FWSceneDesc {
public:
	OBJECTDEF(FWScene, Scene);
	ACCESS_DESC(FWScene);
	typedef std::vector< UTRef<FWObjectIf> > FWObjects;
	FWObjects fwObjects;						///<	ƃOtBbNX̃IuWFNg̃N
	UTRef<PHSceneIf> phScene;					///<	V~[Vp̃V[
	UTRef<GRSceneIf> grScene;					///<	OtBbNXp̃V[
	typedef std::vector< UTRef<HIForceDevice6D> > FWHumanInterfaces;
	//	hase TBW
	//	FWHumanInterfaces humanInterfaces;			///<	[UC^tF[XD[0]JDHIForceDevice6D̃NX͕ύX\D
	enum HumanInterfacePurposeId{
		HI_CAMERACONTROLLER,
		HI_OBJECTMANIPULATOR0,
		HI_OBJECTMANIPULATOR1,
		HI_OBJECTMANIPULATOR2,
		HI_OBJECTMANIPULATOR3,
	};
	/// RXgN^
	FWScene(const FWSceneDesc& d=FWSceneDesc());
	
	virtual PHSceneIf*	GetPHScene(){ return phScene; }
	virtual void		SetPHScene(PHSceneIf* s){ phScene = s; }
	virtual GRSceneIf*	GetGRScene(){ return grScene; }
	virtual void		SetGRScene(GRSceneIf* s){ grScene = s; }
	virtual FWObjectIf* CreateObject(const PHSolidDesc& soliddesc = PHSolidDesc(), const GRFrameDesc& framedesc = GRFrameDesc());
	virtual int NObject()const{return (int)fwObjects.size();}
	virtual FWObjectIf** GetObjects(){return (FWObjectIf**)&*fwObjects.begin();}
	virtual void Sync();
	virtual void Step();
	virtual void Draw(GRRenderIf* grRender, bool debug=false);
	virtual HIForceDevice6D* GetHumanInterface(size_t pos);
	//
	virtual ObjectIf* CreateObject(const IfInfo* info, const void* desc);
	virtual bool AddChildObject(ObjectIf* o);
	virtual bool DelChildObject(ObjectIf* o);
	virtual size_t NChildObject() const;
	virtual ObjectIf* GetChildObject(size_t pos);
	virtual NamedObjectIf* FindObject(UTString name, UTString cls);
	virtual void AddHumanInterface(HIForceDevice6D* d);
};


}

#endif
