/*
 *  Copyright (c) 2003-2006, Shoichi Hasegawa and Springhead development team 
 *  All rights reserved.
 *  This software is free software. You can freely use, distribute and modify this 
 *  software. Please deal with this software under one of the following licenses: 
 *  This license itself, Boost Software License, The MIT License, The BSD License.   
 */
#ifndef GRBlendMesh_H
#define GRBlendMesh_H

#include <SprGraphics.h>
#include "GRFrame.h"

namespace Spr{;

class GRMaterial;

/** @class GRBlendMesh
	@brief OtBbNXV[Otł̍Wn\D	*/
class GRBlendMesh: public GRVisual, public GRBlendMeshIfInit, public GRBlendMeshDesc{
	GRRenderIf* render;							///< _[				
	std::vector<unsigned int> list;				///< fBXvCXg̎ʎq
			
	/// _tH[}bgAVF[_tH[}bg ɍ킹AfBXvCXg쐬D
	void CreateList(GRRenderIf* r);
public:
	OBJECTDEF(GRBlendMesh, GRVisual);
	ACCESS_DESC(GRBlendMesh);

	std::vector< UTRef<GRMaterial> > material;				///< }eA
	std::vector<int>                 materialList;			///< }eÃCfbNXXg
	/**
	   facesƁAOp`OXt@CŎw肳ꂽʂƂ̊֘At \n
	  iXt@C烍[hꂽʂ́AׂĎOp`Ă邽߁A
	   ǂ̖ʂǂ̃}eAKp̂f邽߂̂́j			*/
	std::vector<int> originalFaces;				///< ʂ\邽߂̒_CfbNXiOp`O̖ʂɑ΂CfbNXj
	std::vector<unsigned int> elementIndex;		///< ʂ\邽߂̒_CfbNXiOp`̖ʂɑ΂CfbNXj
	std::vector<int> faceNormals;				///< @CfbNX
	
	std::vector<Affinef>				blendMatrix;			///< uhϊs

	
	GRBlendMesh(const GRBlendMeshDesc& desc=GRBlendMeshDesc());
	~GRBlendMesh();
	void Render(GRRenderIf* r);
	void Rendered(GRRenderIf* r);
};
}
#endif
