/*
 *  Copyright (c) 2003-2006, Shoichi Hasegawa and Springhead development team 
 *  All rights reserved.
 *  This software is free software. You can freely use, distribute and modify this 
 *  software. Please deal with this software under one of the following licenses: 
 *  This license itself, Boost Software License, The MIT License, The BSD License.   
 */
/**
 *	@file GRDeviceGL.h
 *	@brief OpenGLɂOtBbNX`̎@@
 */
#ifndef GRDEVICEGL_H
#define GRDEVICEGL_H

#include <map>
#include <stack>
#include <SprGraphics.h>

namespace Spr{;

/**	@class	GRDeviceGL
    @brief	OpenGLɂOtBbNX`̎@ */
class GRDeviceGL: public GRDevice, public GRDeviceGLIfInit{
	OBJECTDEF(GRDeviceGL, GRDevice);
protected:
	int		nLights;					///< ̐
	int		vertexFormatGl;				///< glInterleavedArraysŎgCGL̒_tH[}bgID
	size_t	vertexSize;					///< _̃TCY
	bool	vertexColor;				///< _Fǂ
	GRMaterialDesc currentMaterial;		///< ݂̃}eA
	/**
	 *	@name	}gbNXϐ
	 *@@ GLłModelςViewςƂƂłȂB \n
	 *@@ _𓮂ɂ́A[UModeloĂKvB	\n
	 *@@ iDirect3D̏ꍇ́AModelViewA_𓮂Ƃłj
	 *	@{ 
	 */
	Affinef								viewMatrix;				///< Jg_s
	Affinef								modelMatrix;			///< Jgfs 
	std::stack<Affinef>                	modelMatrixStack;		///< fsX^bN
	std::vector<Affinef>				blendMatrix;			///< uhϊs
	/** @} */

	/**
	 *	@name	tHgϐ
	 *@@ VKɎw肳ꂽtHgfontListɊi[B
	 *	@{
	 */
	std::map<unsigned int, GRFont> fontList;		///< tHgXg<DisplayListindex, font>    
	unsigned int	fontBase;						///< fBXvCXgindex number̊ꐔ 
	/** @} */	

	/**
	 *	@name	VF[_ϐ
	 *@@ VKɎw肳ꂽtHgfontListɊi[B
	 *	@{
	 */
	std::string vertexShaderFile;						///< VertexShader t@C
	std::string fragmentShaderFile;						///< FragmentShader t@C
	GRShaderFormat::ShaderType shaderType;				///< VF[_̃P[V^Cv
	/** @} */	

public:
	///	RXgN^
	GRDeviceGL(){}
	/// ݒ
	virtual void Init();

	///	Viewportݒ
	virtual void SetViewport(Vec2f pos, Vec2f sz);
	///	obt@NA
	virtual void ClearBuffer();
	///	_O̊JnOɌĂԊ֐
	virtual void BeginScene();
	///	_ȌIɌĂԊ֐
	virtual void EndScene();
	///	Jg̎_safvŒu
	virtual void SetViewMatrix(const Affinef& afv);
	///	Jg̓es擾
	virtual void SetProjectionMatrix(const Affinef& afp);
	///	Jg̓esafpŒu
	virtual void GetProjectionMatrix(const Affinef& afp);
	///	Jg̃fsafwŒu
	virtual void SetModelMatrix(const Affinef& afw);
	///	Jg̃fsɑ΂afw|
	virtual void MultModelMatrix(const Affinef& afw);
	///	Jg̃fsfsX^bN֕ۑ
	virtual void PushModelMatrix();
	///	fsX^bNoAJg̃fsƂ
	virtual void PopModelMatrix();
	/// uhϊs̑Svf폜
	virtual void ClearBlendMatrix();
	/// uhϊsݒ肷
	virtual bool SetBlendMatrix(const Affinef& afb);
	/// uhϊsݒ肷
	virtual bool SetBlendMatrix(const Affinef& afb, unsigned int id);
	///	_tH[}bg̎w
	virtual void SetVertexFormat(const GRVertexElement* e);
	///	_VF[_[̎w
	virtual void SetVertexShader(void* s);
	///	_Ww肵ăv~eBu`
	virtual void DrawDirect(GRRenderBaseIf::TPrimitiveType ty, void* begin, size_t count, size_t stride=0);
	///	_WƃCfbNXw肵ăv~eBu`
	virtual void DrawIndexed(GRRenderBaseIf::TPrimitiveType ty, size_t* idx, void* vtx, size_t count, size_t stride=0);
	///	_CNg`ɂ DiplayList ̍쐬
	virtual int CreateList(GRRenderBaseIf::TPrimitiveType ty, void* vtx, size_t count, size_t stride=0);
	///	_CNg`ɂ DiplayList ̍쐬i}eAAeNX`̐ݒsj
	virtual int CreateList(GRMaterialIf* mat, unsigned int texid, 
						   GRRenderBaseIf::TPrimitiveType ty, void* vtx, size_t count, size_t stride=0);
	/// IuWFNg DisplayList ̍쐬
	virtual int CreateList(float radius, int slices, int stacks);
	/// IuWFNg DisplayList ̍쐬i}eAAeNX`̐ݒsj
	virtual int CreateList(GRMaterialIf* mat,  float radius, int slices, int stacks);
	///	CfbNX`ɂDiplayList̍쐬
	virtual int CreateIndexedList(GRRenderBaseIf::TPrimitiveType ty, size_t* idx, void* vtx, size_t count, size_t stride=0);
	///	CfbNX`ɂ DiplayList ̍쐬i}eAAeNX`̐ݒsj
	virtual int CreateIndexedList(GRMaterialIf* mat, 
								  GRRenderBaseIf::TPrimitiveType ty, size_t* idx, void* vtx, size_t count, size_t stride=0);
	/// CfbNX`ɂVF[_Kp DisplayList ̍쐬iSetVertexFormat()  SetShaderFormat() ̌ɌĂԁj
	virtual int CreateShaderIndexedList(GRHandler shader, void* location, 
										GRRenderBaseIf::TPrimitiveType ty, size_t* idx, void* vtx, size_t count, size_t stride=0);	
	///	DisplayList̕\
	virtual void DrawList(int i);
	///	DisplayList̉
	virtual void ReleaseList(int i);
	/// 3eLXg̕`iGLI[łfont͎wȂj
	virtual void DrawFont(Vec2f pos, const std::string str);
	/// 3eLXg̕`iGLI[łfont͎wȂj
	virtual void DrawFont(Vec3f pos, const std::string str);
	///	3eLXg̕`
	virtual void DrawFont(Vec2f pos, const std::string str, const GRFont& font);
	///	3eLXg̕`
	virtual void DrawFont(Vec3f pos, const std::string str, const GRFont& font);
	///	`̍ގ̐ݒ
	virtual void SetMaterial(const GRMaterialDesc& mat);
	virtual void SetMaterial(const GRMaterialIf*& mat){ GRDevice::SetMaterial(mat); }
	///	`悷_Ȇ̐ݒ
	virtual void SetLineWidth(float w);
	///	X^bNPush
	virtual void PushLight(const GRLightDesc& light);
	virtual void PushLight(const GRLightIf* light){ GRDevice::PushLight(light); }
	///	X^bNPop
	virtual void PopLight();
	///	fvXobt@ւ݂̏/֎~
	virtual void SetDepthWrite(bool b);
	///	fvXeXgL/ɂ
	virtual void SetDepthTest(bool b);
	///	fvXobt@@ɗp锻w肷
	virtual void SetDepthFunc(GRRenderBaseIf::TDepthFunc f);
	/// At@ufBOL/ɂ
	virtual void SetAlphaTest(bool b);
	///	At@ufBÕ[hݒ(SRC̍W, DESTW)
	virtual void SetAlphaMode(GRRenderBaseIf::TBlendFunc src, GRRenderBaseIf::TBlendFunc dest);
	/// eNX`̃[hi߂lFeNX`IDj
	virtual unsigned int LoadTexture(const std::string filename);
	/// VF[_̏
	virtual void InitShader();
	/// VF[_tH[}bg̐ݒ
	virtual void SetShaderFormat(GRShaderFormat::ShaderType type);	
	/// VF[_IuWFNg̍쐬
	virtual bool CreateShader(std::string vShaderFile, std::string fShaderFile, GRHandler& shader);
	/// VF[_IuWFNg̍쐬AGRDeviceGL::shaderւ̓o^i炩ShaderFileo^ĂKvj
	virtual GRHandler CreateShader();
	/// VF[_̃\[XvOɓǂݍ݁AVF[_IuWFNgƊ֘At
	virtual bool ReadShaderSource(GRHandler shader, std::string file);	
	/// P[V̎擾iSetShaderFormat()ŃVF[_tH[}bgݒ肵ĂKvj
	virtual void GetShaderLocation(GRHandler shader, void* location);		
	
};

}
#endif
