/*
 *  Copyright (c) 2003-2006, Shoichi Hasegawa and Springhead development team 
 *  All rights reserved.
 *  This software is free software. You can freely use, distribute and modify this 
 *  software. Please deal with this software under one of the following licenses: 
 *  This license itself, Boost Software License, The MIT License, The BSD License.   
 */
#ifndef GRMesh_H
#define GRMesh_H

#include <SprGraphics.h>
#include "GRFrame.h"

namespace Spr{;

class GRMaterial;

/**	@class	GRMesh
    @brief	OtBbNXV[Otł̍Wn\D */
class GRMesh: public GRVisual, public GRMeshIfInit, public GRMeshDesc{
	UTRef<GRRenderIf> render;					///< _[
	std::vector<unsigned int> list;				///< fBXvCXg̎ʎq

	/// _tH[}bg GRVertexElement ɍ킹AfBXvCXg쐬D
	void CreateList(GRRenderIf* r);
	/// MaterialList̃CfbNXɍ킹AfBXvCXgוD
	void CreateListElement(void* vtx);
public:
	OBJECTDEF(GRMesh, GRVisual);
	ACCESS_DESC(GRMesh);

	std::vector< UTRef<GRMaterial> > material;				///< }eA
	std::vector<int>                 materialList;			///< }eÃCfbNXXg
	/**
	   facesƁAOp`OXt@CŎw肳ꂽʂƂ̊֘At \n
	  iXt@C烍[hꂽʂ́AׂĎOp`Ă邽߁A
	   ǂ̖ʂǂ̃}eAKp̂f邽߂̂́j			*/
	std::vector<int> originalFaces;				///< ʂ\邽߂̒_CfbNXiOp`O̖ʂɑ΂CfbNXj
	std::vector<unsigned int> elementIndex;		///< ʂ\邽߂̒_CfbNXiOp`̖ʂɑ΂CfbNXj
	std::vector<int> faceNormals;				///< @CfbNX

	GRMesh(const GRMeshDesc& desc=GRMeshDesc());
	~GRMesh();
	void Render(GRRenderIf* r);
	void Rendered(GRRenderIf* r);
	
	virtual bool AddChildObject(ObjectIf* o);
	///	qIuWFNg̐
	virtual size_t NChildObject() const ;
	///	qIuWFNg̎擾
	virtual ObjectIf* GetChildObject(size_t pos) ;
};
}
#endif
