#ifndef HIMOUSE_H
#define HIMOUSE_H

#include "HIHapticDevice.h"

#include <Device/DVDeviceManager.h>

namespace Spr {;

class SPR_DLL HIMouse: public HIForceDevice6D{
public:
	/// Ă{^̏ԂtO
	enum ButtonState{
		NONE,
		 #define MK_LBUTTON          0x0001
		LBUTTON = MK_LBUTTON,
		 #define MK_RBUTTON          0x0002
		RBUTTON = MK_RBUTTON,
		 #define MK_SHIFT            0x0004
		SHIFT   = MK_SHIFT,
		 #define MK_CONTROL          0x0008
		CONTROL = MK_CONTROL,
		 #define MK_MBUTTON          0x0010
		MBUTTON = MK_MBUTTON,
	} btnState;	

	/// 
	HIMouse(){ bGood = false; }
	virtual ~HIMouse(){}
	///	foCX̃^Cv
	HIOBJECTDEF(HIMouse);

	bool IsGood(){return bGood;}

	/// }EX̏
	bool Init();

	///	Ă{^ɉpos,oriXVBShiftĂƂaxisXVB
	void Update(float dt);

	///	܂Ƃ߂āCbZ[Wꍇ
	bool PreviewMessage(void* m);
	///@name ʂ̃bZ[WnhŌĂяoꍇ
	//@{
	///	L[
	virtual bool OnKeyDown(unsigned nChar);
	/// hbȌ
	virtual void OnButtonMove(unsigned int state, int x, int y);
	/// {^Ƃ̏
	virtual void OnButtonDown(int x, int y);
	/// {^𗣂Ƃ̏
	virtual void OnButtonUp();
	///	_uNbN̏
	virtual void OnDblClick(unsigned fwKeys, int x, int y);
	/// _uNbN̏(|C^̎p𐅕ɏ)
	virtual void OnLButtonDClick();
	/// E_uNbN̏(|C^̈ʒu_ɏ)
	virtual void OnRButtonDClick();
	/// Shift+_uNbN̏(ẄʒuEp)
	virtual void OnShiftLButtonDClick();
	/// zC[܂킵Ƃ̏(|C^orWZɐړ)
	virtual void OnWheel(unsigned int state, short dz);
	//@}

	

	///	ʒu̎擾
	Vec3f GetPos(){ return pos; }
	///	͂̎擾
	Vec3f GetForce(){ return force; }
	///	gN̎擾
	Vec3f GetTorque(){ return torque; }
	///	px̎擾
	Quaternionf GetOri(){ return ori; }
	/// W̎擾
	Affinef GetAxis(){ return axis; }

	/// XP[̐ݒ
	void SetScale(float tp, float rp, float ta, float ra);

	/// ʂ̐ݒ
	void SetMass(float m){ mass = m; }
	/// ʒu̐ݒ
	void SetPos(Vec3f p){ pos = p; }
	/// p̐ݒ
	void SetOri(Quaternionf o){ ori = o; }
	///	íE]͂̐ݒ
	void SetForce(const Vec3f& f, const Vec3f& t){ force = f; torque = t; }
	void SetForce(const Vec3f& f){ force = f; }
	///	Œ̗͂ݒ肷
	void SetMinForce(){ force = torque = Vec3f(); }	

	/// W̐ݒ
	void SetAxis(Affinef a){ axis = a; }
	/// pW̐ݒ
	void SetAxisInit(Affinef ai){ axisInit = ai; }


	///	Lu[V(ɉȂ)
	bool Calib(){ return true; }

//-> ֌ɂύX (2005/1/05)
	void SetViewSize(float inWidth, float inHeight);
//<-

protected:
	// }EXANeBuǂ̃tO
	bool bGood;
	// }EX̍W(old:OXebvCnew:Xebv)
	int oldX, oldY, newX, newY;
	// }EX̍WƉzEƂ̃XP[pp[^
	float scaleTransPointer, scaleRotPointer, scaleTransAxis, scaleRotAxis;

	// |C^Ɋւϐ
	// 
	float mass;
	// |C^ɂi
	Vec3f force;
	// |C^ɂ]
	Vec3f torque;
	// |C^̈ʒuBUpdate()ōXV
	Vec3f pos;
	// |C^̎pBUpdate()ōXV
	Quaternionf ori;

	// W(hbO쎞͂̍WɂǂÂē)
	Affinef axis;
	// pW
	Affinef axisInit;

//-> ֌ɂύX (2005/1/05)
	float	viewCenterX, viewCenterY, trackBallRadius;

	Vec3f	GetTrackBallRotation(float inX, float inY);
//<-
};

}	//	namespace Spr
#endif
