#ifndef HDSPIDAR3QUAD_H
#define HDSPIDAR3QUAD_H

#include "HIHapticDevice.h"
#include "HISpidarMotor.h"

#include "Device/DVDeviceManager.h"
#include <vector>

namespace Spr {
using namespace Spr;

/**	3{SPIDAR.
	̒WvZsAo͂͊oe[^
	o͂vZ肷Bo͂̌vZ2v@pĂ邽߁C
	HIS/Fortran  libF77.lib libI77.lib QuadPR.lib KvD
@verbatim
SPIDAR̒萔̐ݒ
Init(dev, motPos, 0.5776, 2.924062107079e-5f, 0.5f, 20.0f);

//	[^̎tʒu. [^̂ɎtĂꍇ́C
#define PX	0.265f	//	x̕ӂ̒/2
#define PY	0.265f	//	y̕ӂ̒/2
#define PZ	0.265f	//	z̕ӂ̒/2
Vec3f motorPos[][4] =	//	[^̎tʒu(S_Ƃ){
	{Vec3f(-PX, PY, PZ),	Vec3f( PX, PY,-PZ), Vec3f(-PX,-PY,-PZ), Vec3f( PX,-PY, PZ)},
	{Vec3f( PX, PY, PZ),	Vec3f(-PX, PY,-PZ), Vec3f( PX,-PY,-PZ), Vec3f(-PX,-PY, PZ)}
};

//	Pj[go߂DȀo͓d[V/N]
//	maxon:		0.008[m] / 0.0438[Nm/A] / 0.5[A/V] =  0.365296803653
//	t@:	0.008[m] / 0.0277[Nm/A] / 0.5[A/V] =  0.5776
sp->VoltPerNewton(0.5776f);

//	PJEg̒ [m/plus]	l: 2.924062107079e-5f
sp->LenPerPlus(2.924062107079e-5f);

//	ŏ [N]
sp->MinForce(0.5f);

//	ő咣 [N]
sp->MaxForce(20.0f);
@endverbatim
*/

class SPR_DLL HISpidar3: public HIForceDevice3D{
public:

	typedef HIForceDevice3D superclass;
protected:
	Vec3f pos;
	Vec3f force;
	///	[^
	HISpidarMotor motor[3];
	///	ʂ̂ǂ瑤gp邩
	bool bLeft;

public:
	///
	HISpidar3();
	///	foCX̃^Cv
	HIOBJECTDEF(HISpidar3);
	///
	virtual ~HISpidar3();
	///	foCX̏(gpOɌĂ)
	virtual bool Init(DVDeviceManager& dev);
	///	foCX̏(gpOɌĂ)
	virtual bool Init(DVDeviceManager& dev, Vec3f* motorPos, float vpn, float lpp, float minF, float maxF, bool bLeft);
	///	Lu[V̑Oɍs
	virtual bool BeforeCalib(){ SetMinForce(); return true; }
	///	Lu[V
	virtual bool Calib();
	///	ȈՃLu[V(_ł͂ȂC[^3̏dSŃLu[V)
	virtual bool EasyCalib();
	///	Œᒣ͂o
	void SetMinForce();
	///	͂̏o
	virtual void SetForce(const Vec3f& f){ SetForce(f, 0.1f); }
	virtual void SetForce(const Vec3f& f, float gamma);
	///	foCX݈̌ʒuԂ
	virtual Vec3f GetPos(){ return pos; }
	///	foCX̖ڕW͏o͂Ԃ
	virtual Vec3f GetForce(){ return force; }
	///	foCX̏ԂXV.
	virtual void Update(float dt);

	Vec3f CalcForce(Vec3f *f);
	
	HISpidarMotor* Motor(){
		return motor;
	}

};


}	//	namespace Spr
#endif

