#ifndef HISPIDAR4D_H
#define HISPIDAR4D_H

#include "HIHapticDevice.h"
#include "HISpidarMotor.h"

#include "Device/DVDeviceManager.h"
#include <vector>

namespace Spr {

/**	4{SPIDAR.
	̒WvZsAo͂͊oe[^
	o͂vZ肷Bo͂̌vZ2v@pĂ邽߁C
	HIS/Fortran  libF77.lib libI77.lib QuadPR.lib KvD
@verbatim
SPIDAR̒萔̐ݒ
Init(dev, motPos, 0.5776, 2.924062107079e-5f, 0.5f, 20.0f);

//	[^̎tʒu. [^̂ɎtĂꍇ́C
#define PX	0.265f	//	x̕ӂ̒/2
#define PY	0.265f	//	y̕ӂ̒/2
#define PZ	0.265f	//	z̕ӂ̒/2
Vec3f motorPos[][4] =	//	[^̎tʒu(S_Ƃ){
	{Vec3f(-PX, PY, PZ),	Vec3f( PX, PY,-PZ), Vec3f(-PX,-PY,-PZ), Vec3f( PX,-PY, PZ)},
	{Vec3f( PX, PY, PZ),	Vec3f(-PX, PY,-PZ), Vec3f( PX,-PY,-PZ), Vec3f(-PX,-PY, PZ)}
};

//	Pj[go߂DȀo͓d[V/N]
//	maxon:		0.008[m] / 0.0438[Nm/A] / 0.5[A/V] =  0.365296803653
//	t@:	0.008[m] / 0.0277[Nm/A] / 0.5[A/V] =  0.5776
sp->VoltPerNewton(0.5776f);

//	PJEg̒ [m/plus]	l: 2.924062107079e-5f
sp->LenPerPlus(2.924062107079e-5f);

//	ŏ [N]
sp->MinForce(0.5f);

//	ő咣 [N]
sp->MaxForce(20.0f);
@endverbatim
*/

class SPR_DLL HISpidar4D: public HIForceDevice3D{
public:
	HIOBJECTDEF(HISpidar4D);

	typedef HIForceDevice3D superclass;
protected:
	Vec3f pos;
	///	ʒuvZ邽߂̒萔
	Vec3f posSqrConst;
	///	ʒuvZ邽߂̍s
	Matrix3f matPos;
	Vec3f phi[4];
	float tension[4];	// computed tension
	
protected:
	///	[^
	HISpidarMotor motor[4];

	/**	o͉\ȗ͂vZȀo͂̓_vZ.
		@param disable	gpȂ̔ԍ
		@param f		o͂. o͉\ȗ͂ɕύX.
		@param v3Str	4{̎̌
		@return _(͂̐mƃ[^o͂̑傫Ō܂B
				̎I邱Ƃ̐)	*/
	float AvailableForce(int disable, Vec3f& f, Vec3f* v3Str);
	///	ʒuvZ邽߂̍s̏
	void InitMat();

public:
	///
	HISpidar4D();
	///
	virtual ~HISpidar4D();
	///	foCX̏(gpOɌĂ)
	virtual bool Init(DVDeviceManager& dev);
	///	foCX̏(gpOɌĂ)
	virtual bool Init(DVDeviceManager& dev, Vec3f* motorPos, float vpn, float lpp, float minF, float maxF);
	///	Lu[V̑Oɍs
	virtual bool BeforeCalib(){ SetMinForce(); return true; }
	///	Lu[V
	virtual bool Calib();
	///	Œᒣ͂o
	void SetMinForce();
	///	͂̏o
	virtual void SetForce(const Vec3f& f){ SetForce(f, 0.1f); }
	virtual void SetForce(const Vec3f& f,float eff){ SetForce(f, eff, 0.0f); }
	virtual void SetForce(const Vec3f& f, float eff, float cont);
	///	foCX̏ԂXV.
	virtual void Update(float dt);
	virtual Vec3f GetForce();
	virtual Vec3f GetPos(){ return pos; }

	HISpidarMotor* Motor(){
		return motor;
	}

};


}	//	namespace Spr
#endif

