#ifndef HDSPIDARFISHING_H
#define HDSPIDARFISHING_H

#include "HIHapticDevice.h"
#include "HISpidarMotor.h"
#include "Device/DVPioBase.h"
#include "Device/DVDeviceManager.h"
#include "HISpidarCalc3Dof.h"

namespace Spr {;

/**	@JA	GhGtFN^(Obv)̂6RxSPIDARD̖{͉ρD
	@EN	A SPIDAR with a 6DOF solid grip. The number of the strings is variable.@@*/
class SPR_DLL HISpidarFishing: public HIForceDevice3D,public HISpidarCalc3Dof{
public:
	std::vector<HISpidarMotor> motor;	///<	[^
	std::vector<DVPioBase*> button;	///<	{^

		///	foCX̃^Cv
	HIOBJECTDEF(HISpidarFishing);

	HISpidarFishing();
	bool Init(DVDeviceManager& dev);
	virtual double  GetLength(int);

	///	foCX̏(gpOɌĂ)
//	bool Init(DVDeviceManager& dev, int nMotor, const Vec3f(* motorPos)[2], float vpn, float lpp, float minF, float maxF);
	///	Lu[V̑Oɍs
	virtual bool BeforeCalib(){ SetMinForce(); return true; }
	///	Lu[V
	virtual bool Calib();
	///	Œᒣ͂o
	void SetMinForce();
	
	///	ʒu̎擾
	Vec3f GetPos(){ return pos; }
	///	px̎擾
//	Quaternionf GetOri(){ return ori; }
	
	///	͂̐ݒ
	void SetForce(const Vec3f& f){ HISpidarCalc3Dof::SetForce(f); }
	///	gN̐ݒ
//	void SetForce(const Vec3f& f, const Vec3f& t){ HISpidarCalc6Dof::SetForce(f, t); }
	///	dݕt̐ݒ
	void SetWeight(float s=0.3f, float t=1.0f){ smooth=s; lambda_t=t; }

	///	͂̎擾
	Vec3f GetForce(){ return trnForce; }
	///	gN̎擾
//	Vec3f GetTorque(){ return rotForce; }

	/// {^̎擾
	int HISpidarFishing::GetButton(int ch){
		if(button[ch]) return button[ch]->Get();
		else return 0;
	}

	///	foCX̏ԂXV.
	virtual void Update(float dt);
	virtual void Update(){ HISpidarCalc3Dof::Update(); }

protected:
	virtual void MakeWireVec();					///<	CxNǧvZ
	virtual void UpdatePos();					///<	CݒuʒuW̍XV
	virtual void MeasureWire();					///<	Čv
};

}	//	namespace Spr
#endif



/*#ifndef HDSPIDARFISHING_H
#define HDSPIDARFISHING_H

#include "HISpidarG6.h"

namespace Spr {;

/**	Spidar-G CType
	t[̃TCY⃂[^̕܂	*/

/*
class SPR_DLL HISpidarFishing: public HISpidarG6{
public:
	///	foCX̃^Cv
	HIOBJECTDEF(HISpidarFishing);

	HISpidarFishing();
	bool Init(DVDeviceManager& dev);
	virtual double  GetLength(int);

};

}	//	namespace Spr
#endif

*/