#ifndef VR_HAPTIC_HDSPIDARMOTOR_H
#define VR_HAPTIC_HDSPIDARMOTOR_H

#include "Base/Affine.h"
#include "Device/DVDaBase.h"
#include "Device/DVAdBase.h"
#include "Device/DVCounterBase.h"

namespace Spr {

class SPR_DLL HISpidarMotor{
public:
	///	@name	[^ɂĂ̒萔
	//@{
	///	őo(N)
	float maxForce;
	///	ŏo(N)
	float minForce;
	///	D/Ȁo͓d / [^̏o  (V/N)
	float voltPerNewton;
	///	[^ɗd / D/Ȁo͓d
	float currentPerVolt;
	///	̒ / pX
	float lengthPerPulse;
	///	[^tĂʒu(̏o)̍W
	Vec3f pos;
	///	ObvɎtĂʒu
	Vec3f jointPos;
	//
	//@}

	//@{	foCXANZX
	///	gpD/A.
	DVDaBase* da;
	///	gpGR[_̃JE^.
	DVCounterBase* counter;
	///	gpA/D.
	DVAdBase* ad;
	//@}
	///	o͂
	float force;

	//@{	[^萔(REtNd́ERC萔)̃Lu[V
	float voltageInt;	///<	[^[qԓd̐ϕ
	float currentInt;	///<	[^d̐ϕ
	float timeInt;		///<	ϕԂ̎
	float currentLast;	///<	vJñ[^d
	float lengthLast;	///<	vJn̎̒
	float vdd;			///<	dd
	PTM::VMatrixCol<float> calibMat;
						///<	Lu[Vpf[^
	PTM::VVector<float> calibVec;
						///<	Lu[Vpf[^
	Vec4f calibResult;	///<	Lu[V (R, L, E)
	//@}
public:
	///	
	HISpidarMotor();
	///	
	virtual ~HISpidarMotor(){}
	///	o͂̐ݒ
	void SetForce(float f){
		if(f < minForce) f = minForce;
		if(f > maxForce) f = maxForce;
		if(da) da->Voltage(f * voltPerNewton);
		force = f;
	}
	///	ۂɏo͂͂̎擾
	float GetForce(){
		return force;
	}
	///	dl̎擾
	float GetCurrent(){
		return force * voltPerNewton * currentPerVolt;
	}
	///	݂̎̒̐ݒ
	void SetLength(float l){ if(counter) counter->Count(long(l / lengthPerPulse)); }
	///	݂̎̒
	float GetLength(){
		if(counter) return counter->Count() * lengthPerPulse;
		else return 0;
	}
	///	x̌v
	float GetVelocity();
	///	[^萔̃Lu[V̂߂̌v (100񂭂炢Ăł)
	void GetCalibrationData(float dt);
	///	[^萔̃Lu[V (ĂŃLu[V)
	void Calibrate(bool bUpdate);
	///	dďv
	void GetVdd();
};

}	//	namespace Spr
#endif
