#ifndef HID_STEPWALK_H
#define HID_STEPWALK_H
#include <WinBasis/WBWin.h>

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <Device/DVDeviceManager.h>
#include <Device/DVAdBase.h>
#include <Base/Affine.h>

 namespace Spr{;
using namespace std;

#define SENSOR4 //ZT[4̂Ƃ

class SPR_DLL HIStepWalk{
	//	f[^őlƍŏlŐKNXD
	class SPR_DLL Sensor{
	public:
		float offsetMin;//LuCVpɐVɍ
		float offsetMax;// 2002/6/18
//		float offset; //L̑O܂ō]̃vOŎgĂ
		float scale;
		float rawCur;
		float cur;
	public:
		Vec2f pos;	//	ZT̈ʒu([gP)
		DVAdBase* ad;
		Sensor(){
//			offset = 2.5f;
			offsetMin = 0.5f;//liKj
			offsetMax = 1.0f;//liKj
			scale = 2.0f;//liK?j
			rawCur = 0;
			cur = 0;
			ad = NULL;
		}
		void CalibMin(){
			if (ad) rawCur = ad->Voltage();
			if (rawCur < offsetMin) offsetMin = rawCur;
		}
		void CalibMax(){
			if (ad) rawCur = ad->Voltage();
			if (rawCur > offsetMax) offsetMax = rawCur;
		}
		///	K̒lԂ(01).
		float Get(){
			if (ad) rawCur = ad->Voltage();
			cur = (rawCur - offsetMin) / scale;
//			if (cur > 1) cur = 1; //1傫ȂĂ񂶂ȂH
//			if (cur < 0) cur = 0; //0菬ȂĂ񂶂ȂH
//			std::cout << "cur = " << cur << std::endl;
			return cur;
		}
		/*]񂪍2002/6/18LɕύX
		void Calib(){
			if (ad) rawCur = ad->Voltage();
			if (rawCur < offset) offset = rawCur;
		}
		///	K̒lԂ(01).
		float Get(){
			if (ad) rawCur = ad->Voltage();
			cur = (rawCur - offset) / scale;
			if (cur > 1) cur = 1;
			if (cur < 0) cur = 0;
			return cur;
		}
		*/
	};

public:
	Vec2f cogAve, cog, direction;
	float inner, resultOfInner[3], memoryOfInner;

	HIStepWalk();
	virtual ~HIStepWalk();
	///	
	bool Init(DVDeviceManager& devMan);
	///	{́D20msƂɌĂяoD	
	void Step(float);
	float GetVelocity(){ return walkVel; }
	float GetPitch(){ return pitch; }
	float GetPitchParam(){ return pitchParam; }
	void  SetPitchParam(float p){ pitchParam = p; }
	Vec2f GetDirection(){ return direction; }
	void SetDirection(Vec2f vector){ direction = vector; }
	int GetStep(){ return step; }
	void Print(std::ostream& os) const;
	float GetSensorVoltage(int n){ return sensor[n].Get(); }
	///LuCVp
	void PSenRange();
	void PSenMax();
	void PSenMin();
	void SetCenterOfGravity(Vec2f& centerG);
	Vec2f GetCenterOfGravity(){ return centerOfGravity[0]; };
	void PSenCal();
	bool pSenCal; 
	bool printForCenterG;
	bool rotateSwitch;
	void SetThreshold(float t) { threshold = t; }
	void CloseSIGGRAPHFile();

	void DataOutput(float x, float y, float z);

	std::ofstream *dataFileSIGGRAPH;
	char* folderName;
	char folderNameBack[20];
	int fileNameTime;
	char fileTime[10];

	float jumpPower;
	void SetJump(float& jump);


protected:

	bool SideStep();				///TChXebv̌o
	Vec2f walkingDirection;			///̓ZT݂̂猟oꂽ݂̑ݕ
	Vec2f gravityDiff;				///݂̏dŚiς猩jʒu	
	int sideStep;					///TChXebv
	bool frontCheck;				///ʂĂ邩̃`FbN
	float frontGap;					///`FbN̍ېʂǂꂭ炢̃Y𖳎邩

	DWORD dwLastTime;               ///<    StepWalkOĂяoꂽ̃JEg
	DWORD dwTime;                   ///<    StepWalkĂяoꂽ̃JEg
	int step;						///<	
	int backStep;                   ///<    ɐi
	bool BackStep(float value);     ///<    ɐiނǂf
	float walkVel;					///<	sx	
	unsigned long dwInterval;		///<	݊Ԋu
	unsigned long dwStepTime;		///<	݂ouԂ̎
	float pitch;					///<	dwInterval̋t
	float pitchParam;               ///<    pitcḧړpϐ
	bool flag_SIGGRAPH;             ///<    SIGGRAPHf[^悤tO 
	float threshold;                ///<    ړ臒l
	///	ZT[, OCCE3̃ZT[
#ifndef SENSOR4
	enum {NSENSOR = 3};
#else
	enum {NSENSOR = 4};
#endif
	///	OCCẼZT[
	Sensor sensor[NSENSOR];

	///	̐
	enum {CENTER_OF_GRAVITY_LEN = 6};
	///	dS̍W(܂)
	Vec2f centerOfGravity[CENTER_OF_GRAVITY_LEN];
	///	dS̈ړx
	float dCenterOfGravity;
};

}

#endif
