#ifndef UPP_H
#define UPP_H
#include <Base/BaseDebug.h>
#include <vector>

namespace Spr {

/**	UPP(Universal Pulse Processor)̃hCo[.
	CRatorUppCard, CPCCardDriverg	*/
class SPR_DLL DRUpp{
public:
	class SPR_DLL UppFunc
	{
	public:
		///	UPP̖ߌ
		enum {	FRS = 0x00, INS = 0x10, UDS = 0x20, GTS = 0x30,
			FRC = 0x40, INC = 0x50, PWC = 0x60, OSC = 0x70,
			FFC = 0x80, TPC = 0x98, GTC = 0xA0, CTO = 0xB0,
			SIT = 0xC0, SOT = 0xD0, SPO = 0xE0, NOP = 0xF0};
		///	UPP̖ߌ̃IvV
		enum {};
		///	[q̃GbWo
		enum {};
		enum {IDLEN = 20};
		///	߂ʂ邽߂IDA̖߂𖽗ߕ\폜邽߂ɗp
		char id[IDLEN+1];
			
		///	UPP
		int cmd, ar, br, ioa, iob, ioc, iod;
	
		/**	RXgN^.
		@param aCmd		
		@param anAr		AWX^
		@param anBr		BWX^
		@param anIoa	[qA
		@param anIob	[qB
		@param anIoc	[qC
		@param anIod	[qD
		@param anId		ʕ(ȗ)	*/
		UppFunc(int aCmd = NOP, int anAr = 0, int anBr = 0,
			int anIoa = 0, int anIob = 0, int anIoc = 0, int anIod = 0, char* anId = "");
		bool operator ==(const UppFunc& f) const;
		bool operator <(const UppFunc& f) const;
		bool operator >(const UppFunc& f) const;
		bool operator !=(const UppFunc& f) const;
	};
protected:
	///	UPPWX^̃AhX
	enum {PORT1 = 0x3, PORT2 = 0x2, UDR_BASE=0x40};
	///	ς݂Ȃ true.
	bool bInitalized;
	///	FNR̕\

	static int FNR[17];
	///	UPP̖ߕ\UPPɐݒ肷
	void SetFunc();
	///	UPP̖ߕ\

	std::vector<UppFunc> func;
public:
	/// 
	DRUpp();
	/// 
	virtual bool Init();
	///	UPP̃WX^̃AhX a ɒl v 
	virtual void Out(unsigned a, unsigned v)=0;
	///	UPP̃WX^̃AhX a ̒lǂݏo
	virtual int In(unsigned a)=0;
	///	UPP̎sԂ̎擾
	bool	Run();
	/**	UPP̏Ԃݒ肷.
	@param b ݒ肵. true:s false:~	*/
	void	Run(bool b);
	///	ߕ\ɖ߂ǉ
	void	Add(const UppFunc& f);
	///	ߕ\疽߂폜
	void	Del(char* id);
	///	ߕ\疽߂폜
	void	Del(int id);
	
	/**	UPP̒[qgp郆jbg̐ݒ.
	1bitڂ|[g0ɁA16bitڂ|[g0ɑΉB
    @verbatim
	UPP̒[qƃrbg̊蓖
	0xABCD
	dir  MSB 0x   A    B    C    D LSB
	port       FEDC BA98 7654 3210
	@endverbatim
	0: PIOgp	1: UPPgp	*/
	void	PortOwner(unsigned owner = 0xFFFF);
	/**	UPP̒[q̓o͂̐ݒ.
	1bitڂ|[g0ɁA16bitڂ|[g0ɑΉB
    @verbatim
	UPP̒[qƃrbg̊蓖
	0xABCD
	dir  MSB 0x   A    B    C    D LSB
	port       FEDC BA98 7654 3210
	@endverbatim
	0: 	1: o	*/
	void	PortDir(unsigned dir = 0x0000);
	///	PIO̒l(PortOwnerPIOɂȂĂ[q̂ݎgpł)
	unsigned short PioRead();
	///	PIO֒lo(PortOwnerPIOɂȂĂ[q̂ݎgpł)
	void	PioWrite(unsigned short d);
	/**	UPP Data Register ̒lݒ.
	@param	no	UDR̔ԍ(0-23)
	@param	v	l	*/
	void	UdrWrite(unsigned no,unsigned short v);
	/**	UPP Data Register ̒l̓ǂݏo.
	@param	no	UDR̔ԍ(0-23)
	@return		l	*/
	unsigned short	UdrRead(unsigned no);
};
}	//	namespace Spr
#endif
