#include "HumanInterface.h"
#pragma hdrstop
#include "HIMouse6D.h"

namespace Spr {;
IF_OBJECT_IMP(HIMouse6D, HIPose);

bool HIMouse6D::Init(HISdkIf* sdk, const void* desc){
	HIVirtualDeviceIf* vd = sdk->RentVirtualDevice("KeyMouse");
	keyMouse = DCAST(DVKeyMouse, vd);
	if (!keyMouse) return false;
	keyMouse->SetHandler(this);

/*	oldX = oldY = newX = newY = 0;
	btnState = NONE;

	// ftHg̐ݒ
	scaleTransPointer = 0.01f;
	scaleRotPointer = 0.008f;
	scaleTransAxis = 0.03f;
	scaleRotAxis = 0.008f;
	mass = 0.25f;
	pos = Vec3f();
	ori = Quaternionf();
	axis.Pos() = Vec3f(0, 0, -10);
    axis.LookAt(Vec3f(), Vec3f(0,1,0));
	axis = axis.inv();
	axisInit = axis;
	// }EXANeBuǂ̌o@悭킩Ȃ̂łƂ肠trueɂĂ
	bGood = true;	
*/
//-> ֌ɂύX (2005/1/05)
	SetViewSize(640, 480);
//<-

	return true;
}

void HIMouse6D::SetScale(float tp, float rp, float ta, float ra){
	scaleTransPointer = tp;
	scaleRotPointer = rp;
	scaleTransAxis = ta;
	scaleRotAxis = ra;
}

//-> ֌ɂύX (2005/1/05)
void HIMouse6D::SetViewSize(float inWidth, float inHeight){
	//	VirtualTrackBallɂView̑傫̃p[^
	//	K{Ȃ߁AZbg邽߂̃o֐

	viewCenterX = inWidth / 2;
	viewCenterY = inHeight / 2;

	//	View̒ZVirtualTrackBall̔aƂ
	float	d;
	if (viewCenterX < viewCenterY)
		d = viewCenterX;
	else
		d = viewCenterY;
	trackBallRadius = d * 1.0f;
}

Vec3f HIMouse6D::GetTrackBallRotation(float inX, float inY){
	//	NbNꂽ|CgVirtualTrackBall
	//	_Ƀ}bsO邽߂̃o֐

	Vec3f	v;
	float	d;

	//	TrackBall̒S_ƂȂ悤ɂAȂ
	//	a1ƂȂ悤ɍW𐳋K
	v.x = 1.0f * (inX - viewCenterX) / trackBallRadius;
	v.y = -1.0f * (inY - viewCenterY) / trackBallRadius;
	v.z = 0.0f;

	//	x, y܂̂ž
	d = v.x * v.x + v.y * v.y;
	if (d < 1.0)
	{
		v.z = (float)sqrt(1.0 - d);
	}
	else
	{
		d = sqrt(d);
		v.x = v.x / d;
		v.y = v.y / d;
		v.z = 0;
	}

	return v;
}
//<-

void HIMouse6D::Update(float dt){

	// force,torqueɊÂpos,oriXV
	// ƂƌvZقȂ
	pos += force * dt * dt / mass /2;
	torque	= ori.Inv() * torque;
	Vec3f drot;
	drot = torque * dt * dt / mass;
	float norm = drot.norm();
	if(norm > 1.0e-10){
		ori = Quaternionf::Rot(norm, drot) * ori;
		ori.unitize();
	}

	if(btnState != NONE){
		// OXebṽ}EẌʒuƂ̍
		float dx, dy;
		dx = float(newX - oldX);
		dy = float(newY - oldY);

		// hbOɂē̊
		Affinef afAxis = axis.inv();		

		if (btnState == (DVKeyMouseHandler::SHIFT+ DVKeyMouseHandler::LBUTTON) ){

//-> ֌ɂύX (2005/1/05)

			//	Virtual Track Ball̎
			//		ϊ̉e𖳎i܂蕽sej
			//		ɂ񂿂Virtual Track Ballł邪A
			//		ƓĂ悤Ɋ̂ł悵ƂB
			//		i炭se肵Ƃɂ덷
			//		ł邭炢ł낤...j
			Vec3f	oldRot = GetTrackBallRotation((float)oldX, (float)oldY);
			Vec3f	newRot = GetTrackBallRotation((float)newX, (float)newY);
			Vec3f	rotAxis, rotDirection;
			float	rotVelocity;

			rotDirection = newRot - oldRot;
			rotVelocity = rotDirection.norm();

			if (rotVelocity > 0.001)
			{
				rotAxis = cross(newRot, oldRot);
				rotAxis = afAxis.Rot() * rotAxis;
				rotAxis.unitize();

				afAxis = Affinef::Rot(rotVelocity * 1.0f, rotAxis) * afAxis;
				axis = afAxis.inv();
			}

			//-> IWi
			// Shift + hbÔƂ͊Wx,y𒆐SɃJ]
			//afAxis = Affinef::Rot(dx*scaleRotAxis, afAxis.Ey()) * Affinef::Rot(dy*scaleRotAxis, afAxis.Ex()) * afAxis;
			//axis = afAxis.inv();
			//<- ܂Ł@iIWij
//<-
		}
		else if (btnState == (DVKeyMouseHandler::SHIFT + DVKeyMouseHandler::MBUTTON) ){
			// Shift + hbÔƂ͊Wx-zʂŕsړ
			afAxis.Pos() += (-afAxis.Ex() * dx - afAxis.Ez() * dy) * scaleTransAxis;	
			axis = afAxis.inv();
		}
		else if (btnState == (DVKeyMouseHandler::SHIFT + DVKeyMouseHandler::LBUTTON + DVKeyMouseHandler::RBUTTON) ) {
			// Shift + EhbÔƂ͊Wx-zʂŕsړ
			afAxis.Pos() += (-afAxis.Ex() * dx - afAxis.Ez() * dy) * scaleTransAxis;
			axis = afAxis.inv();
		}
		else if (btnState == (DVKeyMouseHandler::SHIFT + DVKeyMouseHandler::RBUTTON + DVKeyMouseHandler::MBUTTON) ) {
			// Shift + EhbÔƂ͊Wy-zʂŕsړ
			afAxis.Pos() += (-afAxis.Ey() * dx - afAxis.Ez() * dy) * scaleTransAxis;
			axis = afAxis.inv();
		}
		else if (btnState == (DVKeyMouseHandler::SHIFT + DVKeyMouseHandler::RBUTTON) ){
			// Shift + EhbÔƂ͊Wx-yʂŕsړ
			afAxis.Pos() += (-afAxis.Ex() * dx + afAxis.Ey() * dy) * scaleTransAxis;	
			axis = afAxis.inv();
		}
		else if (btnState == DVKeyMouseHandler::LBUTTON) {
			// hbÔƂ͊Wx,y𒆐SɃ|C^]
			ori = Quaternionf::Rot(dx*scaleRotPointer, -afAxis.Ey()) * Quaternionf::Rot(dy*scaleRotPointer, -afAxis.Ex()) * ori;
		}
		else if (btnState == DVKeyMouseHandler::MBUTTON) {
			// hbÔƂ͊Wx-zʂŃ|C^𕽍sړ
			Vec3f up(0,1,0);
			Vec3f ex = afAxis.Ex();
			ex = (ex - (ex*up)*ex).unit();
			Vec3f ez = afAxis.Ez();
			ez = (ez - (ez*up)*ez).unit();
			pos += (ex * dx + ez * dy) * scaleTransPointer;
		}
		else if (btnState == DVKeyMouseHandler::LBUTTON + DVKeyMouseHandler::RBUTTON) {
			// EhbÔƂ͊Wx-zʂŃ|C^𕽍sړ
			Vec3f up(0,1,0);
			Vec3f ex = afAxis.Ex();
			ex = (ex - (ex*up)*ex).unit();
			Vec3f ez = afAxis.Ez();
			ez = (ez - (ez*up)*ez).unit();
			pos += (ex * dx + ez * dy) * scaleTransPointer;
		}
		else if (btnState == DVKeyMouseHandler::RBUTTON + DVKeyMouseHandler::MBUTTON) {
			// EhbÔƂ͊Wy-zʂŃ|C^𕽍sړ
			Vec3f up(0,1,0);
			Vec3f ez = afAxis.Ez();
			ez = (ez - (ez*up)*ez).unit();
			pos += (up * dx + ez * dy) * scaleTransPointer;
		}
		else if (btnState == DVKeyMouseHandler::RBUTTON) {
			Vec3f up(0,1,0);
			Vec3f ex = afAxis.Ex();
			ex = (ex - (ex*up)*ex).unit();
			// EhbÔƂ͊Wx-yʂŃ|C^𕽍sړ
			pos += (ex * dx - up * dy) * scaleTransPointer;
		}

		oldX = newX;
		oldY = newY;

		//DSTR << "(x, y, z) = (" << pos.x << ", " << pos.y << ", " << pos.z << ")" << std::endl;
	}
	HIPose::Update(dt);
}
#ifdef _WIN32
}	//	namespace Spr;
#define WIN32_LEAN_AND_MEAN        // Windows wb_[gpĂȂO܂B
#define WINVER 0x0500            //    o[W` Windows2000ȏ
#define _WIN32_WINNT WINVER
#include <Windows.h>
namespace Spr{;

bool HIMouse6D::PreviewMessage(void* m){
	MSG* msg = (MSG*)m;
	switch (msg->message){
	case WM_LBUTTONDOWN:
	case WM_MBUTTONDOWN:
	case WM_RBUTTONDOWN:{
		int x = (short)LOWORD(msg->lParam);  // horizontal position of cursor 
		int y = (short)HIWORD(msg->lParam);  // vertical position of cursor 
		OnButtonDown(x, y);
		SetCapture(msg->hwnd);
		}break;
	case WM_LBUTTONUP:
	case WM_MBUTTONUP:
	case WM_RBUTTONUP:
		ReleaseCapture();
		OnButtonUp();
		break;
	case WM_MOUSEMOVE:{
		unsigned fwKeys = msg->wParam;  // key flags 
		int x = (short)LOWORD(msg->lParam);	// horizontal position of cursor 
		int y = (short)HIWORD(msg->lParam);	// vertical position of cursor 
		OnButtonMove(fwKeys, x, y);
		//DSTR << "mouse:" << x << " " << y << std::endl;
		}break;
	case WM_MOUSEWHEEL:{
		unsigned fwKeys = LOWORD(msg->wParam);    // key flags
		int zDelta = (short) HIWORD(msg->wParam);    // wheel rotation
		int xPos = (short) LOWORD(msg->lParam);    // horizontal position of pointer
		int yPos = (short) HIWORD(msg->lParam);    // vertical position of pointer
		OnWheel(fwKeys, zDelta);
		}break;
	case WM_LBUTTONDBLCLK:
	case WM_MBUTTONDBLCLK:
	case WM_RBUTTONDBLCLK:{
		unsigned fwKeys = msg->wParam;        // key flags 
		int x = (short)LOWORD(msg->lParam);  // horizontal position of cursor 
		int y = (short)HIWORD(msg->lParam);  // vertical position of cursor 
		OnDblClick(fwKeys, x, y);
		}break;
	case WM_KEYDOWN:{
		int nVirtKey = (int) msg->wParam;
		long lKeyData = msg->lParam;
		return OnKeyDown(nVirtKey);
		}break;
	default:
		return false;
	}
	return true;
}
bool HIMouse6D::OnKeyDown(unsigned nChar){
	//	_ړ֌W
	
	Affinef afBody = GetAxis().inv();
	float df = 0.2f ; //ړω
	// J̕sړ
	if ( nChar == 'W' ) afBody.Pos() = afBody.Pos() + afBody.Ex() * df;
	else if ( nChar == 'Q' ) afBody.Pos() = afBody.Pos() - afBody.Ex() * df;
	else if ( nChar == 'A' ) afBody.Pos() = afBody.Pos() + afBody.Ey() * df;
	else if ( nChar == 'Z' ) afBody.Pos() = afBody.Pos() - afBody.Ey() * df;
	else if ( nChar == VK_DOWN ) afBody.Pos() = afBody.Pos() + afBody.Ez() * df;
	else if ( nChar == VK_UP ) afBody.Pos() = afBody.Pos() - afBody.Ez() * df;
	// J̉]
	else if ( nChar == VK_LEFT ) afBody = Affinef::Rot(Radf(5), 'y') * afBody;
	else if ( nChar == VK_RIGHT ) afBody = Affinef::Rot(Radf(-5), 'y') * afBody;
	else if ( nChar == 'S' ) afBody = Affinef::Rot(Radf(5),afBody.Ex()) * afBody;
	else if ( nChar == 'X' ) afBody = Affinef::Rot(Radf(-5),afBody.Ex()) * afBody;
	else if ( nChar == 'C' ){	// |C^ƃJZbg
		afBody = axisInit.inv();
		afBody.Ex().unitize();
		afBody.Ey().unitize();
		afBody.Ez().unitize();
		pos = Vec3f();
		ori = Quaternionf();
	}
	else return false;	
	SetAxis(afBody.inv());
	return true;
}
#endif

void HIMouse6D::OnButtonDown(int x, int y){
	oldX = newX = x;
	oldY = newY = y;
}	

void HIMouse6D::OnButtonUp(){ 
	btnState = NONE;
	oldX = newX;
	oldY = newY;
}

void HIMouse6D::OnButtonMove(UINT state, int x, int y){ 
	// Ă{^̏Ԃݒ
	btnState = (ButtonState)state; 

	newX = x;
	newY = y;
}

void HIMouse6D::OnDblClick(unsigned fwKeys, int x, int y){
	if (fwKeys & DVKeyMouseHandler::LBUTTON) OnLButtonDClick();
	if (fwKeys & DVKeyMouseHandler::RBUTTON) OnRButtonDClick();
}

/// |C^̎p
void HIMouse6D::OnLButtonDClick(){
	ori = Quaternionf();
}

/// |C^̈ʒu
void HIMouse6D::OnRButtonDClick(){
	pos = Vec3f();
}

/// ẄʒuEp
void HIMouse6D::OnShiftLButtonDClick(){
	axis = axisInit;
}

/// zC[܂킵Ƃ̏(|C^orWZɐړ)
void HIMouse6D::OnWheel(UINT state, short dz){
	btnState = (ButtonState)state;	

	Affinef afAxis = axis.inv();		
	if (btnState == DVKeyMouseHandler::SHIFT){
		afAxis.Pos() += afAxis.Ez() * dz * scaleTransAxis;	
		axis = afAxis.inv();
	} else if (btnState == NONE){
		pos += -afAxis.Ez() * dz * scaleTransPointer;
	}
}

}	//	namespace Spr

