/*
 *  Copyright (c) 2003-2006, Shoichi Hasegawa and Springhead development team 
 *  All rights reserved.
 *  This software is free software. You can freely use, distribute and modify this 
 *  software. Please deal with this software under one of the following licenses: 
 *  This license itself, Boost Software License, The MIT License, The BSD License.   
 */
#ifndef PHCONSTRAINT_H
#define PHCONSTRAINT_H

#include <SprPhysics.h>
#include <Physics/PHContactDetector.h>
#include <Physics/PHSpatial.h>

namespace Spr{;

class PHTreeNode;

class PHConstraint : public SceneObject, public PHConstraintIfInit{
public:
	OBJECTDEF_ABST(PHConstraint, SceneObject);
	enum PHControlMode{
		MODE_TORQUE,
		MODE_POSITION,
		MODE_VELOCITY
	} mode;

	PHScene*			scene;
	PHConstraintEngine* engine;

	bool		bEnabled;			///< LĂꍇtrue
	bool		bFeasible;			///< ̍̂undynamicalȏꍇtrue
	bool		bArticulated;		///< ֐ߌn\Ăꍇtrue
	bool		bInactive[2];		///< ͖̂@ɏ]ꍇtrue	
	PHSolid*			solid[2];	///< S鍄
	SpatialTransform	Xj[2];		///< ̂ɑ΂\PbgCvÖʒuƌ
	SpatialTransform	Xjrel;		///< \Pbgɑ΂vÖʒuƌ
	SpatialVector		vjrel;		///< \Pbgɑ΂vȎΑx
	
	SpatialTransform	Js[2];		///< SRrA SpatialTranform`
	SpatialMatrix		J[2];		///< SRrA s`
	SpatialMatrix		AinvJ[2];
	SpatialMatrix		T[2];
	
	SpatialVector f;				///< S̗͂͐
	SpatialVector F;
	
	SpatialVector b, db, B;			///< LCPbxNgƂ̕␳
	SpatialVector A, dA, Ainv;		///< LCPAs̑ΊpƂ̕␳ʁCt
	SpatialVector scale;

	bool		constr[6];			///< S鎩Rx. ͈́ColE_pLȏꍇtrueƂȂ

	/* hNX̋@\	*/
	virtual void AddMotorTorque(){}							///< S͂Ɋ֐߃gNZ
	virtual void SetConstrainedIndex(bool* con){}			///< ǂ̎RxS邩ݒ
	virtual void ModifyJacobian(){}							///< ƎWngꍇ̃RrȀC
	virtual void CompBias(){}								///< 
	virtual void Projection(double& f, int k){}				///< S͂̎ˉe
	virtual void UpdateJointState(){}						///< ֐ߍẄʒuExXV
	virtual void CompError(){}								///< Correctionp̍S덷ݒ肷
	virtual void ProjectionCorrection(double& F, int k){}	///< 
	
	/// C^tF[X̎
	//virtual PHConstraintDesc::ConstraintType GetConstraintType(){ assert(0); return PHConstraintDesc::INVALID_CONSTRAINT; }
	virtual void Enable(bool bEnable = true){bEnabled = bEnable;}
	virtual bool IsEnabled(){return bEnabled;}
	virtual void SetInactive(int index = 0, bool Inaction = true){bInactive[index] = Inaction;}
	virtual bool IsInactive(int index = 0){return bInactive[index];}
	virtual void GetRelativePose(Posed& p){p.Pos() = Xjrel.r; p.Ori() = Xjrel.q;}
	virtual void GetRelativeVelocity(Vec3d& v, Vec3d& w){v = vjrel.v(); w = vjrel.w();}
	virtual void GetConstraintForce(Vec3d& _f, Vec3d& _t){_f = f.v(); _t = f.w();}
	virtual bool AddChildObject(ObjectIf* o);
	virtual size_t NChildObject();
	virtual ObjectIf* GetChildObject(size_t i);
	virtual void SetDesc(const void* desc);
	
	void	CompJacobian();
	void	SetupLCP();
	void	IterateLCP();
	void	UpdateState();
	void	CompResponseMatrix();
	void	CompResponseMatrixABA();
	void	SetupCorrectionLCP();
	void	IterateCorrectionLCP();
	
	PHConstraint();
};

class PHConstraints : public std::vector< UTRef<PHConstraint> >{
public:
	/// w肳ꂽ̂̑gɍpĂSԂ
	PHConstraint* FindBySolidPair(PHSolid* lhs, PHSolid* rhs){
		for(iterator it = begin(); it != end(); it++)
			if((*it)->solid[0] == lhs && (*it)->solid[1] == rhs)
				return *it;
		return NULL;
	}
};

}

#endif
