/*
 *  Copyright (c) 2003-2006, Shoichi Hasegawa and Springhead development team 
 *  All rights reserved.
 *  This software is free software. You can freely use, distribute and modify this 
 *  software. Please deal with this software under one of the following licenses: 
 *  This license itself, Boost Software License, The MIT License, The BSD License.   
 */
#ifndef PHEngine_H
#define PHEngine_H

#include <Foundation/Object.h>
#include "IfStubPhysics.h"
#include <SprPhysics.h>

namespace Spr {;


///	V[̐UirwCrAjǗGW
/// rwCrA̕ނƗD揇
///	100̔{͕ނ\Aȉ̈ʂ͂̒ł̎sK肷
enum PHBehaviorPriority{
	//W[
	SGBP_INITIALIZER			= 100,
		SGBP_SOLIDINITIALIZER,
		//SGBP_CLEARFORCE,
	//͐W[
	SGBP_FORCEGENERATOR			= 200,
		SGBP_GRAVITYENGINE,
		SGBP_COLLISIONENGINE,
		SGBP_PENALTYENGINE,
		SGBP_CREATURE,
		//SGBP_WATERCONTACTENGINE,
	//ϕ̑Ώ
	SGBP_DYNAMICALSYSTEM		= 300,
		SGBP_JOINTENGINE,
		SGBP_CONSTRAINTENGINE,
		SGBP_SOLIDCONTAINER,
		//SGBP_WATERENGINE,
	//
	SGBP_MOTION					= 400,
		//SGBP_CHANGEOBJECT,
		//SGBP_CONSTRAINT,
	//̃GW̃Xi
	SGBP_LISTENER				= 500,
		//SGBP_CONTACTENGINE,
		//SGBP_STICKENGINE,
		//SGBP_WARPENGINE,
};

class PHScene;
///	GW̊{NXD
class PHEngine:public SceneObject, public PHEngineIfInit{
	OBJECTDEF(PHEngine, SceneObject);
public:
	///	s߂vCIeBlDقǑ
	virtual int GetPriority() const { return SGBP_FORCEGENERATOR; }
	///	Ԃ dt i߂
	virtual void Step(){}
};
inline bool operator < (const PHEngine& e1, const PHEngine& e2){
	return e1.GetPriority() < e2.GetPriority();
}

///	PHEngine̔z
class PHEngines: std::vector< UTRef<PHEngine> >{
public:
	iterator initializer;
	iterator forceGenerator;
	iterator dynamicalSystem;
	iterator motion;
	iterator listener;
protected:
	friend class PHScene;
	PHScene* scene;

	iterator begin2() { return base::begin(); }
	iterator end2() { return base::end(); }
public:
	typedef std::vector< UTRef<PHEngine> > base;
	typedef base::iterator iterator;
	typedef base::const_iterator const_iterator;

	PHEngines();
	virtual ~PHEngines(){}
	
	const_iterator begin() const { return base::begin(); }
	const_iterator end() const { return base::end(); }
	size_t size(){ return base::size(); }
	size_t size() const { return base::size(); }
	UTRef<PHEngine>& operator [] (int id){ return base::begin()[id]; }
	const UTRef<PHEngine>& operator [] (int id) const { return base::begin()[id]; }
	///@name V~[Vi߂郁\bh
	//@{	
	///	͂̃NAD
	virtual void ClearForce();
	///	͂𐶐(vZ)
	virtual void GenerateForce();
	///	ODE(ϕ)D́xCxʒu ̌vZsD
	virtual void Integrate();
	//@}
	void Add(PHEngine* e);
	bool Del(PHEngine* e);
	void Sort();
	///	V[NAƂ̏
	virtual void Clear();
	///	w肵^pGW (ŏɌ̂Ԃ)
	PHEngine* FindInherit(const UTTypeInfo& tinfo, UTString name) const;
	PHEngine* FindInherit(const UTTypeInfo& tinfo) const;
	///	w肵^̔hNX̃GW (ŏɌ̂Ԃ)
	template <class T> bool Find(T*& t) const{
		t = (T*)FindInherit(*T::GetTypeInfoStatic());
		return t != NULL;
	}
	template <class T> bool Find(UTRef<T>& t) const{
		t = UTRef<T>((T*)FindInherit(*T::GetTypeInfoStatic()));
		return t != NULL;
	}
	///	w肵^̔hNX̃GWŖOv̂ (ŏɌ̂Ԃ)
	template <class T> bool Find(T*& t, UTString name) const{
		t = (T*)FindInherit(*T::GetTypeInfoStatic(), name);
		return t != NULL;
	}
	template <class T> bool Find(UTRef<T>& t, UTString name) const{
		t = UTRef<T>((T*)FindInherit(*T::GetTypeInfoStatic(), name));
		return t != NULL;
	}
};


}
#endif
