/*
 *  Copyright (c) 2003-2006, Shoichi Hasegawa and Springhead development team 
 *  All rights reserved.
 *  This software is free software. You can freely use, distribute and modify this 
 *  software. Please deal with this software under one of the following licenses: 
 *  This license itself, Boost Software License, The MIT License, The BSD License.   
 */
/**
 Springhead2/src/tests/Graphics/GRColorSpheres/main.cpp

yTvz
  OtBbNX_[NX DrawScene APIgAV[ꊇŃ_OB
  DrawScene API Őݒ肳Ă}eA}eATvpāAJtȃ{bNX_OB@
  
yIz
  E5000XebvɋIB 

 */
#include <Springhead.h>		//	Springhead̃C^tF[X
#include <ctime>
#include <string>
#include <GL/glut.h>
#ifdef USE_HDRSTOP
#pragma hdrstop
#endif
using namespace Spr;
#define ESC				27			// ESC key
#define EXIT_TIMER		7000		// sXebv
#define WINSIZE_WIDTH	480			// EBhETCY(width)
#define WINSIZE_HEIGHT	360			// EBhETCY(height)
#define NUM_SPHERES		100			// sphere

UTRef<GRSdkIf> grSdk;
GRDebugRenderIf* render;
GRDeviceGLIf* grDevice;

UTRef<PHSdkIf> phSdk;
PHSceneIf* scene;
PHSolidIf* soFloor;
std::vector<PHSolidIf*> soSphere; 


/**
 brief     	glutDisplayFuncŎw肵R[obN֐
 param		Ȃ
 return 	Ȃ
 */
void display(){
	render->ClearBuffer();
	render->DrawScene(scene);
	render->EndScene();
	glutSwapBuffers();
}

/**
 brief		̐ݒ
 param	 	Ȃ
 return 	Ȃ
 */
void setLight() {
	GRLightDesc light0, light1;
	light0.position = Vec4f(10.0, 20.0, 20.0, 1.0);
	light1.position = Vec4f(-10.0, 10.0, 10.0, 1.0);
	render->PushLight(light0);
	render->PushLight(light1);
}
/**
 brief		glutReshapeFuncŎw肵R[obN֐
 param		<in/--> w@@
 param		<in/--> h@@
 return		 Ȃ
 */
void reshape(int w, int h){
	// ViewportƎˉesݒ
	render->Reshape(Vec2f(), Vec2f(w,h));
}
/**
 brief 		glutKeyboardFuncŎw肵R[obN֐ 
 param		<in/--> key@@ ASCIIR[h
 param 		<in/--> x@@@ L[ꂽ̃}EXW
 param 		<in/--> y@@@ L[ꂽ̃}EXW
 return 	Ȃ
 */
void keyboard(unsigned char key, int x, int y){
	if (key == ESC) exit(0);
}	
/**
 brief  	glutIdleFuncŎw肵R[obN֐
 param	 	Ȃ
 return 	Ȃ
 */
void idle(){
	scene->Step();
	glutPostRedisplay();
	static int count;
	count++;
	if (++count > EXIT_TIMER) exit(0);
}
/**
 brief		C֐
 param		<in/--> argc@@R}hC͂̌
 param		<in/--> argv@@R}hC
 return		0 (I)
 */
int main(int argc, char* argv[]){
	phSdk = PHSdkIf::CreateSdk();					// SDK̍쐬@
	PHSceneDesc sd;
	sd.timeStep = 0.05;
	scene = phSdk->CreateScene(sd);				// V[̍쐬
	PHSolidDesc desc;
	desc.mass = 2.0;
	desc.inertia *= 2.0;

	// Solid̍쐬
	unsigned int sphereCnt;
	for (sphereCnt=0; sphereCnt<NUM_SPHERES; ++sphereCnt){
		soSphere.push_back(scene->CreateSolid(desc));		// ̂descɊÂč쐬
	}

	desc.mass = 1e20f;
	desc.inertia *= 1e20f;
	soFloor = scene->CreateSolid(desc);		// ̂descɊÂč쐬
	soFloor->SetGravity(false);

	//	`̍쐬
	CDBoxIf* floor=NULL;
	CDSphereIf* sphere=NULL;
	{
		CDSphereDesc sd;
		sphere = DCAST(CDSphereIf, phSdk->CreateShape(sd));

		CDBoxDesc bd;
		bd.boxsize = Vec3f (30.0, 1.0, 30.0);
		floor = DCAST(CDBoxIf, phSdk->CreateShape(bd));
	}	

	soFloor->AddShape(floor);
	soFloor->SetFramePosition(Vec3f(0,-3,0));
	for (sphereCnt=0; sphereCnt<NUM_SPHERES; ++sphereCnt){
		soSphere[sphereCnt]->AddShape(sphere);
		soSphere[sphereCnt]->SetFramePosition(Vec3f(0, 15+5*sphereCnt, 0));
	}
	scene->SetGravity(Vec3f(0,-9.8f, 0));	// d͂ݒ

	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH);
	glutInitWindowSize(WINSIZE_WIDTH, WINSIZE_HEIGHT);
	int window = glutCreateWindow("GRSimple");
	grSdk = GRSdkIf::CreateSdk();
	render = grSdk->CreateDebugRender();
	grDevice = grSdk->CreateDeviceGL();

	// ݒ
	grDevice->Init();

	glutDisplayFunc(display);
	glutReshapeFunc(reshape);
	glutKeyboardFunc(keyboard);
	glutIdleFunc(idle);
	
	render->SetDevice(grDevice);	// foCX̐ݒ

	// _ݒ肷
	Affinef view;
	view.Pos() = Vec3f(0.0, 15.0, 15.0);								// eye
	view.LookAtGL(Vec3f(0.0, 0.0, 0.0), Vec3f(0.0, 1.0, 0.0));			// center, up 
	view = view.inv();	
	render->SetViewMatrix(view);
	
	
	setLight();

	glutMainLoop();
}
