/*
 *  Copyright (c) 2003-2006, Shoichi Hasegawa and Springhead development team 
 *  All rights reserved.
 *  This software is free software. You can freely use, distribute and modify this 
 *  software. Please deal with this software under one of the following licenses: 
 *  This license itself, Boost Software License, The MIT License, The BSD License.   
 */
/** 
 Springhead2/src/tests/Physics/PHShape/main.cpp

yTvz
  SolidɌ`eXgvOiʒuóAʂ̒_Wój
  EyieB@ɂʑʑ̓m̐ڐGƐڐG͂mFB
  ÊRȀ2̃ubNςݏグ邱Ƃz肷B 
  E_WfobOo͂A_O͍sȂB
  
yIz
  EvOI0ԂB
 
y̗z
  EV~[VɕKvȏ(̂̌`EʁEe\Ȃ)ݒ肷B
  @̂̌`OpenGLŎw肷̂ł͂ȂASolid̂ŎB  
  E^ꂽɂ臙tb̈ʒu̕ω2XebvϕAʒuo͂B
@E_O͍s킸AfobOo͂Ƃđʑ̖̂(Op`)̒_Wo͂B
     
 */
#include <Springhead.h>		//	Springhead̃C^tF[X
#ifdef USE_HDRSTOP
#pragma hdrstop
#endif
using namespace Spr;

UTRef<PHSdkIf> sdk;
PHSceneIf* scene;
PHSolidIf* solid1, *solid2;

/**
 brief		C֐
 param		<in/--> argc@@R}hC͂̌
 param		<in/--> argv@@R}hC
 return	0 (I)
 */
int main(int argc, char* argv[]){
	sdk = PHSdkIf::CreateSdk();				//	SDK̍쐬
	scene = sdk->CreateScene();			//	V[̍쐬
	PHSolidDesc desc;
	desc.mass = 2.0;
	desc.inertia *= 2.0;
	solid2 = scene->CreateSolid(desc);	//	̂descɊÂč쐬

	desc.mass = 1e20f;
	desc.inertia *= 1e20f;
	solid1 = scene->CreateSolid(desc);	//	̂descɊÂč쐬
	solid1->SetGravity(false);
	
	//	`̍쐬
	CDConvexMeshDesc md;
	md.vertices.push_back(Vec3f(-1,-1,-1));
	md.vertices.push_back(Vec3f(-1,-1, 1));
	md.vertices.push_back(Vec3f(-1, 1,-1));
	md.vertices.push_back(Vec3f(-1, 1, 1));
	md.vertices.push_back(Vec3f( 1,-1,-1));
	md.vertices.push_back(Vec3f( 1,-1, 1));
	md.vertices.push_back(Vec3f( 1, 1,-1));
	md.vertices.push_back(Vec3f( 1, 1, 1));
	CDConvexMeshIf* mesh2 = DCAST(CDConvexMeshIf, sdk->CreateShape(md));

	for(unsigned i=0; i<md.vertices.size(); ++i){
		md.vertices[i].x *= 10;
	}
	CDConvexMeshIf* mesh1 = DCAST(CDConvexMeshIf, sdk->CreateShape(md));

	solid1->AddShape(mesh1);
	solid2->AddShape(mesh2);
	solid1->SetFramePosition(Vec3f(0,-1,0));
	solid2->SetFramePosition(Vec3f(0,2,0));

	scene->SetGravity(Vec3f(0,-9.8f, 0));	// d͂ݒ

	for(int i=0; i<2; ++i){
		scene->Step();
		std::cout << solid1->GetFramePosition();
		std::cout << solid2->GetFramePosition() << std::endl;
		// std::cout << solid1->GetOrientation() << std::endl;
	}
	
	// fobOo
	DSTR << "***  solid1  ***\n";
	for(int i=0; i<solid1->NShape();++i){
		CDShapeIf* shape = solid1->GetShape(i);
		CDConvexMeshIf* mesh = DCAST(CDConvexMeshIf, shape);
		Vec3f* base = mesh->GetVertices();
		for(size_t f=0; f<mesh->NFace();++f){
			CDFaceIf* face = mesh->GetFace(f);
			for(int v=0; v<face->NIndex(); ++v){
				DSTR << base[face->GetIndices()[v]];
			}
			DSTR << std::endl;
		}
	}
	DSTR << "***  solid2  ***\n";
	for(int i=0; i<solid2->NShape();++i){
		CDShapeIf* shape = solid2->GetShape(i);
		CDConvexMeshIf* mesh = DCAST(CDConvexMeshIf, shape);
		Vec3f* base = mesh->GetVertices();
		for(size_t f=0; f<mesh->NFace();++f){
			CDFaceIf* face = mesh->GetFace(f);
			for(int v=0; v<face->NIndex(); ++v){
				DSTR << base[face->GetIndices()[v]];
			}
			DSTR << std::endl;
		}
	}
}
