/*
 *  Copyright (c) 2003-2006, Shoichi Hasegawa and Springhead development team 
 *  All rights reserved.
 *  This software is free software. You can freely use, distribute and modify this 
 *  software. Please deal with this software under one of the following licenses: 
 *  This license itself, Boost Software License, The MIT License, The BSD License.   
 */
/** 
 Springhead2/src/tests/Physics/PHSimpleGL/main.cpp
 
yTvz
  2̍̂̈ʒu̕ωmFeXgvOiʒuóAGL\j
  Ể^mFB
  Eʒuo͂AOpenGLŃV~[VsB
 
yIz
  EԂeB[|bgƐeB[|bg10b̈ʒuꂼvZҒlƂB
  @̊ҒlƃV~[VʂrāAv琳I(success)ƂB
  
y̗z
  EV~[VɕKvȏ(ʁEdSEe\Ȃ)ݒ肷B
    ̂̌`OpenGLŃeB[|bgw肷B
  EV~[Vn߂ALō̂ɗ͂B
      ̐ԂeB[|bgFIuWFNg̃[JWn_ƂAdS1mE1N̗͂B
      E̐eB[|bgFIuWFNg̃[JWň_1mEɏdS炵AdS1mE1N̗͂B
  E^ꂽɂ臙tb̈ʒu̕ωϕÂ̈ʒuo͂ƁAOpenGL_OsB
   
 */
#include <Springhead.h>		//	Springhead̃C^tF[X
#include <ctime>
#include <GL/glut.h>
#ifdef USE_HDRSTOP
#pragma hdrstop
#endif
using namespace Spr;

#define ESC		27

UTRef<PHSdkIf> sdk;
PHSceneIf* scene;
PHSolidIf* redTeapot, *blueTeapot;	// Solid^Cv
// ̐ݒ 
static GLfloat light_position[] = { 15.0, 30.0, 20.0, 1.0 };
static GLfloat light_ambient[]  = { 0.0, 0.0, 0.0, 1.0 };
static GLfloat light_diffuse[]  = { 1.0, 1.0, 1.0, 1.0 }; 
static GLfloat light_specular[] = { 1.0, 1.0, 1.0, 1.0 };
// ގ̐ݒ
static GLfloat mat_red[]        = { 1.0, 0.0, 0.0, 1.0 };
static GLfloat mat_blue[]       = { 0.0, 0.0, 1.0, 1.0 };
static GLfloat mat_specular[]   = { 1.0, 1.0, 1.0, 1.0 };
static GLfloat mat_shininess[]  = { 120.0 };

static double stepCnt = 0.0;
namespace {
	Vec3d redVel = Vec3d(0.0, 0.0, 0.0);	// x
	Vec3d redPos = Vec3d(0.0, 0.0, 0.0);	// ʒu
	Vec3d blueVel = Vec3d(0.0, 0.0, 0.0);				
	Vec3d bluePos = Vec3d(0.0, 0.0, 0.0);				
}

/**
 brief     	glutDisplayFuncŎw肵R[obN֐
 param	 	Ȃ
 return 	Ȃ
 */
void SPR_CDECL display(){

	glClear(GL_DEPTH_BUFFER_BIT | GL_COLOR_BUFFER_BIT);

	glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular);
	glMaterialfv(GL_FRONT, GL_SHININESS, mat_shininess);

	// ̐ԂeB[|bg
	glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, mat_red);

	Affined ad;
	glPushMatrix();
	Posed pose = redTeapot->GetPose();
	pose.ToAffine(ad);
	//	redTeapot->GetOrientation().to_matrix(af);
	//	af.Pos() = redTeapot->GetFramePosition();
	// poseł͐xdoubleȂ̂matrixdɂ
	glMultMatrixd(ad);
	glutSolidTeapot(1.0);
	glPopMatrix();

	// E̐eB[|bg
	glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, mat_blue);

	glPushMatrix();
	pose = blueTeapot->GetPose();
	ad = Affined(pose);
	glMultMatrixd(ad);
	glutSolidTeapot(1.0);
	glPopMatrix();

	glutSwapBuffers();
}

/**
 brief     	̐ݒ
 param	 	Ȃ
 return 	Ȃ
 */
void setLight() {
	glEnable(GL_LIGHTING);
	glLightfv(GL_LIGHT0, GL_POSITION, light_position);
	glLightfv(GL_LIGHT0, GL_AMBIENT, light_ambient);
	glLightfv(GL_LIGHT0, GL_DIFFUSE, light_diffuse);
	glLightfv(GL_LIGHT0, GL_SPECULAR, light_specular);
	glEnable(GL_LIGHT0);
}

/**
 brief     	
 param	 	Ȃ
 return 	Ȃ
 */
void initialize(){
	glClearColor(0.0, 0.0, 0.0, 1.0);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	gluLookAt(4.0, 3.0, 10.0, 
		      4.0, 0.0, 0.0,
		 	  0.0, 1.0, 0.0);

	glEnable(GL_DEPTH_TEST);
	glEnable(GL_NORMALIZE);
	setLight();
}

/**
 brief  	glutReshapeFuncŎw肵R[obN֐
 param	 	<in/--> w@@
 param  	<in/--> h@@
 return 	Ȃ
 */
void SPR_CDECL reshape(int w, int h){
	glViewport(0, 0, w, h);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(60.0, (double)(w/h), 1.0, 500);
	glMatrixMode(GL_MODELVIEW);
}

/**
 brief 		glutKeyboardFuncŎw肵R[obN֐ 
 param		<in/--> key@@ ASCIIR[h
 param 		<in/--> x@@@ L[ꂽ̃}EXW
 param 		<in/--> y@@@ L[ꂽ̃}EXW
 return 	Ȃ
 */
void SPR_CDECL keyboard(unsigned char key, int x, int y){
	if (key == ESC) exit(0);
}

/**
 brief  	glutIdleFuncŎw肵R[obN֐
 param	 	Ȃ
 return 	Ȃ
 */
void SPR_CDECL idle(){
	//	̂̏dS1mEɉD
	Vec3d force = Vec3d(1, 0, 0);
	redTeapot->AddForce( force, Vec3f(0,1,0)+redTeapot->GetCenterPosition());
	blueTeapot->AddForce( force, Vec3f(0,1,0)+blueTeapot->GetCenterPosition());

	scene->Step();
	stepCnt += scene->GetTimeStep();	// [msec]
	double dt = scene->GetTimeStep();

	// x𓱂AԌoߌ̈ʒuvZiҒl)
	redVel		+= force * redTeapot->GetMassInv() * dt;	// (force/m)*dt
	redPos		+= redVel * dt;
	blueVel		+= force * blueTeapot->GetMassInv() * dt;	// (force/m)*dt
	bluePos		+= blueVel * dt;

	std::cout << redTeapot->GetCenterPosition() << blueTeapot->GetCenterPosition() << std::endl;
	
	// 10secɃV~[VʂƊҒlr
	if (stepCnt >= 10.0) {	
		bool redApprox, blueApprox;
		redApprox	= approx(redPos, redTeapot->GetFramePosition());
		blueApprox	= approx(bluePos, blueTeapot->GetFramePosition());

		if (redApprox && blueApprox) {	// V~[Vʂ͐ʂƂȂ܂B
			DSTR << "\nPHSimpleGL success (redTeapot:success, blueTeapot:success)" << std::endl;
			exit(EXIT_SUCCESS);
		} else if (redApprox) {			// ԂeB[|bg͐ʂ܂AeB[|bg͐ʂ܂łB
			DSTR << "\nPHSimpleGL failure (redTeapot:success, blueTeapot:failure)" << std::endl;
			exit(EXIT_FAILURE);
		} else if (blueApprox) {		// eB[|bg͐ʂ܂AԂeB[|bg͐ʂ܂łB		
			DSTR << "\nPHSimpleGL failure (redTeapot:failure, blueTeapot:success)" << std::endl;
			exit(EXIT_FAILURE);
		} else {						// eB[|bgƐԂeB[|bg͂Ƃɐʂ܂łB
			DSTR << "\nPHSimpleGL failure (redTeapot:failure, blueTeapot:failure)" << std::endl;
			exit(EXIT_FAILURE);
		}
	} 
	
	glutPostRedisplay();
}

/**
 brief		C֐
 param		<in/--> argc@@R}hC͂̌
 param		<in/--> argv@@R}hC
 return		0 (I)
 */
int SPR_CDECL main(int argc, char* argv[]){
	sdk = PHSdkIf::CreateSdk();					//	SDK̍쐬
	scene = sdk->CreateScene();				//	V[̍쐬
	
	PHSolidDesc desc;						// teapot
	desc.mass = 2.0;						// 	
	desc.inertia *=2.0;						// e\
	desc.center = Vec3f(0,0,0);				// ʒS̈ʒu
	redTeapot = scene->CreateSolid(desc);	// ̂descɊÂč쐬
	redTeapot->SetGravity(false);			// d͂𖳌ɂ
	redPos = redTeapot->GetFramePosition();

	desc.center = Vec3f(1,0,0);			//	dS̈ʒuSoliď_1mEɂ炷D
	desc.pose.Pos() = Vec3f(3.5, 0.0, 0.0);
	//desc.pose = desc.pose * Posed::Trn(0.0, 0.0, 3.0);	// Oɕsړ	
	Vec3d trn = Vec3d(0.0, 0.0, 3.0);
	desc.pose = desc.pose * Posed::Trn(trn);				// Oɕsړ
	blueTeapot = scene->CreateSolid(desc);	
	blueTeapot->SetGravity(false);
	bluePos = blueTeapot->GetFramePosition();

	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH);
	glutCreateWindow("PHSimpleGL");

	initialize();

	glutDisplayFunc(display);
	glutReshapeFunc(reshape);
	glutKeyboardFunc(keyboard);
	glutIdleFunc(idle);

	glutMainLoop();
	
	return 0;
}

